A NOTE ON THE CHANGELOG:
Starting in early 2011, Tk source code has been under the management of
fossil, hosted at http://core.tcl.tk/tk/ .  Fossil presents a "Timeline"
view of changes made that is superior in every way to a hand edited log file.
Because of this, many Tcl developers are now out of the habit of maintaining
this log file.  You may still find useful things in it, but the Timeline is
a better first place to look now.
============================================================================

2013-08-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.15 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

2013-08-25   Kevin Walzer <wordtech@users.sourceforge.net>

	* macosx/tkMacOSXButton.c:  Bug [3016181]: Crash after scrollbar
	* macosx/tkMacOSXMenu.c:	destroyed, Tk Cocoa.
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXWm.c:

2012-08-15  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/progress.tcl: Bug [c597acdab3]: Call [$pb step]
	in tail position in ttk::progressbar::Autoincrement, so that
	the widget is in a consistent state when any write traces on
	the linked -variable are fired. 

2013-07-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:  Bug [32afa6e256]: dirent64 check is incorrect in tcl.m4
	* unix/configure: (thanks to Brian Griffin)

2012-06-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/ttk/scale.tcl: [Bug 2501278]: ttk::scale keyboard binding
	problem.

2012-06-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 1913750]: tk_chooseDirectory -initialdir
	internationalization problem.
	[Bug 3500545]: tk_getOpenFile -multiple 1 wrong	on windows.
	[Bug 3416492]: Crash in open/save file dialog in Windows 7 libraries.
	[Bug 3095112]: crash when selecting file from Win7 Library.
	(All of those backported from Tk 8.6)

2013-06-05  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/ttk/ttkScroll.c: [Bug 3613759]: ttk::entry and symbolic
	index names.
	* generic/ttk/ttkEntry.c: [Bug 2100430]: ttk::entry widget index
	must be integer
	* generic/tkEntry.c: Don't set interp result when it will be
	overwritten later.

2013-05-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:     Fix for FreeBSD, and remove support for older
	* unix/configure:  FreeBSD versions. Patch by Pietro Cerutti.

2013-04-10  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/makefile.vc: [Bug 3568760]: Tk documentation fails to build

2013-04-01  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.14 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.14 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* generic/tkInt.h:	[Bug 3607830] Runtime checks that Xkb is
	* unix/tkUnixEvent.c:	available in the X server before trying to
	* unix/tkUnixKey.c:	use.  Adapted from patch from Brian Griffin.

2013-03-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/button.tcl:    [Bug 3608074]: Add <<Invoke>> bindings to
	* library/listbox.tcl:   Button's, Listbox and Menu.
	* library/menu.tcl:
	* doc/event.n:           Document <<Invoke>>, <<ThemeChanged>>,
	* doc/ttk_panedwindow.n: <<EnteredChild>> (ttk_pandedwindow only) and
	* doc/ttk_spinbox.n:     <<Increment/Decrement>> (ttk_spinbox only)

2013-03-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4: Patch by Andrew Shadura, providing better support for
	three architectures they have in Debian.

2013-03-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkListbox.c:	[Bug 3607326] Stop segfault from
	* tests/listbox.test:	[listbox .l -listvariable $array].

2013-02-28  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixKey.c (TkpGetKeySym): [Bug 3599312]: Put the
	initialization of the key mapping before the input method handling so
	that Alt key handling is correct on non-OSX Unix. Thanks to Colin
	McDonald for developing the fix.

2013-01-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/Makefile.in:  Don't compile Tk with -DTCL_NO_DEPRECATED by
	* unix/Makefile.in: default any more, it might hurt when we compile Tk
	8.x against Tcl 8.y with y > x, because new deprecated constructs
	might be added in higher Tcl versions (except for Tk 8.6, for now,
	because there is no higher 8.x yet).

2013-01-14  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4:	 More flexible search for win32 tclConfig.sh,
	* win/configure: backported from TEA.

2012-12-03  François Vogel  <fvogelnew1@free.fr>

	* generic/tkTextIndex.c: [Bug 3588824]: bug in image index handling
	* tests/textIndex.test:  for weird image names

2012-11-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinTest.c: [Bug 3585396]: winDialog.test requires user
	* tests/winDialog.test: interaction. Renumber test-cases as in Tk 8.6,
	and convert various to tcltest-2 style.

2012-11-09  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.13 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.13 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

2012-11-07  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkFocus.c (TkSetFocusWin): [Bug 3574708]: Move window
	liveness into this function from caller sites to ensure that there are
	no paths where things can trip up on setting the focus to a partially
	dead window.

2012-10-24  Don Porter  <dgp@users.sourceforge.net>

	* macosx/tkMacOSXWm.c:	[Bug 3574893] Add overlooked toplevel ref
	count maintenance in the [wm manage|forget] operations that could
	cause segfaults due to premature free of structs.

2012-10-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkButton.h: Backport of ::tk::mac::useCompatibilityMetrics
	* generic/tkButton.c  handling and scrollbar metrics handling from trunk.
	* generic/tkScrollbar.h
	* generic/tkScrollbar.c
	* macosx/tkMacOSXButton.c
	* macosx/tkMacOSXScrlbr.c
	* unix/tkUnixPort.h
	* win/tkWinButton.c
	* win/tkWinScrlbr.c

2012-10-09  Andreas Kupries  <andreask@activestate.com>

	Cherrypick Merge, Backport of [6223d9e067]. Restored from
	tk-cocoa-8-5-bacport-branch, did not survive the merge.
	See trunk 2012-05-29 Donal K. Fellows

	* generic/tkInt.decls (TkMacOSXDrawable): Added OSX-specific mechanism
	to allow retrieval of the drawing surface. Allows Canvas3d to be
	adapted to 8.6.

2012-09-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkInt.h:     Add 8 colors to the supported color list
	* generic/tkColor.c:   (aqua, crimson, fuchsia, indigo, lime,
	* unix/tkUnixColor.c:  olive, silver and teal), part of TIP #403
	* xlib/rgb.txt
	* xlib/xcolors.c

2012-09-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/Makefile.in:    Compile win32 binaries with -DTCL_NO_DEPRECATED

2012-09-25   Kevin Walzer <wordtech@users.sourceforge.net>

	* macosx/*: Merge Tk-Cocoa backport into core-8-5-branch

2012-09-13  Donal K. Fellows  <dkf@users.sf.net>

	* generic/ttk/ttkEntry.c (EntryDisplay): [Bug 3567453]: Clip regions
	* generic/ttk/ttkLabel.c (TextDraw): must be cleared with XSetClipMask
	* xlib/xgc.c (TkSetRegion): and not TkSetRegion, or crashes will ensue
	on X11-based builds, which can't handle None for a region argument.
	Added a clean panic to the non-X11 TkSetRegion to catch this case and
	stop such confusion from happening again.

2012-09-11  Donal K. Fellows  <dkf@users.sf.net>

	* generic/ttk/ttkEntry.c (EntryDisplay): [Bug 3566594]: Must manually
	* generic/ttk/ttkLabel.c (TextDraw):     reset the clip region of GCs
	when not using the Xft font renderer (well, especially on classic X11)
	because the GC sharing code doesn't take into account clip handling.
	Thanks to Christian Nassau for identifying the problem.

2012-08-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkMenuDraw.c: [Bug 3562426]: Context menu goes out of edge of
	screen.

2012-08-24  Donal K. Fellows  <dkf@users.sf.net>

	* library/tkfbox.tcl (GlobFiltered): [Bug 3558535]: Factor out the
	filtered-sorted globbing code into one procedure that knows how to
	avoid nasty problems when non-list filters are used. This allows the
	rest of the [tk_getOpenFile] implementation to be ignorant of the
	considerable complexities of globbing.

2012-08-23  Don Porter  <dgp@users.sourceforge.net>

	* unix/tkUnixWm.c: [Bugs 3554026,3561016]: Stop crash with tearoff
	menus.

2012-08-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/nmakehlp.c: Add "-V<num>" option, in order to be able
	to detect partial version numbers.

2012-08-15  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/buildall.vc.bat: Only build the threaded builds by default
	* win/rules.vc:        Backport some improvements from Tcl 8.6
	* win/makefile.vc:

2012-08-11  François Vogel  <fvogelnew1@free.fr>

	* generic/tkTextTag.c:  [Bug 3554273]: Test textDisp-32.2 failed

2012-08-09  Stuart Cassoff  <stwo@users.sourceforge.net>

	* generic/tkEvent.c:	Remove useless (void *) casts
	* unix/tkUnixEvent.c:	introduced in checkin [b7a58eae61].
	* unix/tkUnixKey.c:	The warnings were false flags from a
	* unix/tkUnixRFont.c:	faulty OpenBSD C compiler.

2012-08-03  François Vogel  <fvogelnew1@free.fr>

	* tests/bind.test:  [Bug 3554081]: Test bind-22.10 failed

2012-08-02  François Vogel  <fvogelnew1@free.fr>

	* tests/spinbox.test:  [Bug 3553311]: Test spinbox-3.70 failed

2012-07-31  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixKey.c (TkpSetKeycodeAndState, TkpInitKeymapInfo)
	(TkpGetKeySym): [Bug 3551802]: Convert from XKeycodeToKeysym to
	XkbKeycodeToKeysym to fix deprecation warning.

2012-07-31  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/nmakehlp.c: Backport from Tcl 8.6, but add -Q option from
	sampleextension.

2012-07-17  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.12 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.12 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updated for 8.5.12 release.

2012-07-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/makefile.vc: [Bug 3544932]: Visual studio compiler check fails

2012-07-08  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkIntXlibDecls.h: [Bug 3541305]: Xfree/Xsync...
	should not be macros

2012-07-05  Donal K. Fellows  <dkf@users.sf.net>

	* doc/wm.n (geometry): [Bug 3538401]: Better description of the key
	difference between [wm geometry] and [winfo geometry]; the former
	represents the window manager's understanding, not Tk's.

2012-07-04  Donal K. Fellows  <dkf@users.sf.net>

	* win/tkWinDialog.c (GetFileNameW): [Bug 3540127]: Clean up the tables
	of options for the file dialogs so that options are listed in error
	messages in alphabetical order.

2012-07-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 3540127]: filebox.test fails on win32

2012-06-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/configure.in:  Link cygwin wish.exe with win32 tk.dll, only
	* unix/Makefile.in:   in combination with --enable-shared.
	* unix/tcl.m4:
	* unix/configure:     autoconf-2.59

2012-06-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/Makefile.in:    [Bug 1844430]: cygwin make fails in 8.4.14-8.5b3
	* unix/tcl.m4:        Sync with Tcl version.
	* unix/configure:     autoconf-2.59

2012-06-15  Donal K. Fellows  <dkf@users.sf.net>

	* generic/ttk/ttkTreeview.c (unshareObj): [Bug 3535362]: Changed name
	of 'unshare' internal function to avoid clash with some libc versions.

2012-06-12  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixRFont.c (Tk_DrawChars, TkUnixSetXftClipRegion): Add some
	* generic/ttk/ttkEntry.c (EntryDisplay): special magic to make the
	* generic/ttk/ttkLabel.c (TextDraw): text clipping work right with the
	Xft-based renderer (which doesn't use the standard Tk GC except to
	supply the color).

2012-06-11  Donal K. Fellows  <dkf@users.sf.net>

	* generic/ttk/ttkLabel.c (TextDraw): [Bug 3294450]: Get the clipping
	* generic/ttk/ttkEntry.c (EntryDisplay): of text in Ttk various text
	elements (e.g., buttons, entries, etc.) correct. Stops a whole range
	of visual problems, including loss of the second and subsequent lines
	of a label when the first line doesn't entirely fit, and failing to
	draw the last character of an entry at all if it doesn't all exactly
	fit in the space available (a problem I've noticed in tkchat, and been
	very frustrated with).

2012-06-10  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/*.tcl:      [Bug 3534137]: $tcl_platform(platform) !=
	[tk windowingsystem]

2012-06-08  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkMain.c:   Implement TkCygwinMainEx for loading
	* generic/tkWindow.c: Cygwin's Tk_MainEx from the Tk dll.

2012-06-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkInt.decls:   Change XChangeWindowAttributes signature and
	* generic/tkIntXlibDeclsDecls.h: many others to match Xorg, needed for
	Cygwin.

2012-06-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/Makefile.in:      [Bug 3532186] pkgIndex.tcl file complexity
	* win/Makefile.in:

2012-06-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkInt.decls:   Change XSetDashes signature and many others
	* generic/tkIntDecls.h:  to match Xorg, needed for Cygwin.
	* generic/tkIntXlibDeclsDecls.h
	* win/Makefile.in:       Generate same pkgIndex.tcl file for win32 and
	* unix/Makefile.in:      cygwin, one that is equally useable for both.

2012-05-30  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkWindow.c:	Simplify determination whether we are running
	* generic/tkStubInit.c:	on cygwin.  Export Tk_GetHINSTANCE,
	* generic/tkInt.decls:	TkSetPixmapColormap and TkpPrintWindowId on the
	Cygwin dll, sync stub table with Tk 8.6 win32 version.
	* generic/tk*Decls.h:    re-generated
	* win/Makefile.in:       "make genstubs" when cross-compiling on UNIX

2012-05-28  François Vogel  <fvogelnew1@free.fr>

	* doc/text.n:  [Bug 1630251]: Doc for -endline option was wrong

2012-05-28  François Vogel  <fvogelnew1@free.fr>

	* generic/tkTextDisp.c: [Bug 1630254]: missing scrolling of text widget
	when from a -startline == -endline initial state it is configured to
	display a non-empty part of it

2012-05-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/stubs.c:          Change XSetCommand signature to match Xorg,
	* win/tkWinWm.c:        needed for Cygwin.
	* generic/tkInt.decls
	* generic/tk*Decls.h:   re-generated

2012-05-09  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinWm.c:           Change TkpWmSetState signature to match Xorg,
	* generic/tkInt.decls:     needed for Cygwin. (not needed for Mac)
	* generic/tkIntPlatDeclsDecls.h:
	* generic/tkWindow.c:      Don't check for cygwin in win32 static build.
	* unix/tkUnixPort.h:       Some more useful #defines for Cygwin

2012-05-05  Jan Nijtmans  <nijtmans@users.sf.net>

	* xlib/xcolors.c:      Single "const" addition
	* generic/tkWindow.c:  If tk.dll loaded in cygwin, don't use the
	win32 file dialogs

2012-05-04  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/menu.tcl: [Bug 2768586]: Menu posting on dual monitors

2012-05-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/tk.tcl: [Bug 533519]: Window placement with multiple screens
	* generic/tkBind.c:
	* generic/tkFocus.c:
	* generic/tkMenuDraw.c:
	* generic/tkWinWm.c:

2012-04-26  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkStubInit.c (Tk_GetHINSTANCE): Ensure that this is defined
	for OSX.

2012-04-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tk.decls:	[Bug 3508771]: Implement TkClipBox, Tk*Region
	* generic/tkInt.decls:	and Tk_GetHINSTANCE for Cygwin
	* generic/tkPlatDecls.h:
	* generic/tkintDecls.h:
	* generic/tkStubInit.c:
	* unix/Makefile.in:   [Bug 3519917]: Snow Leopard unix/Makefile
	`make test` fail

2012-04-22  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkBind.c (ExpandPercents): [Bug 3520202]: Ensure that the
	%k, %K and %N substitutions use dummy tokens with <MouseWheel> events
	and that the %D subsitution is a dummy with <Key>/<KeyRelease>. This
	was causing significant indigestion (and a read of goodness knows what
	memory) to Tkinter/Python because of the way they map events between
	languages.

2012-04-20  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tk.tcl: Use vroot size in stead of screen size for
	clipping window coordinates in ::tk::PlaceWindow.
	* generic/dialog.tcl: Use ::tk::PlaceWindow in dialog.tcl, in
	stead of dumplicating the code there.
	(harmless part of [Bug 533519])

2012-04-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/rules.vc: [Bug 3517448] TclKit build fails (unresolved
	__strtoi64)

2012-04-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkBind.c: [Bug 3176239] control-MouseWheel causes segv

2012-03-30  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:        [Bug 3511806] Compiler checks too early
	* unix/configure.in:  This change allows to build the cygwin
	* unix/configure      and mingw32 ports of Tcl/Tk to build
	* win/tcl.m4:         out-of-the-box using a native or cross-
	* win/configure.in:   compiler.
	* win/configure

2012-03-21  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkColor.c:  [Bug 2809525] Abort on overlong color name.
	* unix/tkUnixColor.c:

2012-03-18  Jan Nijtmans  <nijtmans@users.sf.net>

	* xlib/xcolors.c:   [RFE 3503317]: XParseColor speedup
	* xlib/rgb.txt:     List of all colors accepted by Tk in Xorg format
	* tests/color.test: Added test case for all colors in rgb.txt

2012-03-07  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkObj.c (GetPixelsFromObjEx): [Bug 3497848]: Better rounding
	of pixel values to integers.

2012-03-04  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:    Patch from the cygwin folks
	* unix/configure: (re-generated)

2012-02-28  François Vogel  <fvogelnew1@free.fr>

	* generic/tkText.c:      [Bug 1630262, Bug 1615425]: segfault
	* generic/tkTextBTree.c  when deleting lines or tagging outside of
	* generic/tkTextDisp.c   the -startline/-endline range with peer
	* generic/tkTextMark.c   text widgets.
	* tests/text.test        [Bug 3487407]: Weird text indices.
	* tests/textMark.test

2012-02-28  Donal K. Fellows  <dkf@users.sf.net>

	* doc/canvas.n: [Bug 3495198]: Corrected types of bitmap options.

2012-02-26  Jan Nijtmans  <nijtmans@users.sf.net>

	* xlib/xcolors.c: Provide fallback for _strtoi64
	* win/configure.in: Detect whether _strtoi64 is available
	* win/configure: (regenerated)

2012-02-15  Jan Nijtmans  <nijtmans@users.sf.net>

	* xlib/xcolors.c: [Bug 3486474]: Inconsistent color scaling
	* generic/tkColor.c: new internal function TkParseColor
	* generic/tkInt.h:
	* generic/tk*.c:   Change XParseColor() to TkParseColor() everywhere.

2012-02-10  Donal K. Fellows  <dkf@users.sf.net>

	* win/tkWinDialog.c (GetFileNameW): Ensure that we do not convert a
	result list to a string inadvertently, as this causes problems with
	Tkinter's handling of multiple filename results. Issue was reported
	via StackOverflow: http://stackoverflow.com/q/9227859/301832

2012-01-30  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl: [Bug 2925561] Don't take focus in
	disabled state.

2012-01-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkImgPhoto.c: [Bug 3480634]: PNG Images missing in menus on Mac

2012-01-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 3480471]: tk_getOpenFile crashes on Win64

2012-01-26  François Vogel  <fvogelnew1@free.fr>

	* generic/tkTextDisp.c: [Bug-1754043] and [Bug-2321450]: When
	-blockcursor is true, the cursor appears as a blinking bar which
	expands to the right edge of the widget.

2012-01-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkImgPhoto.c: [Bug 2433260]: non-critical error in
	Tk_PhotoPutBlock

2012-01-25  François Vogel  <fvogelnew1@free.fr>

	* generic/tkText.c: Don't increase the epoch twice

2012-01-25  François Vogel  <fvogelnew1@free.fr>

	* generic/tkText.c:      [Bug-1630271]: segfault/infinite loop
	* generic/tkTextMark.c:  when a mark is before -startline
	* tests/textMark.test:

2012-01-25  François Vogel  <fvogelnew1@free.fr>

	* generic/tkText.c: [Bug-3475627]: Test text-31.11 fails

2012-01-22  François Vogel  <fvogelnew1@free.fr>

	* generic/tkTextMark.c: [Bug-3288113,3288121]: Missing marks/endless
	* tests/textMark.test:  loop in text mark prev/next

2012-01-19  François Vogel  <fvogelnew1@free.fr>

	* generic/tkText.c: [Bug-3021557]: Moving the cursor in
	* tests/text.test:  elided text freezes Tk

2011-12-22  Don Porter  <dgp@users.sourceforge.net>

	* win/tkWinMenu.c: [Bug 3235256] Keep menu entry IDs out of system
	values. Thanks Colin McDonald.

2011-11-22  Jan Nijtmans  <nijtmans@users.sf.net>

	* doc/wish.1: Use the same shebang comment everywhere.
	* library/demos/hello
	* library/demos/rmt
	* library/demos/square
	* library/demos/tcolor
	* library/demos/timer
	* library/demos/widget
	* unix/Makefile.in: [Bug 1945073]: Demo square.tcl
	* win/Makefile.in: cannot run; need package tktest

2011-11-17  Alexandre Ferrieux  <ferrieux@users.sourceforge.net>

	* generic/tkCanvas.c: [Bug 3437816]: Missing TCL_ERROR return
	in [canvas lower].

2011-11-08  Reinhard Max  <max@suse.de>

	* unix/Makefile.in: Add square to DEMOPROGS. It contains a shebang
	and hence should get installed with executable bits.

	* doc/label.n:         Fix the escaping of leading dots in lines that
	* doc/text.n:          start with a widget name, so that nroff
	* doc/ttk_notebook.n:  doesn't mistake it as a non-existing macro
	* doc/pack.n:          and skips the entire line.

2011-11-04  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.11 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.11 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updated for 8.5.11 release.

2011-11-01  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkObj.c (GetPixelsFromObjEx): [Bug 3431491]: Use a bit of
	type hackery to allow numbers to be interpreted as coordinates (most
	notably on a canvas) without reinterpreting via a string.

2011-10-26  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.11.

2011-10-01  Kevin B. Kenny  <kennykb@acm.org>

	* generic/tkInt.h:	[Bug 3410609] Change the event mechanism
	* unix/tkUnixEvent.c:	for <KeyPress> events to use the keysym
	* unix/tkUnixKey.c:	returned by XLookupString in preference to
	the one that appears in the raw X event at any level. This change
	allows binding to ISO_Level3_Shift-ed characters, composed characters,
	and similar beasts. KeyRelease events still work as they did before,
	as does Tk with input methods disabled.

2011-09-01  Donal K. Fellows  <dkf@users.sf.net>

	* doc/photo.n: Correctly documented what the [$ph data] command
	produces without the -format option.

2011-08-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 3388350] mingw64 compiler warnings
	* win/tkWinDraw.c
	* win/tkWinSend.c
	* win/tkWinSendCom.c
	* win/tkWinColor.c
	* win/tkWinDialog.c
	* win/tkWinEmbed.c
	* win/tkWinMenu.c
	* win/tkWinPixmap.c
	* win/tkWinTest.c
	* win/tkWinWindow.c
	* win/tkWinWm.c
	* win/tkWinX.c
	* win/stubs.c
	* generic/tkAtom.c
	* generic/tkSelect.c

2011-08-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkBitmap.c: [Bug 3388350] mingw64 compiler warnings
	* generic/tkConsole.c
	* unix/tkUnixMenubu.c
	* win/tkWinButton.c
	* win/tkWinEmbed.c
	* win/tkWinFont.c
	* win/tkWinImage.c
	* win/tkWinKey.c
	* win/tkWinTest.c
	* win/tkWinWm.c

2011-08-03  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 3314770] regression - Windows file
	dialogs not resizable

2011-07-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* xlib/X11/Xutil.h: [Bug 3380684] XEmptyRegion prototype doesn't
	match usage

2011-06-29  Don Porter  <dgp@users.sourceforge.net>

	* generic/ttk/ttkTrace.c: [Bug 3341056] Correct segfault due to flaw
	* tests/ttk/ttk.test:	in the 2011-06-17 commit.

2011-06-23  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.10 release.

2011-06-17  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.10 TAGGED FOR RELEASE ***

	* generic/ttk/ttkTrace.c:	Workaround Bug 3062331.
	* tests/ttk/ttk.test:
	* changes:	Updated

2011-06-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4: Sync with win/tcl.m4 from Tcl
	* win/configure: (regenerated)

2011-06-10  Don Porter  <dgp@users.sourceforge.net>

	* README:	Correct some README bitrot.
	* macosx/README:

	* generic/tkCanvLine.c: [Bug 3175610] Incomplete refresh of line item.
	Backport of 2011-03-03 trunk commit from Alexandre Ferrieux.

2011-06-08  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.10 release.

2011-06-07  Don Porter  <dgp@users.sourceforge.net>

	* win/tkWinDialog.c:	Backport [Bug 2484771] fix.

	* generic/tkEntry.c:	Restore support for values "08" and "09"
	in a [spinbox] configured to use -from and -to values.  [Bug 2358545].

2011-06-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Restore proper NUL output to the [console].
	[Bug 2546087]

2011-04-22  Peter Spjuth  <peter.spjuth@gmail.com>

	* generic/tkCanvPoly.c: [Bug 3291543] There was a crash if dchars
	* tests/canvas.test:    removed all coordinates of a polygon.

2011-04-21  Peter Spjuth  <peter.spjuth@gmail.com>

	* doc/checkbutton.n: Document all variable options as global.
	* doc/radiobutton.n:
	* doc/listbox.n:
	* doc/menu.n:
	* doc/options.n:
	* doc/ttk_combobox.n:
	* doc/ttk_entry.n:
	* doc/ttk_progressbar.n:
	* doc/ttk_widget.n:

2011-04-04  Peter Spjuth  <peter.spjuth@gmail.com>

	* tests/grid.test:
	* generic/tkGrid.c: [Bug 723765]: When a slave was removed from grid,
	the -in option was not remembered.

2011-04-04  Peter Spjuth  <peter.spjuth@gmail.com>

	* doc/labelframe.n:
	* doc/frame.n:
	* generic/tkFrame.c: [Bug 2997657]: Removed -container from labelframe
	documentation since it does not work as expected and does not make
	sense as a container. Added note to frame about restrictions when used
	as a container.

2011-03-28  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkTextBTree.c:	[Bug 3129527]: Fix buffer overflow
	w/ GCC 4.5 and -D_FORTIFY_SOURCE=2. One more place where this problem
	could appear.

2011-03-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinMenu.c: [Bug #3239768] tk8.4.19 (and later) WIN32
	menu font support.

2011-03-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:    Make SHLIB_LD_LIBS='${LIBS}' the default and
	* unix/configure: set to "" on per-platform necessary basis.
	Backported from TEA, but kept all original platform code which was
	removed from TEA.

2011-03-12  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWin32Dll.c: Eliminate unneeded _TkFinalize wrapper.

2011-03-11  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/ttk/ttkDefaultTheme.c: Eliminate some unneeded write-only
	* generic/ttk/ttkManager.c:      variables (discovered by gcc-4.6)
	* generic/ttk/ttkSquare.c:

2011-03-09  Reinhard Max  <max@suse.de>

	* unix/configure.in: Use a symbol from libXft itself for the link
	test rather than one from libfreetype, because the latter doesn't
	work when the linker is called with --as-needed.

2011-01-25  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkSelect.c:	[Patch #3129527]: Fix buffer overflow
	* win/tkWinWm.c:	w/ GCC 4.5 and -D_FORTIFY_SOURCE=2. Just the
	* unix/tkUnixWm.c:	strcpy->memcpy part, to prevent anything
	like [Bug #3164879]

2011-01-22  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkEntry.c(ttk::combobox): Add missing
	'validate' command (reported by schelte).

2011-01-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/ttk/ttkGenStubs.tcl:	Make sure to use CONST/VOID in stead of
	* generic/ttk/ttkDecls.h: const/void when appropriate. This allows to
	use const/void in the *.decls file always, genStubs will do the right
	thing.

2011-01-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tcl.m4:         handle --enable-64bit=ia64 for gcc. BACKPORT.
	* win/configure:      (autoconf-2.59)

2011-01-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/msgbox.tcl: [Patch #3154705] Close button has no effect

2011-01-06  Stuart Cassoff  <stwo@users.sourceforge.net>

	* generic/tkEvent.c:	Cast some NULLs to (void *) in order to quash
	* unix/tkUnixEvent.c:	"missing sentinel in function call"
	* unix/tkUnixKey.c:	compiler warnings.
	* unix/tkUnixRFont.c:

2010-12-17  Stuart Cassoff  <stwo@users.sourceforge.net>

	* unix/Makefile.in:  [Bug 2446711]: Remove 'allpatch' target.

2010-12-17  Stuart Cassoff  <stwo@users.sourceforge.net>

	* unix/Makefile.in:  Use 'rpmbuild', not 'rpm' [Bug 2537626].

2010-12-13  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:       Cross-compile support for Win and UNIX (backported)
	* unix/configure:    (autoconf-2.59)
	* win/tcl.m4:
	* win/configure.in:
	* win/configure:     (autoconf-2.59)
	* win/tkWin32Dll.c:  SEH-emulation for AMD64
	* win/tkWinX.c:      mingw-w64 does not accept _WIN32_IE < 0x0501

2010-12-12  Stuart Cassoff  <stwo@users.sourceforge.net>

	* unix/tcl.m4: Better building on OpenBSD.
	* unix/configure: (autoconf-2.59)

2010-11-24  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c:	[Bug #3071836]: Crash/Tcl_Panic on WinXP saving
	* win/tkWinInit.c:	file to C:\ re-wrote TkpDisplayWarning such
	that it does not use an Tcl API calls any more, so it works even with
	an ill-initialized Tcl.
	* win/winMain.c:	Teach WishPanic how to thread UTF-8 in it's
	messagebox.  Backports from Tcl 8.6. No change in functionality.

2010-11-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/configure.in:	Allow cross-compilation by default. (backported)
	* win/tcl.m4:		Use -pipe for gcc on win32 (backported)
	* win/configure:	(regenerated)

2010-11-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinPort.h  [Bug #3110161]: Extensions using TCHAR don't compile
	on VS2005 SP1

2010-11-04  Jan Nijtmans  <nijtmans@users.sf.net>

	* library/msgs/de.msg:  Updated German messages.  Thanks to Ruediger
	Haertel. [Patch 2442309] [Bug 3102739].

2010-10-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/rules.vc        Update for VS10

2010-10-11  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c: Fix crash in 'tag add' / 'tag remove'
	commands when no -tags specified [Bug 3085489].

2010-10-06  Donal K. Fellows  <dkf@users.sf.net>

	* win/Makefile.in (genstubs): [Tcl Bug 3082049]: Typo.

2010-09-08  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c (TreeviewSeeCommand): [Bug 2829363]:
	Schedule redisplay if [$tv see] opens any items.

2010-09-02  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/winTheme.tcl, library/ttk/xpTheme.tcl,
	* library/ttk/vistaTheme.tcl: [Bug 3057573]: Specify disabled combobox
	text foreground color.

2010-09-01  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.9 TAGGED FOR RELEASE ***

	* changes:	Updated for 8.5.9 release.

	* doc/menu.n:  Formatting error.

2010-09-01  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/entry.tcl: Revert keyboard navigation bindings
	to use real events instead of virtual events.

2010-08-31  Andreas Kupries  <andreask@activestate.com>

	* win/tcl.m4: Applied patch by Jeff fixing issues with the
	manifest handling on Win64.
	* win/configure: Regenerated.

2010-08-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (DumpLine): [Bug 3053347]:
	s/segPtr->size/currentSize/ throughout, but particularly in if
	lineChanged block where segPtr may no longer be valid.

	* unix/Makefile.in: add valgrind target
	* unix/configure, unix/tcl.m4: [Bug 1230554]: SHLIB_LD_LIBS='${LIBS}'
	for OSF1-V*. Add /usr/lib64 to set of auto-search dirs.
	(SC_PATH_X): Correct syntax error when xincludes not found.

	* win/Makefile.in (VC_MANIFEST_EMBED_DLL VC_MANIFEST_EMBED_EXE):
	* win/configure, win/configure.in, win/tcl.m4: SC_EMBED_MANIFEST
	macro and --enable-embedded-manifest configure arg added to support
	manifest embedding where we know the magic.  Help prevents DLL hell
	with MSVC8+.

2010-08-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/ttk_spinbox.n (new), doc/ttk_*.3, doc/ttk_*.n:
	* generic/ttk/ttkGenStubs.tcl:
	* generic/ttk/ttk.decls, generic/ttk/ttkDecls.h:
	* generic/ttk/ttkButton.c, generic/ttk/ttkCache.c:
	* generic/ttk/ttkClamTheme.c, generic/ttk/ttkClassicTheme.c:
	* generic/ttk/ttkDefaultTheme.c, generic/ttk/ttkElements.c:
	* generic/ttk/ttkEntry.c, generic/ttk/ttkFrame.c:
	* generic/ttk/ttkImage.c, generic/ttk/ttkInit.c:
	* generic/ttk/ttkLabel.c, generic/ttk/ttkLayout.c:
	* generic/ttk/ttkNotebook.c, generic/ttk/ttkPanedwindow.c:
	* generic/ttk/ttkProgress.c, generic/ttk/ttkScale.c:
	* generic/ttk/ttkScroll.c, generic/ttk/ttkScrollbar.c:
	* generic/ttk/ttkSeparator.c, generic/ttk/ttkSquare.c:
	* generic/ttk/ttkState.c, generic/ttk/ttkStubInit.c:
	* generic/ttk/ttkStubLib.c, generic/ttk/ttkTagSet.c:
	* generic/ttk/ttkTheme.c, generic/ttk/ttkTheme.h:
	* generic/ttk/ttkThemeInt.h, generic/ttk/ttkTrace.c:
	* generic/ttk/ttkTrack.c, generic/ttk/ttkTreeview.c:
	* generic/ttk/ttkWidget.c, generic/ttk/ttkWidget.h:
	* library/ttk/spinbox.tcl (new):
	* library/ttk/altTheme.tcl, library/ttk/aquaTheme.tcl:
	* library/ttk/button.tcl, library/ttk/clamTheme.tcl:
	* library/ttk/classicTheme.tcl, library/ttk/combobox.tcl:
	* library/ttk/cursors.tcl, library/ttk/defaults.tcl:
	* library/ttk/entry.tcl, library/ttk/notebook.tcl:
	* library/ttk/panedwindow.tcl, library/ttk/scale.tcl:
	* library/ttk/sizegrip.tcl, library/ttk/treeview.tcl:
	* library/ttk/ttk.tcl, library/ttk/utils.tcl:
	* library/ttk/vistaTheme.tcl, library/ttk/winTheme.tcl:
	* library/ttk/xpTheme.tcl:
	* macosx/ttkMacOSXTheme.c: used 8.6/carbon variant
	* tests/ttk/combobox.test, tests/ttk/treetags.test:
	* tests/ttk/treeview.test, tests/ttk/ttk.test:
	* tests/ttk/vsapi.test:
	* tests/ttk/checkbutton.test (new):
	* tests/ttk/radiobutton.test (new):
	* tests/ttk/spinbox.test (new):
	* win/ttkWinMonitor.c, win/ttkWinTheme.c, win/ttkWinXPTheme.c:
	Major backport of 8.6 Ttk for 8.5.9.  Most changes were only being
	committed to head (8.6), although they could apply for 8.5 as well.
	This re-sync makes future work easier to maintain and adds some
	useful work for 8.5 users. [Bug 3053320]: Notable changes:
	- Lots of code cleanup
	- Some bug fixes never backported
	- Addition of ttk::spinbox
	- minor color changes
	- Improved Vista/7 styling
	- Move to tile version 0.8.6 (pseudo-package)
	- ABI and API compatible (even $w identify)
	- minor new features (extended $w identify)

2010-08-03  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.9 release.

2010-08-20  Donal K. Fellows  <dkf@users.sf.net>

	* doc/listbox.n (SEE ALSO): [Bug 3048809]: Corrected what other page
	was referred to (ttk::treeview can work as a listbox).

2010-08-12  Donal K. Fellows  <dkf@users.sf.net>

	* library/text.tcl (TextCursorInSelection): [Patch 2585265]: Backport
	of factoring-out of decision logic for whether to delete the selected
	text.

2010-08-11  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/Makefile.in (%.${OBJEXT}): better implicit rules support

	* unix/configure: regen with ac-2.59
	* unix/configure.in, unix/Makefile.in:
	* unix/tcl.m4 (AIX): remove the need for ldAIX, replace with
	-bexpall/-brtl.  Remove TK_EXP_FILE (export file) and other baggage
	that went with it.  Remove pre-4 AIX build support.

2010-08-11  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkCanvLine.c (LineDeleteCoords): [Bug 2900121]: Backport of
	fix to sense of test.

2010-08-10  Don Porter  <dgp@users.sourceforge.net>

	* library/msgs/pl.msg:	Backport updates to pl.msg from HEAD

2010-08-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* license.terms: Fix DFARs note for number-adjusted rights clause

2010-08-04  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.9 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updated for 8.5.9 release.

2010-08-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/button.tcl (::tk::CheckEnter): [AS Bug#87409]: Use uplevel
	set instead of set :: to work with other var resolvers (itcl).

2010-08-03  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.9 release.

2010-07-06  Andreas Kupries  <andreask@activestate.com>

	* doc/text.n: Fixed minor typo in the description of 'text delete', as
	reported by <eee@users.sf.net> on the chat.

2010-05-31  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkBind.c (Tk_CreateBinding): [Bug 3006842]: Silently ignore
	empty binding scripts.
	* generic/ttk/ttkTreeview.c: [$tv tag bind $tag <...> {}] now removes
	binding.

2010-05-31  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkMain.c:  Fix CYGWIN warning: "fd_set and assiciated.macros
	have been defined in sys/types. This may cause runtime problems with
	W32"
	* win/winMain.c:     Add command line processing for CYGWIN, backported
	from trunk.

2010-05-20  Donal K. Fellows  <dkf@users.sf.net>

	* win/tkWinX.c (HandleIMEComposition): [Bug 2992129]: Ensure that all
	places that generate key events zero them out first; Tk relies on that
	being true for the generic parts of the fix for Bug 1924761.

2010-05-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 3002230]: tk_chooseDirectory returns garbage
	on cancel.

2010-05-17  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinDialog.c: [Bug 2987995]: Tk_getOpenFile returns garbage
	under described circumstances. Backported some formatting from trunk.

2010-05-03  Donal K. Fellows  <dkf@users.sf.net>

	* library/button.tcl (CheckInvoke, CheckEnter): [Patch 1530276 redux]:
	Apply a bit more care to ensure that things continue to work correctly
	even when there is no -selectcolor defined.

2010-04-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkWinPort.h: Fix [Patch 2986105]: conditionally defining
	strcasecmp/strncasecmp
	* win/tkWinDialog.c: Fix [Bug 2987995]: Tk_GetOpenFile returns garbage
	under described circumstances, minor formatting.
	* win/tkWinDialog.c: [Patch 2898255]: Filenames limit with
	Tk_GetFileName().
	Assure modern style dialogs where available

2010-03-12  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkButton.h:	[Bug 2956548]: TkpButtonSetDefaults only
	* generic/tkButton.c:	initializes one button type
	* win/tkWinButton.c:
	* win/tkWinEmbed.c:	Fix various gcc warnings, all
	* win/tkWinMenu.c:	backported from Tk 8.6
	* win/tkWinPixmap.c:
	* win/tkWinSend.c:
	* win/tkWinTest.c:
	* win/tkWinWm.c:
	* win/tkWinX.c:
	* win/tkWinInt.h:	VC6++ does not have SPI_SETKEYBOARDCUES
	* win/.cvsignore:

2010-03-11  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkText.c (DumpLine): [Bug 2968379]: When peers are about,
	there can be unnamed marks present during a dump. Ignore them as they
	will just be for the peers' insert and current marks, which aren't
	very important.

2010-03-04  Donal K. Fellows  <dkf@users.sf.net>

	* doc/clipboard.n: Added note about STRING vs. UTF8_STRING types.

2010-02-21  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkText.c (TextEditCmd): [Bug 1799782]: Refix this, so that
        <<Modified>> events are issued when things change.

2010-02-19  Donal K. Fellows  <dkf@users.sf.net>

	* unix/installManPage: [Tcl Bug 2954638]: Correct behaviour of manual
	page installer. Also added armouring to check that assumptions about
	the initial state are actually valid (e.g., look for existing input
	file).

2010-02-19  Stuart Cassoff  <stwo@users.sourceforge.net>

	* tcl.m4: Correct compiler/linker flags for threaded builds on
	OpenBSD.
	* configure: (regenerated).

2010-02-17  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkMenu.c: [Bug 2952745]: Defer TkMenuOptionTables cleanup to
	CallWhenDeleted() time, to ensure that the record doesn't get freed
	until after all widget instance commands have been deleted.

2010-02-16  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tkUnixWm.c: Make TkSetTransientFor static

2010-02-07  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/ttk/ttkGenStubs.tcl: Backport various formatting (spacing)
	* generic/ttk/ttk.decls:       changes from HEAD, so diffing
	* generic/ttk/ttkDecls.h:      between 8.5.x and 8.6 shows the
	* generic/tk*.decls:           real structural differences again.
	* generic/tk*Decls.h:          (any signature change not backported!)

2010-01-29  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkBind.c:      Fix various gcc-4.4 warnings, all
	* generic/tkListbox.c:   backported from HEAD.
	* generic/tkText.c:
	* generic/ttk/ttkInit.c:

2010-01-20  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/bgerror.tcl:  [TIP 359]: Extended Window Manager Hints
	* library/clrpick.tcl:  following the freedesktop.org specification
	* library/demos/widget: are now supported on X11 using a new
	* library/dialog.tcl:   wm attribute called '-type'
	* library/msgbox.tcl:   This feature is now used in the Tk library
	* library/tkfbox.tcl:   functions where appropriate.
	* library/ttk/combobox.tcl:
	* tests/unixWm.test:
	* tests/wm.test:
	* unix/tkUnixWm.c:

2010-01-19  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkCanvas.c (TagSearchScanExpr): [Bug 2931374]: Stop overflow
	of working buffer during construction of long tag expressions.

2010-01-18  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkCanvas.c:      [Patch 2932808]: Canvas items not
	                           updating on widget state change.

2010-01-09  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* doc/menu.n:           [TIP 360]: Remove special handling of
	* library/obsolete.tcl: the .help menu on X11.
	* unix/tkUnixMenu.c:

	* library/menu.tcl:      [TIP 360]: Make Tk menu activation
	* library/obsolete.tcl:  follow mouse movements.

2010-01-08  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* doc/photo.n: [Bug 2927569]: Multiple edits have peverted the
	original meaning of the phrase 'image file data' to reference
	a filename option that does not exist.

2010-01-07  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkTextDisp.c (AsyncUpdateLineMetrics): [Bug 2677890]: Fix
	odd text widget update problem that had scrollbars being unable to
	cover the whole widget. Fix is to reify the range to update sooner.

2010-01-06  Jan Nijtmans  <nijtmans@users.sf.net>

	* unix/tcl.m4:		Sync with Tcl version
	* unix/configure:	(regenerated)
	* unix/Makefile.in:
	* unix/.cvsignore:
	* generic/default.h:	Trivial CYGWIN fixes
	* generic/tkWindow.c:
	* doc/.cvsignore:

2010-01-06  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixWm.c (TkWmMapWindow): [Bug 1163496]: Allow windows to be
	* tests/wm.test (wm-transient-8.1): set to be transients for withdrawn
	masters correctly.

2010-01-05  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinDialog.c: [Patch 2898255]: Enable unlimited multiple
	file selection from the open files dialog (pawlak,fellows,thoyts)

2010-01-05  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkMenu.c (MenuWidgetObjCmd): [Bug 220950]: Do not delete
	menu entries if the first index to delete is explicitly after the last
	index of existing entries.

2010-01-04  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/dialog.tcl: Backported fix for tk_dialog <Return> binding
	* library/console.tcl: Backported fix for console keyboard menu
	activation and <<Cut>> handling from HEAD.
	* library/tk.tcl: Correctly handle quoted ampersands in AmpMenuArgs

2010-01-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkMenu.h: [Patch 2848897] Support the system keyboard
	* win/tkWinMenu.c:  cues option on Windows. This system parameter
	hides the underlines on menu items unless the keyboard is used to
	open the menu. (kovalenko, thoyts)

2010-01-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/tearoff.tcl: tearoff menus should be transient and use the
	                       toolwindow style on Windows.
	* tests/menu.test: menu tests using 'tkwait visibility' are unix only

2010-01-02  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixEvent.c (TransferXEventsToTcl): [Bug 1924761]: Use the
	new cache mechanism to force the extraction of the string of a key
	event from XIM at the right time rather than after queueing when it
	can be quashed by a race condition centered on the limited amount of
	state in some XIM implementations.

	* unix/tkUnixKey.c (TkpGetString): [Bug 1373712]: Cache the value that
	* generic/tkInt.h (TkKeyEvent):		will be substituted via %A so
	* generic/tkEvent.c (CleanUpTkEvent):	that we do not need to make it
	* doc/HandleEvent.3 (ARGUMENTS):	fresh each time, which causes
	* doc/QWinEvent.3 (ARGUMENTS):		trouble with some input
	* macosx/tkMacOSXKeyEvent.c (InitKeyEvent): methods. Also includes the
	* win/tkWinX.c (GenerateXEvent):	factoring out of some code and
	update of documentation to describe the slightly increased constraints
	on how Tk_HandleEvent can be used.

2010-01-01  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixEvent.c (TransferXEventsToTcl): [Bug 1924761]: Move the
	* generic/tkEvent.c (Tk_HandleEvent):	     passing of key events to
	XFilterEvent to the low level point where all other events are
	handled, where it should have been all along. This makes more input
	methods work, stops [event generate] from interfering with input
	methods, and allows the simplification of tkEvent.c by removing half
	of InvokeInputMethods and allowing the rest - which was not full input
	method handling - to be rolled back into Tk_HandleEvent. Introduces a
	small potential bug when a focus change and input method handling are
	too close together in the Tk event queue, but that should be less
	deadly to usability than the previous problems where input methods
	could fail completely or reorder key presses...

2009-12-30  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkMenu.c: [Patch 2879789]: Torn off menu items are only
	* tests/menu.tcl:   activated over a limited region of the window.
	Fixed to make the whole width of a menu item activate the entry.

2009-12-27  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinMenu.c: [Bug 2879927]: Highlight for cascade items in
	torn-off menus is incorrect on Windows.

2009-12-25  Donal K. Fellows  <dkf@users.sf.net>

	* doc/option.n: [Bug 2914943]: Correct the first example.
	Also define what the format of option patterns is; that's a much less
	commonly known fact than it used to be.

2009-12-22  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/sizegrip.tcl: [Bug 2912356]: Patch to avoid bizarro
	behavior under compiz.

2009-12-22  Donal K. Fellows  <dkf@users.sf.net>

	* library/tkfbox.tcl (ListInvoke): [Bug 2919205]: Correct ordering of
	arguments to tk_messageBox.

2009-12-20  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixSend.c (ServerSecure): [Patch 2917663]: Better support
	for server-interpreted access control addreses.

2009-12-16  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkNotebook.c: Don't call Tk_DeleteOptionTable()
	[Bug 2915709], backport fix for [Bug 2496162].

2009-12-14  Kevin B. Kenny  <kennykb@acm.org>

	* library/demos/unicodeout.tcl: Added code to check for right-to-left
	support on Windows and adjust Hebrew and Arabic character strings
	accordingly. Changed the Hebrew string to 'ktb ebryt' (ktav Ivrit,
	"Hebrew writing") to be consistent with at least the Greek and Russian
	strings. Thanks to Rodrigo Readi for calling the inconsistency to our
	attention.

2009-12-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* win/tkInt.decls:	[Bugs 220600, 220690]: Comment that
	TkWinChildProc is exported through the stubs table since 8.5.9

2009-12-11  Donal K. Fellows  <dkf@users.sf.net>

	* library/tk.tcl (tk::ScreenChanged): [Bug 2912473]: Stop problems
	caused by display names with a double colon in.

2009-12-10  Donal K. Fellows  <dkf@users.sf.net>

	* library/demos/ttkscale.tcl: Added demo of [ttk::scale] widget.

2009-12-09  Andreas Kupries  <andreask@activestate.com>

	* library/safetk.tcl (::safe::loadTk): [Bug 2902573]: Fixed access to
	the cleanupHook of the safe base. The code used the old internal
	commands which have been removed since 2009-12-09. See Tcl's
	ChangeLog.

2009-12-09  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkColor.c (Tk_GetColorByValue): [Bug 2911570]: Ensure that
	hash keys of color values are zeroed first, so that they hash properly
	on 64-bit systems (where X structures are not tightly packed).

2009-12-08  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* unix/tkUnixWm.c: [Bug 2864685]: Backported window manager hinting
			   update from HEAD

2009-12-06  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c (GetFontFamilyName): [Bug 2548661]: Merge fix
	from HEAD (1.44).

2009-12-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/xpTheme.tcl:    Fix selection of treeview rows on
	* library/ttk/vistaTheme.tcl: Windows XP and Vista.

2009-12-02  Jan Nijtmans  <nijtmans@users.sf.net>

	* doc/GetHINSTANCE.3:	Correct mentioned header file
	* win/tkWinInt.h:	[Bugs 220600, 220690]: Make TkWinChildProc
	* generic/tkInt.decls:	available in private stub table.
	* generic/tkIntPlatDecls.h: (regenerated)
	* generic/tkStubInit.c:	(regenerated)

2009-11-25  Stuart Cassoff <stwo@users.sf.net>

	* unix/tcl.m4:		[Patch 2892871]: Remove unneeded
	*			AC_STRUCT_TIMEZONE.
	* unix/configure:	Regenerated with autoconf-2.59.

2009-11-24  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixWm.c (WmIconphotoCmd): [Bug 2902814]: Use the correct
	type for the array of data passed into X. It's wrong, but "right"
	because of a mistake in the X11 specification.

2009-11-22  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winWm.test: [Bug 2899949]: Make sure the window is still
	* win/tkWinWm.c:    present when handling delayed activation

2009-11-13  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winDialog.test: [Bug 2307837]: Backported fix for running
	* win/tkWinTest.c:      dialog tests on non-English locales

2009-11-12  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.8 TAGGED FOR RELEASE ***

	* changes:	Updated for 8.5.8 release.

2009-11-03  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.8 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updated for 8.5.8 release.

2009-11-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinWm.c: [Bug 2891541]: Permit normal behaviour on
	Windows for a grabbed toplevel when it is the main window.

2009-11-01  Joe Mistachkin  <joe@mistachkin.com>

	* win/tkWinButton.c: [Bug 1739613]: The default width being stored
	in TSD cannot be put into the process-wide options table.  This fix
	allocates storage for the default width from the heap and frees it
	using an exit handler.

2009-10-29  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinFont.c: [Bug 1825353]: Backported patch for tiny
	fixed font on Russian Windows systems.

2009-10-25  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixColor.c (TkpGetColor): [Bug 2809525]: Impose a maximum
	X11 color name length so that it becomes impossible to blow things up
	that way.

	* library/text.tcl: [Bug 1854913]: Stop <Delete> actions from ever
	deleting backwards, even when the insertion cursor is "at the end" of
	the text widget.

2009-10-24  Donal K. Fellows  <dkf@users.sf.net>

	* macosx/ttkMacOSXTheme.c (RangeToFactor, TrackElementDraw)
	(PbarElementDraw): [Bug 2883712]: Corrected scaling of progress bars
	and scales, and backported the fix for 64-bitness.

	* library/button.tcl, unix/tkUnixButton.c (TkpDisplayButton):
	[Patch 1530276]: Make -selectcolor handling work better for both
	checkbuttons and radiobuttons when they don't have indicators.

2009-10-22  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkText.c (CreateWidget, TextEditUndo, TextEditRedo)
	(TextEditCmd, UpdateDirtyFlag):
	* generic/tkText.h: [Patch 1469210]: Corrected handling of marking as
	dirty when inserting after an undo from a non-dirty state.

	* library/xmfbox.tcl (MotifFDialog_FileTypes)
	(MotifFDialog_ActivateSEnt):
	* library/tkfbox.tcl (Done, ::tk::dialog::file::):
	* macosx/tkMacOSXDialog.c (Tk_GetOpenFileObjCmd):
	* win/tkWinDialog.c (GetFileNameW, GetFileNameA):
	* doc/getOpenFile.n: [Patch 2168768]: Corrected handling of the
	-typevariable option to be consistently global; it's the only way it
	can work even close to the same on all platforms.

2009-10-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Relax the runtime version requirements on Tcl
	* generic/tkMain.c:	so that Tk 8.5.8 can [load] into Tcl 8.6 (and
	* generic/tkWindow.c:	later 8.*) interps.  [Feature Request 2794032]
	* library/tk.tcl
	* unix/Makefile.in:
	* win/Makefile.in:
	* win/makefile.vc:

2009-10-10  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixRFont.c (InitFont,TkpGetFontFromAttributes,Tk_DrawChars):
	[Bug 1961455]: Draw underlines and overstrikes when using Xft for font
	rendering.

2009-10-08  Donal K. Fellows  <dkf@users.sf.net>

	* library/tkfbox.tcl (::tk::IconList_Create): [Patch 2870648]:
	Corrected cursor used in file/directory dialogs.

2009-10-07  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/vistaTheme.tcl: [Bug 2787164]: Fix size of dropdown
	arrow on combobox and menubutton for Windows 7.

2009-10-07  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixScrlbr.c (TkpComputeScrollbarGeometry): [Patch 2088597]:
	Stop scrollbars from getting too small at the end.

2009-10-05  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.8 release.

2009-10-05  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinButton.c: [Bug 2860827]: Backported patch avoiding 3D
	effects with user-specified background.

2009-09-25  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkImgPhoto.c (ImgGetPhoto): Correct generation of grayscale
	data from an image. Reported by Keith Vetter on comp.lang.tcl.

2009-09-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenuDraw.c (TkPostSubmenu): [Bug 873613]: Fix reposting of
	* win/tkWinMenu.c (TkWinHandleMenuEvent): submenu in torn off Windows
	menu.
	(DrawMenuEntryArrow): [Bug 873608]: Draw Win menu arrow after being
	torn off.

2009-09-10  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixRFont.c (InitFont): Move pattern disposal in error case
	to callers so they have more options when they come to recovering from
	the failure.
	(TkpGetFontFromAttributes): If the default attributes don't work, try
	adding a setting to turn off use of XRender. That seems to work for
	some people for unexplained reasons (possibly local misconfiguration).
	* generic/tkFont.c (Tk_AllocFontFromObj): Stop this function from
	keeling over in a heap when the low-level font allocation fails. An
	error beats a crash! (Issue reported on comp.lang.tcl by Denis
	Berezhnoy.)

2009-08-25  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixSend.c (ServerSecure): [Bug 1909931]: Added some support
	for server-interpreted access control addreses.

2009-08-24  Donal K. Fellows  <dkf@users.sf.net>

	* library/msgbox.tcl (::tk::MessageBox): Correct bindings so that they
	work with ttk::buttons. Reported by Hans-Christoph Steiner.

2009-08-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXHLEvents.c (ScriptHandler): Fix "do script" apple
	event handler issues on recent Mac OS X releases by using AE coercion
	to 'utf8' for text data and to 'fsrf' for alias data. (Reported by
	Youness Alaoui on tcl-mac)

2009-08-08  Donal K. Fellows  <dkf@users.sf.net>

	* library/demos/pendulum.tcl: Make the display handle being resized
	more gracefully.

2009-08-04  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkTextDisp.c (TkTextCharLayoutProc): Make the line breaking
	algorithm (in the word-wrap case) do the right thing with non-breaking
	spaces by restricting what we break on to ASCII spaces, which is good
	enough for most purposes.

2009-08-01  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixWm.c (WmIconphotoCmd): [Bug 2830420]: Assemble the image
	for the window manager in a way that doesn't assume we're on a little-
	endian system.

2009-07-22  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkFocus.c (TkFocusDeadWindow): [Bug 2496114]: Ensure that
	focus desynchronization doesn't cause a crash.

2009-07-20  Donal K. Fellows  <dkf@users.sf.net>

	* tests/clipboard.test (clipboard-6.2): [Bug 2824378]: Corrected
	result of test in light of changes to binary selection retrieval.

2009-07-18  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixSelect.c (SelCvtFromX32, SelCvtFromX8): Make the
	incremental transfer of binary selections work get deserialized
	correctly. Thanks to Emiliano Gavilán for detecting.

2009-07-15  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixSelect.c (TkSelEventProc, SelRcvIncrProc, SelCvtFromX8):
	[Bug 2821962]: Make byte sequence selection transfers possible.

2009-07-14  Donal K. Fellows  <dkf@users.sf.net>

	* doc/canvas.n (WINDOW ITEMS): [Bug 2326602]: Corrected definition of
	the -height and -width options for these items.

	* unix/configure.in: [Bug 2496018]: Allow the disabling of the use of
	XScreenSaver at configuration time, so as to permit better control of
	dependencies in the embedded case.

2009-07-11  Donal K. Fellows  <dkf@users.sf.net>

	* doc/grid.n: [Bug 2818455]: Corrected example.

2009-06-27  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkInt.decls (Tk(Orient|Smooth)(Parse|Print)Proc):
	Backport [Bug 2804935]: Expose these functions through the internal
	stub table as they are useful to existing third-party code.

2009-06-23  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkCanvUtil.c: [Bug 220935]: canvas dash update problem

2009-06-02  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinWm.c:   [Bug 2799589]: Backported fix for crash on
	* tests/winWm.test: delayed window activation.

2009-05-21  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinMenu.c: [Bug 2794778]: Backported fix for keyboard
	traversal of the menus on Windows.

2009-05-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkButton.c: [Bug 1923684]: Backported checkbutton fix
	for confused state when -offvalue equals -tristatevalue

2009-05-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* doc/ttk_image.n:  Backported support for the Vista theme.
	* doc/ttk_style.n:  This requires the vsapi element engine,
	* doc/ttk_vsapi.n:  the hover state and the theme script
	* doc/ttk_widget.n: definition.
	* generic/ttk/ttkState.c:
	* generic/ttk/ttkTheme.h:
	* generic/ttk/ttkWidget.c:
	* library/ttk/ttk.tcl:
	* library/ttk/vistaTheme.tcl:
	* library/ttk/xpTheme.tcl:
	* tests/ttk/vsapi.test:
	* win/ttkWinXPTheme.c:

2009-05-13  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkFont.c: [Bug 2791352]: Backported fix and tests for
	* tests/font.test:  mis-parsing of certain font descriptions.

2009-05-03  Donal K. Fellows  <dkf@users.sf.net>

	* win/tkWinWm.c (UpdateWrapper): [Bug 2785744]: Manipulate flag bit
	correctly so that menubar updates can't smash other attributes.

2009-04-30  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinWm.c: [Patch 2504402]: Backported change to create
	wm icons as device independent bitmaps. (cjmcdonald)

2009-04-30  Donal K. Fellows  <dkf@users.sf.net>

	* win/tkWinPixmap.c (Tk_GetPixmap): [Bug 2080533]: Added patch that
	allows Tk to keep working even when the graphics card is stressed.

2009-04-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure (SC_CONFIG_CFLAGS): Harden the check
	to add _r to CC on AIX with threads.

2009-04-27  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkInt.decls: [Bug 2768945]: Expose (as "private") a set of
	functions needed for easily building canvas items that work like
	existing standard ones.

2009-04-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (ChooseDirectoryValidateProc): No need to set
	cwd on selchange. Prevents delete of selected folder in dialog.

2009-04-24  Stuart Cassoff <stwo@users.sf.net>

	* unix/Makefile.in:	[Bug 2764263]: Removed stray @ from
	Makefile.in test target. [Bug 1945073]: Don't chmod+x square demo.
	[Patch 2764272]: Adjustable demo install location.

2009-04-24  Stuart Cassoff <stwo@users.sf.net>

	* unix/Makefile.in: [Patch 2769530]: Don't chmod/exec installManPage.

2009-04-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinDialog.c (Tk_ChooseDirectoryObjCmd): [Bug 2779910]: Enable
	the new style choosedir that has a "New Folder" button, with
	::tk::winChooseDirFlags override for new behavior.

2009-04-15  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.7 TAGGED FOR RELEASE ***

	* changes:	Updated for 8.5.7 release.

2009-04-14  Stuart Cassoff  <stwo@users.sourceforge.net>

	* unix/tcl.m4:	Removed -Wno-implicit-int from CFLAGS_WARNING.

2009-04-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updated for 8.5.7 release.

	* generic/tk.h:		Bump to 8.5.7 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

2009-04-10  Joe English  <jenglish@users.sourceforge.net

	* library/palette.tcl(tk_setPalette): Don't set
	*selectColor: #b03060; this makes radio- and checkbuttons
	look wrong post-TIP#109.

2009-04-10  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in (Darwin):	use Darwin SUSv3 extensions if
					available.
	* unix/configure:		autoconf-2.59
	* unix/tkConfig.h.in:		autoheader-2.59

	* library/msgbox.tcl: don't set msgbox bitmap background on TkAqua.

	* library/demos/filebox.tcl: only show "Motif Style Dialog" checkbutton
	on X11 windowingsystem.

	* library/demos/widget: GOOBE: use ttk::cursor

	* library/ttk/cursors.tcl: backport ttk::cursor from HEAD

	* library/demos/knightstour.tcl: fix knightstour demo not running from
	interactive wish.

	* library/console.tcl (::tk::ConsoleInit): remove redundant TkAqua
	Quit menu item.

	* generic/tkPointer.c (Tk_UpdatePointer): use all 5 buttons.

	* generic/tkMenu.c (PostProcessEntry): delay call to
	TkpConfigureMenuEntry() until all menu entry attributes are setup.

	* library/menu.tcl (::tk::MbPost): fix error thrown in y position
	computation with indicatoron.

	* generic/tkMenubutton.c: s/DEF_BUTTON_JUSTIFY/DEF_MENUBUTTON_JUSTIFY/

	* generic/tkTextBTree.c (TkBTreeDeleteIndexRange): add bounds check
	to startEnd array access (fixes testsuite crash).

	* tests/unixFont.test: only use xlsfonts with X11 windowingsystem.

2009-04-10  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkCanvPs.c (TkPostscriptInfo): [Bug 1466509]: Eliminate old
	and misleading comments mentioning prolog.ps.
	* generic/prolog.ps, library/prolog.ps: Remove unused files.
	* unix/Makefile.in, win/Makefile.in: Stop building distributions that
	include the removed files or trying to install them.

	* library/tk.tcl: [Bug 2116837]: Add event definitions to handle the
	standard virtual events when Caps Lock is on.

2009-04-03  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c: [Bug 1789819]: Don't Panic.

2009-03-25  Donal K. Fellows  <dkf@users.sf.net>

	* generic/ttk/ttkTheme.c (BuildOptionMap, NewElementImpl):
	[Bug 2178820]: Ensure that zero-size allocations don't happen; some
	malloc implementations don't like it at all.

	* win/wish.exe.manifest.in: [Bug 1871101]: Add magic to make Tk not be
	blurred on Vista with large fonts.

2009-03-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkFileFilter.c: Backported some fixes for uninitialized
	* generic/tkFont.c:       variables identified by das using clang
	* generic/tkListbox.c:    analysis.

2009-02-27  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkWindow.c: [Bug 2645457] check for dead windows after
	calling Tk_MakeWindowExist to avoid a crash when mapping dead windows.

2009-02-23  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinCursor.c: [Patch 2542828] use stock Win32 help arrow
	cursor when question_arrow requested (danckaert)

	* win/rc/*.cur: [Patch 2513104] fix cursor hotspots (cjmcdonald)

	* win/tkWinMenu.c: Applied patch for menu image display bug
	[Bug 1329198, 456299] [Patch 2507419] (cjmcdonald)

2009-02-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4, win/configure: Check if cl groks _WIN64 already to
	avoid CC manipulation that can screw up later configure checks.
	Use 'd'ebug runtime in 64-bit builds.

2009-02-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure.in, win/configure: align better with tcl
	version. Ensures finding correct CPP for Win64.

2008-02-06  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkImgPhoto.c:		fix numerous leaks discovered with the
	* generic/tkMenu.c:		Mac OS X Instruments.app Leaks tool.
	* generic/tkText.c:
	* generic/tkTextImage.c:
	* generic/tkTextIndex.c:
	* generic/tkUndo.c:
	* generic/ttk/ttkFrame.c:
	* macosx/tkMacOSXWm.c:

2009-01-22  Kevin B. Kenny  <kennykb@acm.org>

	* unix/tcl.m4: Corrected a typo ($(SHLIB_VERSION) should be
	${SHLIB_VERSION}).
	* unix/configure: Autoconf 2.59

2009-01-19  Kevin B. Kenny  <kennykb@acm.org>

	* unix/Makefile.in: Added a CONFIG_INSTALL_DIR parameter so that
	* unix/tcl.m4:      distributors can control where tclConfig.sh goes.
	Made the installation of 'ldAix' conditional
	upon actually being on an AIX system.  Allowed for downstream
	packagers to customize SHLIB_VERSION on BSD-derived systems.
	Thanks to Stuart Cassoff for [Patch 907924].
	* unix/configure: Autoconf 2.59

2009-01-14  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkImgPhoto.c: fix for aMSN compatibility [tcl-Bug 2507326]

2009-01-11  George Peter Staplin  <georgeps@users.sourceforge.net>

	* generic/tkEvent.c: Backport a fix from 8.6 for a NULL pointer
	dereference in CreateXIC.

2009-01-07  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinWm.c: Backported fix for [Bug 1847002] to prevent the
	bypassing of grab restrictions via the taskbar on Windows.

2008-12-22  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.6 TAGGED FOR RELEASE ***

	* tests/embed.test:	Eliminate duplicate test names.

	* changes:	Updates for 8.5.6 release.

2008-12-22  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkWidget.c: Don't crash when
	application uses nondefault visual [Bug 2264732]
	(Backport from trunk change 2008-11-11)
	* Workaround for [Bug 2207435]
	(Backport from trunk change 2008-10-31).

2008-12-22  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkCanvPs.c (Tk_PostscriptFont,TkCanvPostscriptCmd): Backport
	of font size and reflection fix. [Bug 2107938]

2008-12-22  Alexandre Ferrieux 	<ferrieux@users.sourceforge.net>

	* generic/tkCanvUtil.c: Backport of the Millipeter patch [1813597,
	* generic/tkInt.h:       2218964]
	* generic/tkObj.c:
	* generic/tkText.c:

2008-12-21  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.6 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updates for 8.5.6 release.

2008-11-22  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/combobox.tcl: [Bug 1939129,1991930] combobox dropdown
	                            was drawn behind topmost toplevels.

2008-11-19  Jan Nijtmans  <nijtmans@users.sf.net>

	* generic/tkImage.c    Relax the constraint that every Tk_ImageType
	* generic/tkImgPhoto.c can only be passed to this function once.
	                       This allows tkImg to be loaded in multiple
	                       interpreters in a thread-enabled build of Tk.
	                       [Bug 2312027]

2008-11-15  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tk.h:        The tip 125 implementation permits the
	* generic/tkFrame.c:   wm manage command to manage any widget but
	* macosx/tkMacOSXWm.c: only those with Frame instance data should
	* unix/tkUnixWm.c:     be permitted. We now check for the suitability
	* win/tkWinWm.c:       and raise an error for non-frame widgets.
	* test/wm.test:        Updated the tests and documentation.
	* doc/wm.n:            See also [Bug 2239034]

2008-11-12  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/constraints.tcl: backported listbox test fix from head
	* tests/listbox.test:    the default on windows is 'underline'
	* tests/winDialog.test: backported some fixes from head
	* library/text.tcl: Backported fix for bug #1777362 to have events
	* test/text.test:   work with window paths that include hyphens.

2008-10-23  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump version number to 8.5.6b1 to distinguish
	* library/tk.tcl:	CVS development snapshots from the 8.5.5 and
	* unix/configure.in:	8.5.6 releases.
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2008-10-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/scale.tcl: Backported keyboard bindings for ttk::scale

2008-10-11  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	*** 8.5.5 TAGGED FOR RELEASE ***

	* generic/tkCanvas.c (CanvasWidgetCmd): Corrected result generation.

2008-10-10  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.5 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updates for 8.5.5 release.

	* unix/Makefile.in:	Relax constraints in index script so that
	* win/Makefile.in:	each Tk 8.5.* release may be [package require]d
	* win/makefile.vc:	into any Tcl 8.5.* interp.  [Bug 1890438].

2008-10-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkListbox.c:	Make literal return values consistent with
	those generated by Tcl_PrintDouble().

	* tests/canvText.test:	Backport test updates in light of the
	* tests/entry.test:	2008-10-05 commit.
	* tests/listbox.test:
	* tests/scrollbar.test:
	* tests/spinbox.test:
	* tests/textDisp.test:

	* generic/tkEntry.c:	Fix missing space constructing the scroll
	command.

2008-10-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* win/tkWinScrlbr.c:		Convert 'sprintf(..."%g"...)' to the
	* macosx/tkMacOSXScrlbr.c:	locale-insensitive Tcl_PrintDouble.
	* generic/tkScrollbar.c:	[Bug 2112563]  NOTE: Tcl_PrintDouble
	* generic/tkListbox.c:		is sensitive to the value of
	* generic/tkEntry.c:		::tcl_precision.
	* generic/tkCanvText.c:		*** POTENTIAL INCOMPATIBILITY ***
	* generic/tkArgv.c:

2008-08-25  Todd M. Helfter  <tmh@users.sourceforge.net>

	* library/menu.tcl: additional fix for [Bug 1023955]

2008-09-08  Todd M. Helfter  <tmh@users.sourceforge.net>

	* doc/menu.n: fix typo in docs [Bug 2098425]

2008-08-28  Don Porter  <dgp@users.sourceforge.net>

	* unix/tkConfig.sh.in:	Added @XFT_LIBS@ to the definition of TK_LIBS
	to avoid link failures when a "big wish" program links against a
	--disable-shared build of libtk.  (Discovered building expectTk).

	* generic/tk.h:		Bump version number to 8.5.5b1 to distinguish
	* library/tk.tcl:	CVS development snapshots from the 8.5.4 and
	* unix/configure.in:	8.5.5 releases.
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2008-08-25  Todd M. Helfter  <tmh@users.sourceforge.net>

	* library/menu.tcl: fix typo from [Bug 1023955]

2008-08-25  Todd M. Helfter <tmh@users.sourceforge.net>

	* library/menu.tcl : Do not flip to the arrow cursor on menus.
	This was a Motif convention.  Current behavior is maintained if
	tk_strictMotif is enabled.  [Bug 1023955]

2008-08-25  Todd M. Helfter <tmh@users.sourceforge.net>

	The patch is associated with the bug tracker id: 1936220
	library/tkfbox.tcl : fix the multiple selection error for
	tk_getOpenFile -multiple 1 which fails on all unix platforms since
	the adoption of ttk widgets.

2008-08-19  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkScroll.c:  Don't use sprintf "%g" to
	format floating point numbers in -[xy]scrollcommand callbacks
	or [xy]view methods.  Minor incompatibility: 0 and 1 now
	formatted as "0.0" resp "1.0".
	* tests/ttk/entry.test, tests/ttk/treeview.test: Updated
	to account for above change.

2008-08-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXFont.c (SetFontFeatures):	Disable antialiasing of
						 	fixed-width fonts with
						 	size <= 10.

2008-08-14  Daniel Steffen  <das@users.sourceforge.net>

	*** 8.5.4 TAGGED FOR RELEASE ***

	* unix/tcl.m4 (SC_PATH_X):	check for libX11.dylib in addition to
					libX11.so et al.

	* unix/configure: 		autoconf-2.59

2008-08-08  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump to 8.5.4 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updates for 8.5.4 release.

2008-08-05  Joe English  <jenglish@users.sourceforge.net>

	* generic/tk.h, generic/tkEvent.c: Fix for [Bug 2010422]
	"no event type or button # or keysym while executing
	"bind Listbox <MouseWheel> [...]".

2008-08-01  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinWm.c: Backported fixes for handling unmapped parent
	* test/wm.test:  toplevels. [Bug 2009788, 2028703]

2008-07-31  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:	Added missing EXTERN for the Tcl_PkgInitStubsCheck
	declaration to fix inability to embed non-stub-enabled Tk on Windows.

2008-07-26  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* doc/options.n: Direct to the font manual for -font [Bug 1686012]

	* win/tkWinWindow.c: Check for 0x prefix in sprintf %p. Bug [2026405]

2008-07-22  Daniel Steffen  <das@users.sourceforge.net>

	* library/ttk/aquaTheme.tcl: Use system color names and TIP145 named
	font instead of hardcoded color values and deprecated native font name.

	* macosx/tkMacOSXHLEvents.c: sync with HEAD.

2008-07-04  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkDefaultTheme.c, generic/ttk/ttkClamTheme.c,
	generic/ttk/ttkClassicTheme.c, generic/ttk/ttkElements.c:
	Backport [Bug 2009213].

2008-06-29  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.3 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.3 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:
	* README:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updates for 8.5.3 release.

2008-06-26  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkPanedWindow.c (PanedWindowProxyCommand)
	(DisplayPanedWindow): Ensure that a zero width never gets fed to the
	underlying window system. [Bug 1639824]  (Backport fix from dkf).

2008-06-20  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/treeview.tcl: Backport fix for [Bug 1951733]

2008-06-19  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.3 release.

2008-06-18  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXCarbonEvents.c:	fix debug carbon event tracing;
	(InstallStandardApplicationEventHandler):	replace needless use of
	TkMacOSXInitNamedDebugSymbol() by standard TkMacOSXInitNamedSymbol().

	* macosx/tkMacOSXDebug.c:	revert 2007-11-09 commit making
	* macosx/tkMacOSXDebug.h:	TkMacOSXInitNamedDebugSymbol()
					available outside of debug builds.

	* macosx/tkMacOSXEmbed.c (TkpMakeWindow):	fix bug with missing
	* macosx/tkMacOSXSubwindows.c (XMapWindow):	focus on first map by
	only sending VisibilityNotify events once windows are mapped (rather
	than when they are created).

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXProcessWindowEvent): fix
	return value.

	* macosx/tkMacOSXInit.c:	add helper to efficiently convert from
	* macosx/tkMacOSXPrivate.h:	CFString to Tcl_Obj.

	* macosx/tkMacOSXFont.c (TkpGetFontFromAttributes, InitFont):	fix
	incorrect conversion to points of font sizes already in points; factor
	out retrieval of font family name from font family ID.

2008-06-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure, win/configure.in (TK_WIN_VERSION): fix handling
	of interim a/b versioning for manifest usage.

2008-06-12  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkPointer.c (Tk_UpdatePointer): fix failure to restore a
	global grab capture and to release the restrict window capture when
	releasing a button grab. Fixes segfault due to dangling reference to
	restrict window inside TkpSetCapture() implementation. [Bug 1991932]

	* unix/tcl.m4 (SunOS-5.11): fix 64bit amd64 support with gcc & Sun cc.
	* unix/configure: autoconf-2.59

	* macosx/tkMacOSXXStubs.c (Tk_ResetUserInactiveTime): use UsrActivity
	instead of OverallAct (which may be ignored in some circumstances).

	* macosx/Wish.xcodeproj/project.pbxproj: add debug configs for 64bit,
	* macosx/Wish.xcodeproj/default.pbxuser: with gcov, and with
	corefoundation disabled; updates & cleanup for Xcode 3.1 and for
	Leopard; sync with Tcl.xcodeproj.
	* macosx/Wish.xcode/project.pbxproj:	sync Wish.xcodeproj changes.
	* macosx/Wish.xcode/default.pbxuser:
	* macosx/README:			document new build configs.

2008-06-10  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixKey.c: tkUnixKey.c: Use Xutf8LookupString if available
	[Patch #1986818].  This should fix problems (like #1908443) where
	Xlib's idea of the system encoding does not match Tcl's.

2008-05-23  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkLabel.c: Avoid passing width or height <= 0 to
	Tk_RedrawImage, as this leads to a panic on Windows [Bug 1967576]

2008-05-11  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/tk.tcl: Support for ttk widgets in AmpWidget

	* doc/button.n: Note negative widths for button [Patch #1883418]
	* doc/ttk_*:   'identify' widget command is on all ttk widgets.

2008-05-04  Joe English  <jenglish@users.sourceforge.net>

	* macosx/ttkMacOSAquaTheme.c: "default" and "focus" adornments
	should not be disjoint [Bug 1942785]

2008-04-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkCanvas.c:   Fix logic that determines when canvas item
	<Enter> event should fire.  Thanks to Sebastian Wangnick. [Bug 1327482]

2008-04-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinDialog.c: backport tk_chooseColor -title fix from head
	* win/tkWinTest.c:   Added parent to testgetwininfo
	* tests/winDialog.test: Created some tk_chooseColor win tests.

2008-04-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump version number to 8.5.3b1 to distinguish
	* library/tk.tcl:	CVS development snapshots from the 8.5.2 and
	* unix/configure.in:	8.5.3 releases.
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2008-04-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (Initialize): fix double-free on Tk_ParseArgv
	* tests/main.test (main-3.*):      error. [Bug 1937135]

	* generic/tkArgv.c: fix -help mem explosion. [Bug 1936238] (kenny)

2008-04-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/xpTheme.tcl: fix the colour of labelframe in xp

2008-04-01  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkStubLib.c (Tk_InitStubs):	Added missing error message.
	* generic/tkWindow.c (Tk_PkgInitStubsCheck):

2008-03-28  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.2 TAGGED FOR RELEASE ***

	* README:		Bump to 8.5.2 for release.
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:	Updates for 8.5.2 release.

2008-03-27  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/safetk.tcl (::safe::tkInterpInit): make sure tk_library
	and its subdirs (eg, ttk) are on the "safe" access path.

2008-03-27  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (SunOS-5.1x): fix 64bit support for Sun cc. [Bug 1921166]

	* unix/configure: autoconf-2.59

2008-03-27  Daniel Steffen  <das@users.sourceforge.net>

	* generic/ttk/ttkStubLib.c:	ensure tcl stubs are used in libtkstub
					even in a static build of Tk.
	* generic/ttk/ttkDecls.h:	fix incorrect number of arguments in
					Ttk_InitStubs macro definition.

2008-03-26  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.2 release.

	* unix/tkUnixCursor.c:	Stop crash in [. configure -cursor] on X11.
	Thanks to Emiliano Gavilán.  [Bug 1922466]

2008-03-26  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkInt.h, generic/tkEvent.c, unix/tkUnixEvent.c,
	unix/tkUnixKey.c: XIM reorganization and cleanup; see
	[Patch 1919791] for details.

2008-03-21  Joe English  <jenglish@users.sourceforge.net>

	* generic/tk.decls, generic/ttk/ttkStubLib.c, unix/Makefile.in:
	Keep ttkStubLib.o in libtkstub instead of libtk. [Bug 1920030]

2008-03-20  Donal K. Fellows  <dkf@users.sf.net>

	* tests/wm.test: Rewrote so that tests clean up after themselves
	rather than leaving that to the following test. Makes it easier to
	catch problems where they originate. Inspired by [Bug 1852338]

2008-03-19  Donal K. Fellows  <dkf@users.sf.net>

	* doc/GetClrmap.3: Documented Tk_PreserveColormap. [Bug 220809]

2008-03-17  Joe English  <jenglish@users.sourceforge.net>

	* unix/Makefile.in, win/Makefile.in, win/makefile.vc: Put ttkStubLib.o
	in libtkstub instead of libtk. [Bug 1863007]

2008-03-16  Donal K. Fellows  <dkf@users.sf.net>

	* library/demos/goldberg.tcl: Made work when run twice in the same
	session. [Bug 1899664] Also made the control panel use Ttk widgets.

2008-03-13  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in:	Use backslash-quoting instead of double-quoting
	* unix/tcl.m4:		for lib paths in tkConfig.sh. [Bug 1913622]
	* unix/configure:	autoconf-2.59

2008-03-13  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.2 release.

2008-03-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj: Add support for Xcode 3.1
	* macosx/Wish.xcodeproj/default.pbxuser: CODE_SIGN_IDENTITY and
	* macosx/Wish-Common.xcconfig:		 'xcodebuild install'.

2008-03-12  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Try a fallback font if XftFontOpenPattern()
	fails in GetFont (workaround for [Bug 1090382]).

2008-03-11  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/knightstour.tcl:	Aqua GOOBE.
	* library/demos/widget:

	* macosx/Wish.xcodeproj/project.pbxproj: Add support for Xcode 3.1 and
	* macosx/Wish.xcodeproj/default.pbxuser: configs for building with
	* macosx/Wish-Common.xcconfig:		 gcc-4.2 and llvm-gcc-4.2.

	* generic/tkCanvUtil.c:			Fix gcc-4.2 warnings.

	* macosx/GNUmakefile:			Fix quoting to allow paths to
	* macosx/Wish-Common.xcconfig:		${builddir}, ${INSTALL_ROOT}
	* unix/Makefile.in:			and ${TCL_BIN_DIR} to contain
	* unix/configure.in:			spaces.
	* unix/install-sh:
	* unix/tcl.m4:

	* unix/configure:			autoconf-2.59

	* unix/Makefile.in (install-strip):	Strip non-global symbols from
						dynamic library.

2008-03-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.2 release.

2008-03-07  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/colors.n: Reworked to produce nicer HTML output.

2008-03-06  Joe English  <jenglish@users.sourceforge.net>

	* doc/ttk_notebook.n: Move "TAB IDENTIFIERS" section above "WIDGET
	COMMAND" section. [Bug 1882011]

2008-02-29  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/demos/widget:  Added a Knight's tour canvas demo.
	* library/demos/knightstour.tcl:

2008-02-27  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c: workaround leak in Carbon SetPortPenPixPat()
	API [Bug 1863346]; avoid repeated PixPat allocation/deallocation.

2008-02-23  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl, doc/ttk_combobox.n,
	* tests/ttk/combobox.test: Arrange to deliver <<ComboboxSelected>>
	event after listbox is unposted, as intended [Bug 1890211]. Clarified
	documentation.

2008-02-23  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkPanedWindow.c: Don't enforce minimum sash thickness
	of 5 pixels, just use 5 as a default. [FR 1898288]

2008-02-14  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/README: Documented missing configure flags.

2008-02-06  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/ttk_scale.n (new file): Added basic documentation. [Bug 1881925]

2008-02-04  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5.1 TAGGED FOR RELEASE ***

	* generic/tk.h:		Bump to 8.5.1 for release.
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

2008-02-04  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/MeasureChar.3, doc/FontId.3: Minor improvements (formatting,
	keywords).

2008-02-02  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish-Info.plist.in:	add CFBundleLocalizations key, listing
	* unix/configure.in (Darwin): 	all library/msgs locales.

	* unix/configure.in (Darwin):	correct Info.plist year substitution in
					non-framework builds.

	* unix/configure:		autoconf-2.59

2008-02-01  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.1 release.

2008-02-01  Reinhard Max  <max@suse.de>

	* generic/tkImgGIF.c: Fixed a buffer overflow (CVE-2008-0553).
	* tests/imgPhoto.test: Added a test for the above.

2008-01-31  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/msgbox.tcl (::tk::MessageBox): don't use ttk::label in
	low depth/aqua fallback, as it doesn't support -bitmap.

	* win/tkWinDialog.c (Tk_MessageBoxObjCmd): pass "" instead of NULL
	when -title isn't set.  [Bug 1881892]

2008-01-31  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/panedwindow.n: Added proper description of -height and -width
	options, which aren't "standard". Last of fallout from [Bug 1882495].

2008-01-30  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/canvas.n, doc/listbox.n, doc/message.n: Fix erroneous listing of
	"standard" options. [Bug 1882495]

2008-01-29  Joe English  <jenglish@users.sourceforge.net>

	* library/treeview.tcl: Fix bug in Shift-ButtonPress-1 binding (error
	if no current focus item; reported on c.l.t.)

2008-01-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/ttk_*.n: Adjusted handling of the standard options part of the
	Ttk manual pages so that they are documented in the correct location.
	[Bug 1876493]

2008-01-28  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Re-fix strict-aliasing warnings reintroduced by
	last patch.

2008-01-27  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkNotebook.c: Make sure to schedule a redisplay when
	adding and/or hiding tabs. [Bug 1878298]

2008-01-27  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Merged common code from InitFont() and
	TkpGetFontAttrsForChar(), factored into GetTkFontAttributes() and
	GetTkFontMetrics(). Removed write-only struct UnixFtFont member
	'drawable'. Removed unneeded double-pointer indirections. Ensure that
	TkFontAttributes.family member is a Tk_Uid, as specified. Use
	FcTypeDouble for XFT_SIZE attribute. Finally: fix [Bug 1835848]

2008-01-25  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5.1 release.

2008-01-08  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkFrame.c: BUGFIX: fix crash in [ttk::labelframe] when
	-style option specified. [Bug 1867122]

2008-01-08  Joe English  <jenglish@users.sourceforge.net>

	* win/ttkWinTheme.c: Add tristate support to checkbuttons and
	radiobuttons. [Bug 1865898]
	Fix check and radio indicator size. [Bug 1679067]

2008-01-06  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkWidget.c, generic/ttk/ttkWidget.h: Call
	Tk_MakeWindowExist() in widget constructor. Removed now-unnecessary
	initial ConfigureNotify processing.

2008-01-06  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/treeview.tcl, library/ttk/utils.tcl: Fix MouseWheel
	bindings for ttk::treeview widget. [Bugs 1442006, 1821939, 1862692]

2008-01-02  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump version number to 8.5.1b1 to distinguish
	* library/tk.tcl:	CVS development snapshots from the 8.5.0 and
	* unix/configure.in:	8.5.1 releases.
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2007-12-30  Donal K. Fellows  <dkf@users.sf.net>

	* doc/canvas.n: Documented exact behaviour of items with respect to
	when they are the current item. [Bug 1774593] Also documented the
	clipping behaviour of window items.

	* library/demos/nl.msg: Corrected following testing "in the field" by
	Arjen Markus. [Bug 1860802]

2007-12-17  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	*** 8.5.0 TAGGED FOR RELEASE ***

	* doc/canvas.n: Documented -outlineoffset item option. [Bug 1836621]

2007-12-14  Don Porter  <dgp@users.sourceforge.net>

	* changes:	More updates for 8.5.0 release.

2007-12-14  Joe English  <jenglish@users.sourceforge.net>

	* doc/ttk_treeview.n: Fix typo. [Bug 1850713]

2007-12-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinInt.h:     Add in missing function definitions
	* win/tkWinButton.c:  to support plain MSVC6 and use INT_PTR
	* win/tkWinScrlBar.c: rather than LONG_PTR which isn'tr defined
	* win/tkWinWm.c:      in the msvc6 headers.

2007-12-14  Pat Thoyts <patthoyts@users.sourceforge.net>

	* win/nmakehlp.c:  Support compilation with MSVC9 for AMD64.
	* win/makefile.vc:

2007-12-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkMenubutton.c (ConfigureMenuButton): trace the
	-textvariable even if an image exists as it may use -compound.

2007-12-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkText.c (DeleteIndexRange, TextEditCmd, UpdateDirtyFlag):
	* tests/text.test (text-25.10.1,25.11.[12]):
	Don't require [update idle] to trigger Modified event [Bug 1809538]
	Modified virtual event should only fire on state change [Bug 1799782]
	Make sure we delete chars before triggering <<Modified>> [Bug 1737288]

2007-12-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (ApplyMasterOverrideChanges): Revert 2007-10-26
	change to window class of transient toplevels that are not also
	overrideredirect. [Bug 1845899]

	* macosx/tkMacOSXWm.c (ApplyMasterOverrideChanges): Implement more
	* macosx/tkMacOSXMouseEvent.c (BringWindowForward): X11-like transient
	* macosx/tkMacOSXSubwindows.c (XDestroyWindow):     behaviour by adding
	transient windows to a window group owned by the master window, this
	ensures transients always remain in front of and are collapsed with the
	master; bring master to front when selecting transient windows; restore
	default window group of transients if master destroyed. [Bug 1845899]

2007-12-12  Joe English  <jenglish@users.sourceforge.net>

	* doc/ttk_intro.n, doc/ttk_style.n, doc/ttk_widget.n:
	Various minor updates.

2007-12-12  Don Porter  <dgp@users.sourceforge.net>

	* changes:		Updated for 8.5.0 release.

2007-12-11  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTheme.c(StyleElementOptionsCmd):
	Use Ttk_GetElement() to find element instead of direct
	hash table access.

2007-12-11  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkText.c (TextReplaceCmd): Added code to rebuild the from
	index after the deletion phase so that the linePtr field is valid for
	the insertion phase. [Bug 1602537]

2007-12-10  Donal K. Fellows  <dkf@users.sf.net>

	* doc/event.n: Clarify the fact that [event info] only returns the
	names of virtual events that are bound to physical event sequences.
	This follows on from comments on comp.lang.tcl.
	http://groups.google.com/group/comp.lang.tcl/msg/935d2d226ae8a770

2007-12-10  Joe English  <jenglish@users.sourceforge.net>

	* doc/AddOption.3, doc/CrtImgType.3, doc/CrtPhImgFmt.3,
	* doc/InternAtom.3, doc/TextLayout.3, doc/chooseColor.n,
	* doc/chooseDirectory.n, doc/loadTk.n, doc/palette.n,
	* doc/ttk_combobox.n: Various markup fixes (mostly: missing quotes on
	.SH arguments, extraneous .PPs)

	* doc/ttk_entry.n, doc/ttk_scrollbar.n, doc/ttk_treeview.n: Remove
	extra .BEs that got added by mistake somewhere.

2007-12-10  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.decls:		use new genstubs 'export' command to
	* generic/tkInt.decls:		mark exported symbols not in stubs
					table [FR 1716117]; cleanup formatting

	* generic/tkIntDecls.h:		regen with new genStubs.tcl.
	* generic/tkIntPlatDecls.h:	[Tcl Bug 1834288]
	* generic/tkIntXlibDecls.h:
	* generic/tkPlatDecls.h:
	* generic/tkStubInit.c:

2007-12-10  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* tests/safe.test: Ensure list of hidden commands is correct. [Bug
	1847925]

2007-12-10  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWin.h: We must specify the lowest Windows version we intend to
	support. In particular the SystemParametersInfo API doesn't like to
	receive structures that are larger than it expects which affects the
	font assignements. Set to Win98 support.

	* win/tkWinFont.c: Handle failure to read the system parameters. This
	causes ttk/fonts.tcl to set any missing named fonts.

	* win/ttkWinMonitor.c:  Only tkWin.h should include windows.h unless
	* win/ttkWinTheme.c:    we have an explicit override of the WINVER
	* tin/ttkWinXPTheme.c:  macro.

	* win/rules.vc: Handle MSVC 9 (aka: Visual Studio 2008)

	* tests/safe.test: Update for 'unload' as a safe command (tcl 8.5b3+)

2007-12-09  Donal K. Fellows  <dkf@users.sf.net>

	* win/configure.in: Adjusted code so that running configure does not
	generate an error message when the full current directory name
	contains a space.

	* win/tkWinWm.c: Added set of #defs to make this file build with my
	version of the SDK (i.e. with the msys suite we distribute).

2007-12-07  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/altTheme.tcl, library/ttk/classicTheme.tcl:
	s/style/ttk::style/.

2007-12-07  Don Porter  <dgp@users.sourceforge.net>

	* unix/README:  Mention the stub library created by `make` and warn
	about the effect of embedded paths in the installed binaries. Thanks
	to Larry Virden. [Tcl Bug 1794084]

2007-12-05  Joe English  <jenglish@users.sourceforge.net>

	* macosx/ttkMacOSXTheme.c: Fix TCombobox layout so as not to truncate
	long text when combobox is wider than requested. [Bug 1845164]

2007-12-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/demos/widget: reduce start size to 70% of screenheight from
	sh-200 for a more reasonable size.

	* win/tkWinButton.c, win/tkWinDialog.c: use SetWindowLongPtr and
	* win/tkWinScrlbr.c, win/tkWinWm.c:     GetWindowLongPtr only.
	* win/ttkWinMonitor.c:

	* win/tkWinInt.h: remove CS_CLASSDC (not recommended for any apps now)
	* win/tkWinX.c:   and simplify WNDCLASS to one style.
	* win/tkWinWm.c:  Reduce wrapper update for exStyle to toolwindow
	change only and set WS_EX_LAYERED as sticky (once set on a window, do
	not remove it) to reduce alpha transition flicker.

	* win/configure, win/tcl.m4 (LIBS_GUI): mingw needs -lole32 -loleaut32
	but not msvc for Tk's [send]. [Bug 1844749]

2007-12-04  Joe English  <jenglish@users.sourceforge.net>

	* doc/ttk_style.n: Remove nonsense about "this manpage has not yet
	been written"; everything supported is documented.

2007-12-04  Donal K. Fellows  <dkf@users.sf.net>

	* library/msgs/en.msg: Added missing messages. [Patch 1800744]

	* library/msgs/da.msg: Added Danish messages. [Patch 1844143]. Many
	thanks to Torsten Berg <treincke@users.sf.net>.

2007-12-03  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure, win/tcl.m4 (LIBS_GUI): remove ole32.lib oleaut32.lib
	(LIBS): add ws2_32.lib for static builds with Tcl.

2007-12-01  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTheme.h, generic/ttk/ttkThemeInt.h,
	* generic/ttk/ttkTheme.c, generic/ttk/ttkLayout.c,
	* generic/ttk/ttkClamTheme.c, generic/ttk/ttkClassicTheme.c,
	* generic/ttk/ttkTreeview.c, macosx/ttkMacOSXTheme.c,
	* win/ttkWinTheme.c, win/ttkWinXPTheme.c: Improved macrology for
	statically-initialized layout template tables.

2007-11-28  Don Porter  <dgp@users.sourceforge.net>

	* unix/tkUnixPort.h:	When unix/configure determines whether the
	intptr_t type is available, it has the <inttypes.h> header present.
	It's only fair that we let Tk have it too.

2007-11-26  Kevin Kenny  <kennykb@acm.org>

	* generic/tkImgPPM.c (StringReadPPM): Corrected a comparison whose
	sense was reversed that resulted in reading beyond the end of the
	input buffer on malformed PPM data. [Bug 1822391]
	* library/tkfbox.tcl (VerifyFileName): Corrected a couple of typos in
	handling of bad file names. [Bug 1822076] Thanks to Christoph Bauer
	(fridolin@users.sf.net) for the patch.
	* tests/filebox.test (filebox-7.1, filebox-7.2): Added test cases that
	exercise. [Bug 1822076]
	* tests/imgPPM.test (imgPPM-4.1): Added test case that exercises. [Bug
	1822391]

2007-11-25  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkManager.h, generic/ttk/ttkManager.c,
	* generic/ttk/ttkFrame.c, generic/ttk/ttkNotebook.c,
	* generic/ttk/ttkPanedwindow.c:  Internal Ttk_Manager API updates;
	Fixed [Bug 1343984]; Added [$nb hide] method; [$nb add] on
	already-managed windows no longer throws an error, can be used to
	re-add a hidden tab.

	* doc/ttk_notebook.n, tests/ttk/notebook.test,
	* tests/ttk/panedwindow.test:  Updated docs and test suite.

2007-11-23  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* unix/README: General improvements.

2007-11-21  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/tkfbox.tcl: Better theming in the file list area.

2007-11-19  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5b3 TAGGED FOR RELEASE ***

	* README:		Bump version number to 8.5b3.
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

	* changes:		Update changes for 8.5b3 release.

2007-11-19  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/ttk/ttkTheme.c:	Fix crash when 'style element create'
	* tests/ttk/ttk.test:		called w/ insufficient args; add tests.

2007-11-18  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkElements.c, macosx/ttkMacOSXTheme.c: Add "fill"
	element: like "background" but only erases parcel.

	* generic/ttk/ttkFrame.c: Use fill element in Labelframe Label
	sublayout.  Also improved default labelmargins for -labelanchor w*, e*.

	* generic/ttk/ttkLabel.c: no longer need Labelframe hack.

	* library/ttk/aquaTheme.tcl: ImageTextElement no longer needed.
	TextElement no longer needs '-background' option.

	* generic/ttk/ttkFrame.c: Use sublayout for ttk::labelframe labels
	instead of single element.

	* generic/ttk/ttkLabel.c: Default -anchor for text and label elements
	is now "w" instead of "center". [Bug 1614540]

	* library/ttk/defaults.tcl, library/ttk/*Theme.tcl: Button styles now
	need explicit "-anchor center".

	* generic/ttk/ttkLayout.c (TTKInitPadding): BUGFIX:
	Ttk_GetPaddingFromObj() and Ttk_GetBorderFromObj() returned garbage
	when passed an empty list.

	* macosx/ttkMacOSXTheme.c: Resynchronize with Tile codebase so that
	patches can flow back and forth.

	* library/ttk/aquaTheme.tcl: Extra TButton -padding no longer needed.

2007-11-18  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/ttkWinXPTheme.c: Add support for size information flags for
	scrollbar and combobox buttons. This handles Tile [Patches 1596647 and
	1596657] but a bit more generically.

2007-11-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/(tkArgv.c, tkBind.c, tkCipboard.c, tkEntry.c, tkOption.c,
	tkScale.c, tkScrollbar.c, tkTextImage.c, tkVisual.c, tkWindow.c): Tidy
	up some variable types.

	* generic/tkFont.c:	Only check for -displayof if there are
	* test/font.test:	sufficient arguments. This permits checking
				strings like -d.

2007-11-17  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/scrollbar.tcl: Swap in core scrollbars for
	[ttk::scrollbar]s on OSX.

2007-11-16  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c (TkpMeasureCharsInContext): Correct an
	oversight in the bug fix from 2007-11-11. [Bug 1824638]

2007-11-15  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj: add new chanio.test.
	* macosx/Wish.xcode/project.pbxproj:

2007-11-14  Donal K. Fellows  <dkf@users.sf.net>

	* library/msgs/sv.msg: Get the locale declared within the message
	catalog correct! [Bug 1831803]

2007-11-11  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c (TkpMeasureCharsInContext): Fix the case when
	TK_WHOLE_WORDS and TK_AT_LEAST_ONE are both set and maxLength is small.
	[Bug 1824638]

2007-11-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXCarbonEvents.c
	(InstallStandardApplicationEventHandler): on Mac OS X Leopard, replace
	the 2005-11-27 approach of installing the standard application handler
	by calling RAEL and immediately longjmping out of it from an event
	handler, as that now leads to crashes in -[NSView unlockFocus] whenever
	HIToolbox uses Cocoa in Leopard (Help menu, Nav Services, Color
	Picker). Instead call InstallStandardEventHandler() on the application
	and menubar event targets, as Leopard ISEH finally handles these
	correctly. Unfortunately need a HIToolbox-internal SPI to retrieve the
	menubar event target, no public API appears have that functionality.

	* macosx/tkMacOSXDebug.c:	make TkMacOSXInitNamedDebugSymbol()
	* macosx/tkMacOSXDebug.h:	available outside of debug builds as
					the new Leopard ISAEH needs it.

	* macosx/tkMacOSXButton.c:	replace HiliteControl() by modern API
	* macosx/tkMacOSXMenubutton.c:	for activation and enabling;
					distinguish inactive and disabled
					look&feel; correct activation handling
					to match that of container toplevel.

	* macosx/tkMacOSXMenubutton.c:	correct size computation of bevelbutton
					variant to match that of buttons;
					fix crash with bitmap due to NULL GC;
					delay picParams setup until needed;
					formatting cleanup. [Bug 1824521]

	* library/menu.tcl:		correct handling of menubutton "active"
					state on Aqua to match that of buttons.

	* macosx/tkMacOSXDefault.h:	correct button & menubutton active
					foreground and background colors and
					menubutton border width.

	* macosx/tkMacOSXWindowEvent.c:	handle kEventWindowExpanding carbon
	* macosx/tkMacOSXCarbonEvents.c: event instead of kEventWindowExpanded
					to ensure activate event arrives after
					window is remapped, also need to
					process all Tk events generated by
					remapping in the event handler to
					ensure children are remapped before
					activate event is processed.

	* macosx/tkMacOSXSubwindows.c:	add pixmap size field to MacDrawable
	* macosx/tkMacOSXInt.h:		struct; add flag for B&W pixmaps.
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXMenu.c:

	* macosx/tkMacOSXPrivate.h:	correct Leopard HIToolboxVersionNumber.

	* macosx/ttkMacOSXTheme.c:	add error checking; cleanup formatting.

	* macosx/tkMacOSXFont.c (TkpGetFontAttrsForChar): panic on false return
					from TkMacOSXSetupDrawingContext().

	* macosx/tkMacOSXButton.c:	sync formatting, whitespace, copyright
	* macosx/tkMacOSXDialog.c:	with core-8-4-branch.
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXWm.c:
	* xlib/xgc.c
	* library/bgerror.tcl:
	* library/console.tcl:
	* library/menu.tcl:

2007-11-07  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTheme.c (Ttk_ElementSize): Fixed longstanding,
	subtle bug that caused element padding to sometimes be counted
	twice in size computations.

	* generic/ttk/ttkElements.c, generic/ttk/ttkClamTheme.c,
	generic/ttk/ttkDefaultTheme.c, generic/ttk/ttkTreeview.c,
	generic/ttk/ttkImage.c, macosx/ttkMacOSXTheme.c,
	win/ttkWinTheme.c, win/ttkWinXPTheme.c:	Fix ElementSizeProcs affected
						 by previous change.

2007-11-06  Andreas Kupries  <andreask@activestate.com>

	* doc/CrtConsoleChan.3: Fixed markup typo and extended see also
	  section per suggestions by Donal.

2007-11-05  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl: Set focus to listbox in <Map> binding
	instead of in Post command (see [Bug 1349811] for info).

2007-11-05  Andreas Kupries  <andreask@activestate.com>

	* doc/CrtConsoleChan.3: New file providing minimal documentation
	  of 'Tk_InitConsoleChannels()'. [Bug 432435]

2007-11-05  Joe English  <jenglish@users.sourceforge.net>

	* macosx/ttkMacOSXTheme.c (TreeitemLayout): Remove focus ring
	from treeview items on OSX (problem reported by Kevin Walzer).

2007-11-04  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c: Use null "treearea" element for
	treeview owner-draw area instead of "client", to avoid
	nameclash with Notebook.client element (this was causing
	sizing anomalies in XP theme, and introduced extraneous
	padding).
	* generic/ttk/ttkDefaultTheme.c: Treeitem.indicator element
	needs left margin now.

2007-11-04  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMenus.c: add "Run Widget Demo" menu item to the
	default Edit menu along with associated carbon event handler enabling
	the item only if demo files are installed; cleanup handling of "About"
	and "Source" menu items.

	* library/bgerror.tcl:		fix background of detail text on Aqua.

	* library/console.tcl:		add accelerators and fix Aqua bindings
					of the new font size menu items.

	* library/demos/mclist.tcl:	Aqua GOOBE.
	* library/demos/tree.tcl:
	* library/demos/ttknote.tcl:
	* library/demos/widget:

	* doc/chooseDirectory.n:	remove/correct obsolete Mac OS 9-era
	* doc/getOpenFile.n:		information.
	* doc/menu.n:

	* macosx/tkMacOSXEvent.c (TkMacOSXProcessCommandEvent): fix boolean arg

	* macosx/Wish.xcodeproj/project.pbxproj: add new demo file.
	* macosx/Wish.xcode/project.pbxproj:

2007-11-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/console.tcl: Add menu item and key binding to adjust font.

2007-11-02  Donal K. Fellows  <dkf@users.sf.net>

	* library/demos/mclist.tcl: Added a demo of how to do a multi-column
	sortable listbox.

	* library/msgbox.tcl: Made message dialog use Ttk widgets for better
	L&F.

	* library/tkfbox.tcl (::tk::dialog::file::CompleteEnt): Added <Tab>
	completion. [FR 805091]
	* library/tkfbox.tcl: Made file dialog use Ttk widgets for better L&F.

	* library/demos/sayings.tcl: Better resizing. [Bug 1822410]

2007-11-01  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/textpeer.tcl: Better resizing. [Bug 1822601]

	* doc/colors.n: Added list of Windows system colors. [Bug 945409]

2007-11-01  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXColor.c (GetThemeColor): improve translation of RGB
				pixel values into RGBColor.

	* library/demos/widget:	increase height of main window text widget to
				use more of the available vertical space.

	* doc/bind.n:		document the Option modifier, clarify meaning
				and availability of Command & Option.

	* doc/console.n:	clarify availability of [console] in TkAqua.

2007-11-01  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* unix/installManPage, doc/*.n: Make documentation use the name that
	scripts use as much as possible. [Bug 1640073]

	* doc/text.n: Fixed mistake in [$t tag remove] docs. [Bug 1792191]

	* doc/bind.n: Documented the Command modifier. [Bug 1232908]

	* doc/console.n, doc/wish.1: Made it clearer when and why the console
	command is present. [Bug 1386955]

2007-10-31  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/entry3.tcl: Improved description/comments so that
	people better understand what is being validated, following suggestion
	from Don Porter.

	* library/demos/image2.tcl (loadImage): Mark non-loadable images
	as such instead of throwing a nasty dialog, following suggestion
	from Don Porter.

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock): More optimization, derived
	from [Patch 224066].

2007-10-30  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl (Unpost): BUGFIX: Unpost can be called with
	no preceding Post.

2007-10-31  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/rules.vc:     Use -fp:strict with msvc8 as -fp:precise fails on
	* generic/tkObj.c:  amd64 builds. Fix the two places in Tk that
	* generic/tkTrig.c: generate errors with msvc8 when using this flag.

2007-10-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/choosedir.tcl: only enable OK button when valid in
	conjunction with -mustexist. [Bug 1550528]

	* library/listbox.tcl (::tk::ListboxBeginSelect): ignore -takefocus
	when considering focus on <1>, it is for tab focus.

2007-10-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h:		Bump version number to 8.5b2.1 to distinguish
	* library/tk.tcl:	CVS development snapshots from the 8.5b2
	* unix/configure.in:	release.
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2007-10-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/text.n: fix spelling of -inactiveselectbackground [Bug 1626415]

	* library/entry.tcl: don't error with Clear event. [Bug 1509288]

	* library/ttk/fonts.tcl: use size -12 TkFixedFont (was -10) on X11

2007-10-30  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/unicodeout.tcl: Fixed Arabic and Hebrew rendering on
	Windows. [Bug 1803723]

	* generic/tkImgPhoto.c (ImgPhotoCmd): Rename enumeration for somewhat
	simpler-to-read code. [Bug 1677613]

2007-10-30  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkWidget.c: Split up RedisplayWidget() to factor out
	double-buffering related code.

	* macosx/ttkMacOSXAquaTheme.c: Use SetThemeBackGround/
	kThemeBrushModelessDialogBackground{Active|Inactive} instead of
	ApplyThemeBackground/kThemeBackgroundWindowHeader (advice from DAS).

	* library/ttk/aquaTheme.tcl: Use darker shade for inactive and
	disabled text, to match typical values of most
	kThemeXXXTextColorInactive values.

2007-10-30  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/selection.n: Clarify UTF8_STRING handling. [Bug 1778563]

	* doc/text.n: Clarify search subccommand docs. [Bug 1622919]

2007-10-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXFont.c (InitSystemFonts):
	* library/ttk/fonts.tcl: use Monaco 11 (was 9) as Aqua TkFixedFont

	* tests/listbox.test, tests/panedwindow.test, tests/scrollbar.test:
	* library/bgerror.tcl, library/dialog.tcl, library/listbox.tcl:
	* library/msgbox.tcl, library/optMenu.tcl, library/tclIndex:
	* library/tkfbox.tcl, library/demos/floor.tcl, library/demos/rmt:
	* library/demos/tcolor, library/demos/text.tcl:
	* library/demos/twind.tcl, library/demos/widget: Buh-bye Motif look
	* library/ttk/fonts.tcl:    Update of Tk default look in 8.5
	* macosx/tkMacOSXDefault.h: Trims border sizes, cleaner X11 look
	* unix/tkUnixDefault.h:     with minor modifications for Win32/Aqua.
	* win/tkWinDefault.h:       Uses Tk*Font definitions throughout for
	* win/tkWinFont.c:          classic widgets. [Bug 1820344]
	* library/obsolete.tcl (::tk::classic::restore): This restores
	changes made to defaults in 8.5 using the 'option' command,
	segmented into logical groups.

	* tests/winfo.test: winfo-4.5 raise .t to above . for Windows

	* tests/unixWm.test: note TIP#142 results and remove unnecessary
	catches.

2007-10-29  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/*.1, doc/*.n, doc/*.3: Lots more GOOBE work.

2007-10-28  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl: Make popdown window [wm resizable 0 0] on
	OSX, to prevent TkAqua from shrinking the scrollbar to make room for a
	grow box that isn't there.
	* macosx/ttkMacOSXTheme.c, library/ttk/aquaTheme.tcl: Reworked
	combobox layout.

2007-10-26  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5b2 TAGGED FOR RELEASE ***

	* changes:		Update changes for 8.5b2 release.

	* doc/*.1:              Revert doc changes that broke
	* doc/*.3:              `make html` so we can get the release
	* doc/*.n:              out the door.

	* README:		Bump version number to 8.5b2.
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

2007-10-26  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (ApplyMasterOverrideChanges): fix window class
	of transient toplevels that are not also overrideredirect. [Bug
	1816252]

	* macosx/tkMacOSXDialog.c:	TIP#242 cleanup.
	* library/demos/filebox.tcl: 	demo TIP#242 -typevariable.

2007-10-25  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkNotebook.c: [Bug 1817596]

2007-10-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/getOpenFile.n:	TIP#242 implementation of -typevariable to
	* library/tkfbox.tcl:	return type of selected file in file dialogs.
	* library/xmfbox.tcl:	[Bug 1156388]
	* macosx/tkMacOSXDialog.c:
	* tests/filebox.test:
	* tests/winDialog.test:
	* win/tkWinDialog.c:

2007-10-25  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkPlace.c:	Prevent segfault in place geometry manager.
	Thanks to Colin McDonald.  [Bug 1818491]

2007-10-24  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/*.c, win/{ttkWinMonitor,ttkWinTheme,ttkWinXPTheme}.c,
	* macosx/ttkMacOSXTheme.c: Move widget layout registration
	from TtkElements_Init() to widget *_Init() routines.
	Renaming/consistency: s/...ElementGeometry()/...ElementSize()/

2007-10-24  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/*.n, doc/*.3, doc/*.1: Lots of changes to take advantage of the
	new macros.

2007-10-24  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinDraw.c: Applied [Patch 1723362] for transparent bitmaps.

	* generic/tkWindow.c: permit wm manage of any widget (esp: ttk::frame)

2007-10-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/ttk/combobox.tcl (ttk::combobox::PopdownWindow): redo wm
	transient on each drop to handle reparent-able frames. [Bug 1818441]

2007-10-23  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl: [namespace import ::ttk::scrollbar]
	doesn't work, since ttk::scrollbar isn't [namespace export]ed.

2007-10-23  Don Porter  <dgp@users.sourceforge.net>

	* tests/cursor.test:	Make tests robust against changes in Tcl's
	rules for accepting integers in octal format.

2007-10-23  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* doc/font.n: Added section on the TIP#145 fonts.

2007-10-23  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinFont.c: Fixed leak in CreateNamedFont spotted by das.

2007-10-23  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/combo.tcl:	Aqua GOOBE.
	* library/demos/toolbar.tcl:
	* library/demos/tree.tcl:
	* library/demos/ttknote.tcl:
	* library/demos/ttkprogress.tcl:
	* library/demos/widget:

	* macosx/Wish.xcodeproj/project.pbxproj: add new demo files.
	* macosx/Wish.xcode/project.pbxproj:

2007-10-22  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/widget: Added more demos, reorganized to make Tk and
	Ttk demos seem to be more coherent whole. Made localization a bit
	easier by reducing the amount of duplication.
	* library/demos/{combo,toolbar,tree,ttknote,ttkprogress}.tcl: New
	demos of new (mostly) Ttk widgets.
	* library/demos/ttkbut.tcl: Improvements.

2007-10-22  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl:	ttk::combobox overhaul; fixes [Bugs
					1814778, 1780286, 1609168, 1349586]
	* library/ttk/aquaTheme.tcl:	Factored out aqua-specific combobox
					-postposition adjustments.
	* generic/ttk/ttkTrack.c:	Detect [grab]s and unpress pressed
					element; combobox workaround no longer
					needed.

2007-10-22  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXFont.c: 	register named fonts for TIP #145 fonts
					and all theme font IDs.

	* generic/tkFont.c (Tk{Create,Delete}NamedFont): allow NULL interp.

	* library/ttk/fonts.tcl:	check for TIP #145 fonts on all
					platforms; correct aqua font sizes.

	* library/demos/ttkmenu.tcl:	Aqua GOOBE.
	* library/demos/ttkpane.tcl:
	* library/demos/widget:

	* macosx/Wish.xcodeproj/project.pbxproj: add new demo files.
	* macosx/Wish.xcode/project.pbxproj:

2007-10-18  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/ttkmenu.tcl: Added more demos of Ttk widgets. These
	* library/demos/ttkpane.tcl: ones are of menubuttons, panedwindows and
	a progress bar (indirectly).

2007-10-18  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/ttk/fonts.tcl: Create all the TIP #145 font names on all
	platforms (mac and unix get handled in script, windows in C)

2007-10-17  David Gravereaux <davygrvy@pobox.com>

	* bitmaps/*.xbm: Changed CVS storage mode from -kb to -kkv as these
	are really text files, not binaries.
	* win/makefile.vc: Added $(BITMAPDIR) to the search path for the
	depend target.

2007-10-18  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/widget:		Aqua GOOBE, cleanup icons.
	* library/demos/ttkbut.tcl:
	* library/demos/entry3.tcl:
	* library/demos/msgbox.tcl:

	* library/demos/button.tcl:	restore setting of button
					highlightbackground on Aqua.

	* macosx/ttkMacOSXTheme.c: 	adjust button and separator geometry.

	* macosx/tkMacOSXWm.c:		fix warnings.

	* macosx/Wish.xcodeproj/project.pbxproj: add new demo files.
	* macosx/Wish.xcode/project.pbxproj:

2007-10-17  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/ttkbut.tcl: Added demo of the basic Ttk widgets.

2007-10-16  David Gravereaux <davygrvy@pobox.com>

	* win/makefile.vc: depend target now works and builds a generated
	dependency list with $(TCLTOOLSDIR)/mkdepend.tcl

2007-10-16  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/widget: Made the code for generating the contents of
	the main widget more informative. Added 'new' flagging for wholly new
	demos.

	* doc/text.n: Made it clearer what things are text widget invokations
	and what are not. Also some other clarity improvements.

2007-10-15  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/demos/widget: Use Ttk widgets for the widget demo core, for
	vastly improved look-and-feel on at least one platform (Windows).
	* library/demos/{button,check,style,twind}.tcl: Various tweaks for
	GOOBE...
	* library/demos/textpeer.tcl: New demo script to show off peering as a
	specific feature.

2007-10-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkFocus.c, generic/tkFrame.c, generic/tkInt.h:
	* macosx/tkMacOSXButton.c, macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXWm.c, unix/tkUnixWm.c, win/tkWinWm.c:
	* doc/wm.n, tests/wm.test: TIP #125 implementation [Bug 998125]
	Adds [wm manage|forget] for dockable frames.
	Finished X11 and Windows code, needs OS X completion.

2007-10-15  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c: Store pointer to column table entry
	instead of column index in columnNames hash table. This avoids the
	need for the evil PTR2INT and INT2PTR macros, and simplifies things a
	bit.

2007-10-15  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkArgv.c:		Fix gcc warnings about 'cast to/from
	* generic/tkCanvUtil.c:		pointer from/to integer of different
	* generic/tkCanvas.c:		size' on 64-bit platforms by casting
	* generic/tkCursor.c:		to intermediate types
	* generic/tkInt.h:		intptr_t/uintptr_t via new PTR2INT(),
	* generic/tkListbox.c:		INT2PTR(), PTR2UINT() and UINT2PTR()
	* generic/tkObj.c:		macros.
	* generic/tkStyle.c:
	* generic/tkTextIndex.c:
	* generic/tkUtil.c:
	* generic/ttk/ttkTheme.h:
	* generic/ttk/ttkTreeview.c:
	* unix/tkUnixMenu.c:
	* unix/configure.in:

	* unix/configure:		autoconf-2.59
	* unix/tkConfig.h.in:		autoheader-2.59

	* macosx/Wish-Common.xcconfig:		add 'tktest-X11' target.
	* macosx/Wish.xcode/project.pbxproj:
	* macosx/Wish.xcode/default.pbxuser:
	* macosx/Wish.xcodeproj/default.pbxuser:
	* macosx/Wish.xcodeproj/project.pbxproj:

	* unix/configure.in (Darwin):	add support for 64-bit X11.
	* unix/configure:		autoconf-2.59

2007-10-14  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/configure, win/configure.in (TK_WIN_VERSION): Make sure the
	patchlevel doesn't contain extra dotted pairs (eg. interim release)

2007-10-12  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc:  Mine all version information from headers.
	* win/rules.vc:     Sync tcl and tk and bring extension versions
	* win/nmakehlp.c:   closer together. Try and avoid using tclsh
	                    to do substitutions as we may cross compile.

	* library/console.tcl:          Use TkFixedFont and ttk widgets

2007-10-12  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c:	replace all (internal) use of QD region
	* macosx/tkMacOSXSubwindows.c:	API by HIShape API, with conversion to
	* macosx/tkMacOSXWindowEvent.c:	QD regions only when required by legacy
	* macosx/tkMacOSXPrivate.h:	Carbon or Tk API.
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:

	* macosx/tkMacOSXInt.h:		replace MacDrawable's QD RgnHandles
	* macosx/tkMacOSXEmbed.c:	clipRgn, aboveClipRgn & drawRgn by
	* macosx/tkMacOSXMenu.c:	HIShapeRefs visRgn & aboveVisRgn and
	* macosx/tkMacOSXSubwindows.c:	CGRect drawRect.

	* macosx/tkMacOSXWindowEvent.c:	remove use of QD port vis rgn in window
	* macosx/tkMacOSXSubwindows.c:	update rgn calculation, manually excise
	* macosx/tkMacOSXWm.c:		growbox from toplevel clip rgn instead.

	* macosx/tkMacOSXDraw.c:	replace use of QD port clip rgn by new
	* macosx/tkMacOSXPrivate.h:	clipRgn fld in TkMacOSXDrawingContext;
					handle QD/CG drawing mismatches in
					XCopyArea, XCopyPlane and TkPutImage;
					cleanup/speedup CGContext setup in
					TkMacOSXSetupDrawingContext().

	* macosx/tkMacOSXDraw.c:	change TkMacOSXSetupDrawingContext() to
	* macosx/tkMacOSXEntry.c:	return boolean indicating whether
	* macosx/tkMacOSXFont.c:	drawing is allowed (and was setup) or
	* macosx/tkMacOSXMenu.c:	not (e.g. when clipRgn is empty).
	* macosx/ttkMacOSXTheme.c:

	* macosx/tkMacOSXSubwindows.c:	signal that drawable is a pixmap via
	* macosx/tkMacOSXInt.h:		new explicit TK_IS_PIXMAP flag instead
					of a NULL cligRgn field.

	* macosx/tkMacOSXRegion.c:	add wrappers for missing/buggy HIShape
	* macosx/tkMacOSXPrivate.h:	API, and private helpers to operate on
					HIShapeRefs & convert to/from TkRegion.

	* macosx/tkMacOSXRegion.c:	add Tkp{Retain,Release}Region() API for
	* macosx/tkMacOSXInt.h:		TkRegion.

	* xlib/xgc.c:			factor out alloc/free of GC clip_mask;
	* macosx/tkMacOSXXStubs.c:	manage clip rgn lifetime with new
					Tkp{Retain,Release}Region().

	* macosx/tkMacOSXButton.c:	delay picParams setup until needed.

	* generic/tkTextDisp.c (CharUndisplayProc): fix textDisp.test crash.

2007-10-11  David Gravereaux <davygrvy@pobox.com>

	* win/winMain.c:  Replaced incorrect comments in main() to descibe
	why the console widget does not need to be created for this
	application entry point (if used).  Must have been a bad copy/paste
	of WinMain() from 10 years back.

2007-10-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkMacOSXGrowToplevel): manually constrain resize
	limitBounds to maxBounds, works around SectRect() mis-feature (return
	zero rect if input rect has zero height/width). [Bug 1810818]

2007-10-09  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkImage.c:     Make Ttk_GetImage safe if called with NULL
	* tests/ttk/image.test:  interp. Added some tests that crash
	                         on Windows without this fix.

2007-10-02  Don Porter  <dgp@users.sourceforge.net>

	[core-stabilizer-branch]

	* README:               Bump version number to 8.5.0
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:	Updated LOCALES.
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf (2.59)
	* win/configure:

2007-09-30  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/entry.tcl (WordBack, WordForward):
	Fix private routines accidentally defined in global namespace
	[Bug 1803836]

2007-09-26  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/msgs/hu.msg: Added Hungarian message set, from Pader Reszo.
	[Patch 1800742]

2007-09-20  Donal K. Fellows  <dkf@users.sf.net>

	*** 8.5b1 TAGGED FOR RELEASE ***

	* generic/tkTextDisp.c (LayoutDLine):  Only call callbacks that are
	* tests/textDisp.test (textDisp-32.3): not NULL. [Bug 1791052]

2007-09-20  Don Porter  <dgp@users.sourceforge.net>

	* changes: updates for 8.5b1 release.

2007-09-19  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.5b1.
	* generic/tk.h:		Merge from core-stabilizer-branch.
	* library/tk.tcl:	Stabilizing toward 8.5b1 release now done
	* unix/configure.in:	on the HEAD.  core-stabilizer-branch is
	* unix/tk.spec:		now suspended.
	* win/configure.in:

2007-09-19  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkStubLib.: Replaced isdigit with internal implementation.

2007-09-18  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkStubLib.c:	Remove C library calls from Tk_InitStubs()
	* win/makefile.vc:	so that we don't need the C library linked
	in to libtkStub.

2007-09-18  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkImgGIF.c (FileReadGIF, StringReadGIF): Rewrite for greater
	clarity (more comments, saner code arrangement, etc.)

2007-09-18  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/all.tcl:     Made ttk/all.tcl be the same as tk's all.tcl and
	* tests/ttk/all.tcl: make use of file normalize (bugs noted by
	mjanssen and GPS with msys)

2007-09-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc: Add crt flags for tkStubLib now it uses C-library
	functions.

2007-09-17  Joe English  <jenglish@users.sourceforge.net>

	* unix/tcl.m4: use '${CC} -shared' instead of 'ld -Bshareable' to
	build shared libraries on current NetBSDs. [Bug 1749251]
	* unix/configure: regenerated (autoconf-2.59).

2007-09-17  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Revised callers of Tcl_InitStubs() to account
	* generic/tkMain.c:	for restored compatible support for the call
	* generic/tkWindow.c:	Tcl_InitStubs(interp, TCL_VERSION, 1).  Also
	revised Tcl_PkgRequire() call for Tcl so that, for example, a Tk
	library built against Tcl 8.5.1 headers will not refuse to [load] into
	a Tcl 8.5.0 interpreter. [Tcl Bug 1578344]

	* generic/tk.h:		Revised Tk_InitStubs() to restore Tk 8.4
	* generic/tkStubLib.c:	source compatibility with callers of
	* generic/tkWindow.c:	Tk_InitStubs(interp, TK_VERSION, 1).

2007-09-17  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl:  Try to improve combobox appearance on
	OSX + Tk 8.5. [Bug 1780286]

2007-09-15  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: 	replace all direct references to compiler by ${CC} to
			enable CC overriding at configure & make time; run
			check for visibility "hidden" with all compilers;
			quoting fixes from TEA tcl.m4.
	(SunOS-5.1x):	replace direct use of '/usr/ccs/bin/ld' in SHLIB_LD by
			'cc' compiler driver.
	* unix/configure: autoconf-2.59

2007-09-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish-Common.xcconfig:		  enable Tcl DTrace support.
	* macosx/Wish.xcodeproj/project.pbxproj:

2007-09-12  Andreas Kupries  <andreask@activestate.com>

	* win/Makefile.in (install-binaries): Fixed missing brace in the
	* win/makefile.vc (install-binaries): generated package index file.
	Note: unix/Makefile.in is good.

2007-09-11  Reinhard Max  <max@suse.de>

	* generic/tkImgGIF.c: Fixed a buffer overrun that got triggered by
	multi-frame interlaced GIFs that contain subsequent frames that are
	smaller than the first one.

	* tests/imgPhoto.test: Added a test for the above.

2007-09-11  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Revised calls to Tcl_InitStubs() and
	* generic/tkMain.c:	[package require Tcl] so that Tk Says What It
	* generic/tkWindow.c:	Means using the new facilties of [package] in
	* library/tk.tcl:	Tcl 8.5 about what version(s) of Tcl it is
	* unix/Makefile.in:	willing to work with. [Bug 1578344]
	* win/Makefile.in:
	* win/makefile.vc:

2007-09-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/README: typo corrections [Bug 1788682]

2007-09-10  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Revise all Tcl_InitStubs() calls to restore
	* generic/tkMain.c:	the traditional practice that a Tk shared
	* generic/tkWindow.c:	library may [load] into a Tcl 8.5 interp at
	any patchlevel.	 This practice also matches the compile time checks of
	TCL_MAJOR_VERSION and TCL_MINOR_VERSION in tk.h. [Bug 1723622]

2007-09-06  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkWindow.c (Initialize):	Moved common Tk initialization
	* generic/tkInitScript.h (removed):	script out of tkInitScript.h
	* macosx/tkMacOSXInit.c:	and multiple TkpInit() routines and
	* unix/Makefile.in:	into the common Initialize() routine in
	* unix/tkUnixInit.c:	generic code. Also removed constraint on
	* win/tkWinInit.c:	ability to define a custom [tkInit] before
	calling Tk_Init(). Until now the custom [tkInit] had to be a proc. Now
	it can be any command. Removal of tkInitScript.h also fixes [Bug
	1656283].

2007-09-06  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcode/project.pbxproj: discontinue unmaintained support
	* macosx/Wish.xcode/default.pbxuser: for Xcode 1.5; replace by Xcode2
	project for use on Tiger (with Wish.xcodeproj to be used on Leopard).

	* macosx/Wish.xcodeproj/project.pbxproj: updates for Xcode 2.5 and 3.0.
	* macosx/Wish.xcodeproj/default.pbxuser:
	* macosx/Wish.xcode/project.pbxproj:
	* macosx/Wish.xcode/default.pbxuser:
	* macosx/Wish-Common.xcconfig:

	* macosx/README: document project changes.

2007-09-04  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkTest.c: Fix for [Bug 1788019] "tkTest.c compiler warning".

2007-09-04  Don Porter  <dgp@users.sourceforge.net>

	* unix/Makefile.in:     It's unreliable to count on the release
	manager to remember to `make genstubs` before `make dist`. Let the
	Makefile remember the dependency for us.

	* unix/Makefile.in:     Corrections to `make dist` dependencies to be
	sure that macosx/configure gets generated whenever it does not exist.

2007-09-03  Daniel Steffen  <das@users.sourceforge.net>

	* generic/ttk/ttkInit.c  (Ttk_Init): register ttk in package database
	to enable extension access to the ttkStubs table.

	* generic/ttk/ttkDecls.h: correct capitalization of ttk package name.

2007-08-28  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	Assorted documentation improvements.
	* doc/button.n: Added examples.
	* doc/checkbutton.n: Added example.
	* doc/console.n: Standardized section ordering.
	* doc/tk.n: Added "See also".
	* doc/ttk_combobox.n: Added keywords.

2007-08-27  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (Tk_ChooseColorObjCmd): correct setting of
	interp result [Bug 1782105]; fix -initialcolor overwriting last color
	selection; style cleanup.

2007-08-21  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/rules.vc: Synchronize with tcl rules.vc
	* tests/all.tcl: Fix the line-endings.

2007-08-07  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in:	Add support for compile flags specific to
				object files linked directly into executables.

	* unix/configure.in (Darwin): Only use -seg1addr flag when prebinding;
	use -mdynamic-no-pic flag for object files linked directly into exes.

	* unix/configure: autoconf-2.59

2007-08-01  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinDialog.c:    Fix [Bug 1692927] (buffer length problems)
	* win/tkWinTest.c:      Added 'testfindwindow' and 'testgetwindowinfo'
	and extended 'testwinevent' for WM_COMMAND support to enable testing
	native messagebox dialogs.
	* tests/winMsgbox.test: New Windows native messagebox tests.

2007-07-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (NavServicesGetFile): Reset interp result on
	nav dialog cancel. [Bug 1743786]

2007-07-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in: clarify what the headers installed are, and
	add ttkTheme.h and ttkDecls.h to private headers (later public).

2007-07-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (Tk_MacOSXIsAppInFront):	Use process mgr
	* macosx/tkMacOSXMouseEvent.c:				to determine if
	app is in front instead of relying on activate/deactivate events (which
	may arrive after this info is needed, e.g. during window drag/click
	activation); replace other process mgr use to get this info with calls
	to Tk_MacOSXIsAppInFront().

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): Correct
	window click activation, titlebar click handling and background window
	dragging/growing in the presence of grabs or window-/app-modal windows;
	fix window click activation bringing all other app windows to front.

	* macosx/tkMacOSXDraw.c (TkPutImage): Handle non-native XImage byte and
	bit orders; reverse bits via xBitReverseTable instead of InvertByte().

2007-07-06  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/aquaTheme.tcl:	Set -anchor w for TMenubuttons.
					[Bug 1614540]

2007-07-04  Andreas Kupries  <andreask@activestate.com>

	* macosx/tkMacOSXXStubs.c (DestroyImage): Fixed seg.fault in release
	of image data for images coming from XGetImage. Change committed by me
	for Daniel Steffen. See 2007-06-23 for the change which introduced the
	problem.

2007-07-02  Daniel Steffen  <das@users.sourceforge.net>

	* xlib/xgc.c (XCreateGC): Correct black and white pixel values used to
	initialize GC foregrund and background fields.

	* macosx/tkMacOSXColor.c: Add debug messages for unknown pixel values.

	* macosx/tkMacOSXDraw.c (TkMacOSXRestoreDrawingContext): Don't restore
	port state if it wasn't altered by TkMacOSXSetupDrawingContext().

2007-06-29  Daniel Steffen  <das@users.sourceforge.net>

	* xlib/ximage.c:		Bitmaps created from the static .xbm
					arrays always have LSBFirst bit order.

	* unix/configure.in:		Fix flag used to weak-link libXss.
	* unix/configure:		autoconf-2.59

	* macosx/tkMacOSXScrlbr.c: Correct int <-> dobule conversion issues
	that could lead to Carbon getting confused about scrollbar thumb size.

	* macosx/tkMacOSXDraw.c (XCopyArea, XCopyPlane, TkPutImage): Use
	TkMacOSX{Setup,Restore}DrawingContext() to setup/restore clip & colors.
	(TkMacOSXSetupDrawingContext, TkMacOSXRestoreDrawingContext): Add save
	and restore of QD port clip region; factor out clip region code common
	to CG and QD branches; check for port and context validity; handle
	tkPictureIsOpen flag during QD port setup.
	(TkScrollWindow): Remove unnecessary scroll region manipulation

	* macosx/tkMacOSXDraw.c:	Remove second global QD temp region
	* macosx/tkMacOSXInt.h:		(no longer necessary) and rename
	* macosx/tkMacOSXRegion.c:	remaining global QD temp region.
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:

	* macosx/tkMacOSXDraw.c: 	Make useCGDrawing variable MODULE_SCOPE
	* macosx/tkMacOSXFont.c: 	and respect it for ATSUI font drawing.

	* macosx/tkMacOSXButton.c:	Reduce reliance on current QD port
	* macosx/tkMacOSXColor.c:	setting and remove unnecessary
	* macosx/tkMacOSXDebug.c:	references to a drawable's QD port,
	* macosx/tkMacOSXDebug.h:	notably replace GetWindowFromPort(
	* macosx/tkMacOSXDialog.c:	TkMacOSXGetDrawablePort()) idiom by new
	* macosx/tkMacOSXDraw.c:	TkMacOSXDrawableWindow() and change
	* macosx/tkMacOSXKeyEvent.c:	TkMacOSXSetColorInPort() to take a port
	* macosx/tkMacOSXMenu.c:	argument.
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXInt.h:		  	Factor out macros, declarations
	* macosx/tkMacOSXPrivate.h (new): 	and prototypes that are purely
	internal and private to the 'macosx' sources into a new internal header
	file that does _not_ get installed into Tk.framework/PrivateHeaders.

	* macosx/tkMacOSXButton.c: 		#include new tkMacOSXPrivate.h
	* macosx/tkMacOSXCarbonEvents.c:	instead of tkMacOSXInt.h.
	* macosx/tkMacOSXClipboard.c:
	* macosx/tkMacOSXColor.c:
	* macosx/tkMacOSXCursor.c:
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXNotify.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:
	* macosx/ttkMacOSXTheme.c:

	* macosx/Wish.xcodeproj/project.pbxproj: Improve support for renamed
	* macosx/Wish.xcodeproj/default.pbxuser: tcl and tk source dirs; add
	* macosx/Wish-Common.xcconfig:		 10.5 SDK build config; remove
						 tclMathOp.c.

	* macosx/README: Document Wish.xcodeproj changes.

2007-06-23  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkImgPhoto.c (ImgPhotoConfigureInstance, DisposeInstance):
	Use XDestroyImage instead of XFree to destroy XImage; replace runtime
	endianness determination by compile-time check for WORDS_BIGENDIAN.

	* xlib/ximage.c (XCreateBitmapFromData): Use XCreateImage and
	XDestroyImage instead of creating XImage structure manually.

	* macosx/tkMacOSXXStubs.c (XCreateImage, DestroyImage): Correct XImage
	bytes_per_line/bitmap_pad calculations and endianness setting; free
	image data and XImage structure at destruction; formatting cleanup.

	* macosx/tkMacOSXDialog.c (NavServicesGetFile): Disable app-modal
	sheet variant of nav dialog on OS versions where it causes problems.

2007-06-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/ttk/ttk.tcl: Should require Tk before pseudo-providing
	tile 0.8.0.

2007-06-09  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkPanedwindow.c, doc/ttk_panedwindow.n,
	* tests/ttk/panedwindow.test: Added -width and -height options. Added
	'panes' method, return list of managed windows. 'sashpos' method is
	now documented as part of the public interface, and details clarified.
	Should be easier to set initial sash positions now. Alleviates [Bug
	1659067].

2007-06-09  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WmIconphotoCmd): fix wm iconphoto RGBA issues.
	[Bug 1467997] (janssen)

	* win/tkWinMenu.c (TkWinHandleMenuEvent): Improve handling to allow
	for unicode char menu indices and not use CharUpper on Tcl utf
	strings. [Bug 1734223]

2007-06-09  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkManager.h, generic/ttk/ttkManager.c,
	* generic/ttk/ttkNotebook.c, generic/ttk/ttkPanedwindow.c,
	* generic/ttk/ttkFrame.c: Ttk_Manager API overhaul:
	    + Ttk_Manager no longer responsible for managing slave records
	    + Ttk_Manager structure now opaque
	    + Ttk_Slave structure now private
	    + Pass Ttk_Manager* to Tk_GeomMgr hooks instead of Ttk_Slave*

	* generic/ttk/ttkFrame.c: Simplified -labelwidget management.

	* doc/ttk_panedwindow.n, library/ttk/panedwindow.tcl: Changed
	documentation of ttk::panedwindow 'identify' command to match
	implementation.

	* generic/ttk/ttkNotebook.c, tests/ttk/notebook.test:
	BUGFIX: ttk::noteboook 'insert' command didn't correctly maintain
	current tab.

2007-06-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXColor.c: Fix issues with TK_{IF,ELSE,ENDIF} macros;
	* macosx/tkMacOSXDraw.c:  implement Jaguar equivalent of unavailable
	* macosx/tkMacOSXEntry.c: kHIToolboxVersion global; panic at startup
	* macosx/tkMacOSXEvent.c: if MAC_OS_X_VERSION_MIN_REQUIRED constraint
	* macosx/tkMacOSXInit.c:  is not satisfied.
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c (XCopyArea, XCopyPlane, TkPutImage)
	(TkMacOSXSetupDrawingContext): Factor out common code and standardize
	setup/restore of port, context and clipping; formatting cleanup.

	* macosx/tkMacOSXWindowEvent.c:	Add error checking.
	* macosx/tkMacOSXMenu.c:	Fix gcc3 warning.
	* macosx/tkMacOSXScrlbr.c:	Fix testsuite crash.
	* macosx/tkMacOSXSubwindows.c:	Formatting cleanup.
	* macosx/tkMacOSXRegion.c:	Fix typos.
	* macosx/tkMacOSXScale.c:

	* macosx/tkMacOSXXStubs.c (Tk_GetUserInactiveTime): Remove superfluous
							    CFRetain/CFRelease.

	* macosx/Wish-Release.xcconfig: Disable tktest release build stripping.

	* macosx/Wish.xcodeproj/project.pbxproj: Add new Tclsh-Info.plist.in.

2007-06-06  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXInt.h: Use native debug message API when available.
	* macosx/Wish-Debug.xcconfig:

	* macosx/tkMacOSXMouseEvent.c (GenerateMouseWheelEvent): Enable
	processing of mousewheel events in background windows.

	* macosx/tkMacOSXScrlbr.c: Modernize checks for active/front window.
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXColor.c: Factor out verbose #ifdef checks of
	* macosx/tkMacOSXDraw.c:  MAC_OS_X_VERSION_{MAX_ALLOWED,MIN_REQUIRED}
	* macosx/tkMacOSXEntry.c: and runtime checks of kHIToolboxVersion into
	* macosx/tkMacOSXEvent.c: new TK_{IF,ELSE,ENDIF}_MAC_OS_X macros.
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c:  Factor out clip clearing in QD ports;
	* macosx/tkMacOSXEntry.c: Formatting cleanup.

	* macosx/Wish.xcodeproj/project.pbxproj: Add settings for Fix&Continue.

	* unix/configure.in (Darwin): Link the Tk and Wish plists into their
	binaries in all cases; fix 64bit arch removal in fat 32&64bit builds.

	* unix/tcl.m4 (Darwin): Fix CF checks in fat 32&64bit builds.
	* unix/configure: autoconf-2.59

2007-06-05  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/photo.n: Clarified the fact that base64 support for the -data
	option is not universal. [Bug 1731348] (matzek)

2007-06-03  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in: Add datarootdir to silence autoconf-2.6x warning.

	* macosx/Wish.xcodeproj/default.pbxuser: Add ttk tests.

	* macosx/tkMacOSXMenu.c: Add error checking; whitespace cleanup.

	* macosx/tkMacOSXDraw.c:	Comment formatting fixes for Xcode 3.0
	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

2007-06-02  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMenu.c (TkpPostMenu): Ensure cascade menus display in
	posted menus that are not part of the menubar or attached to a
	menubutton (fixes bug reported on tcl-mac by Linus Nyberg).

2007-05-31  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (GenerateUpdateEvent): Complete all
	pending idle-time redraws before newly posted Expose events are
	processed; add bounds of redrawn windows to update region to ensure
	all child windows overdrawn by parents are redrawn.

	* macosx/tkMacOSXWindowEvent.c:	Centralize clip and window invalidation
	* macosx/tkMacOSXSubwindows.c: 	after location/size changes in the
	* macosx/tkMacOSXWm.c:		BoundsChanged carbon event handler;
	correct/add window invalidation after window attribute changes.

	* macosx/tkMacOSXSubwindows.c (XResizeWindow, XMoveResizeWindow)
	(XMoveWindow): Factor out common code dealing with embedded and
	non-toplevel windows; remove unnecessary clip and window invalidation.

	* macosx/tkMacOSXButton.c (TkpDisplayButton): Move clip setup closer
	to native button drawing calls.

	* macosx/tkMacOSXWm.c (TkMacOSXIsWindowZoomed, TkMacOSXZoomToplevel):
	Correct handling of gridded windows in max size calculations.

	* macosx/tkMacOSXEvent.c (TkMacOSXFlushWindows): Use HIWindowFlush API
	when available.

	* macosx/tkMacOSXColor.c:	Cleanup whitespace and formatting.
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:

	* generic/tkFont.c:	#ifdef out debug msg printing to stderr.
	* generic/tkTextDisp.c:

2007-05-30  Don Porter  <dgp@users.sourceforge.net>

	* generic/tk.h: Correct placement of #include <tcl.h>. [Bug 1723812]

2007-05-30  Daniel Steffen  <das@users.sourceforge.net>

	* library/bgerror.tcl:	Standardize dialog option & button size
	* library/dialog.tcl:	modifications done when running on on Aqua.
	* library/msgbox.tcl:

	* library/demos/button.tcl: Set button highlightbackground on Aqua.

	* macosx/tkMacOSXMenu.c (DrawMenuSeparator): Use DrawingContext API.

	* macosx/tkMacOSXWindowEvent.c (ClearPort): Clip to updateRgn.

	* macosx/tkMacOSXDebug.c:	Factor out debug region flashing.
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:

	* macosx/tkMacOSXEvent.c:	Cleanup whitespace and formatting.
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:
	* xlib/xgc.c:

	* macosx/Wish.xcodeproj/project.pbxproj: Delete references to removed
	* macosx/Wish.xcodeproj/default.pbxuser: ttk files.

2007-05-28  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c (TkpMeasureCharsInContext): Fix short measures
	with flags=TK_WHOLE_WORDS|TK_AT_LEAST_ONE [Bug 1716141]. Make some
	casts unnecessary by changing variable types.

2007-05-25  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/ttk.tcl: Omit ttk::dialog and dependencies.
	* library/ttk/dialog.tcl, library/ttk/icons.tcl,
	* library/ttk/keynav.tcl: Removed.
	* tests/ttk/misc.test: Removed.
	* doc/ttk_dialog.tcl: Removed.

2007-05-25  Donal K. Fellows  <dkf@users.sf.net>

	* doc/canvas.n: Fixed documentation of default -joinstyle option
	values for line and polygon items. [Bug 1725782]

2007-05-22  Don Porter  <dgp@users.sourceforge.net>

	[core-stabilizer-branch]

	* unix/configure:       autoconf-2.59 (FC6 fork)
	* win/configure:

	* README:               Bump version number to 8.5b1
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

2007-05-18  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkEntry.c(EntrySetValue):  Ensure that widget is in a
	consistent state before setting the linked -textvariable. Previously,
	it was possible for [$e index insert] to point past the end of the
	string, leading to heap corruption. [Bug 1721532]
	* tests/ttk/entry.test(entry-9.1): Add test case for the above.

2007-05-18  Don Porter  <dgp@users.sourceforge.net>

	* unix/configure:       autoconf-2.59 (FC6 fork)
	* win/configure:

	* README:               Bump version number to 8.5a7
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* tests/ttk/treetags.test:	Another bit of test suite
	SCIM-tolerance. [Bug 1609316]

2007-05-17  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.decls: Workaround 'make checkstubs' failures from
	tkStubLib.c MODULE_SCOPE revert. [Bug 1716117]

	* macosx/Wish.xcodeproj/project.pbxproj: Add tkOldTest.c and remove
						 tkStubImg.c.

2007-05-16  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkStubLib.c:  Change Tk_InitStubs(), tkStubsPtr, and the
	auxilliary stubs table pointers back to public visibility. See [Bug
	1716117] for details.

	Removed TCL_STORAGE_CLASS monkey business, as it had no effect.

2007-05-16  Don Porter  <dgp@users.sourceforge.net>

	* library/choosedir.tcl:	Removed uses of obsolete {expand}
	* library/comdlg.tcl:		syntax; replaced with the now
	* library/tk.tcl:		approved {*}. [Bug 1710633]
	* tests/canvImg.test:
	* tests/imgPhoto.test:

	* tests/bind.test:    Make test suite more SCIM-tolerant. [Bug 1609316]

2007-05-16  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc: Test ttk widgets.

2007-05-15  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Fix crash introduced by previous fix exposed
	under newer fontconfig libraries [Bug 1717830] again.

2007-05-15  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkGrid.c: Stop crash due to list intrep shimmer [Bug 1677608]

2007-05-15  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Fix various memory leaks. [Bug 1717830], [Bug
	800149]

2007-05-14  Don Porter  <dgp@users.sourceforge.net>

	[Tk Bug 1712081]

	* unix/Makefile.in:	Updates to account for new and deleted files
	* win/Makefile.in:	tkStubImg.c and tkOldTest.c.
	* win/makefile.bc:
	* win/makefile.vc:

	* generic/tkOldTest.c (new):	New file used to create testing
	* generic/tkTest.c:		commands for testing various Tk
	* tests/constraints.tcl:	legacy interfaces where a separate
	* tests/image.test:		compilation unit is needed in order to
	#define suitable macros during compilation. Only the effect of
	USE_OLD_IMAGE on Tk_CreateImageType() is currently tested, but more
	similar testing commands can be added to this same file. New
	constraint defined to detect presence of the image type provided by
	the new testing code, and a few tests added to exercise it. Having
	USE_OLD_IMAGE support tested by the default test suite should reduce
	chance of a recurrence of this bug.

	* doc/CrtImgType.3:	Revised docs to better indicate the legacy
	* doc/CrtPhImgFmt.3:	nature of the interfaces supported by
	USE_OLD_IMAGE.

	* generic/tkDecls.h:	make genstubs
	* generic/tkStubInit.c:

	* generic/tk.decls:		Reworked USE_OLD_IMAGE support to use
	* generic/tk.h:			the same support mechanisms both with
	* generic/tkStubImg.c (deleted):and without a stub-enabled build. In
	each case, route the legacy calls to Tk_CreateImageType and
	Tk_CreatePhotoImageFormat through the Tk_CreateOldImageType and
	Tk_CreateOldPhotoImageFormat routines. Add those routines to the
	public stub table so they're available to a stub-enabled extension.
	Remove the definition of Tk_InitImageArgs() and use a macro to convert
	any calls to it in source code into a comment.

	* generic/tkImage.c:	Removed the MODULE_SCOPE declarations that
	* generic/tkImgPhoto.c:	broke USE_OLD_IMAGE support.

2007-05-11  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* tests/winButton.test: Avoid font dependencies in results.

	* generic/tkFont.c: propagate error from TkDeleteNamedFont. [Bug
	1716613]

2007-05-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkFileFilter.c (AddClause): OSType endianness fixes.

	* library/palette.tcl (tk::RecolorTree): Handle color options with
	empty value, fixes error due to emtpy -selectforeground (reported on
	tcl-mac by Russel E. Owen).

	* macosx/tkMacOSXWindowEvent.c:	Ensure window is brought to the front
	* macosx/tkMacOSXMouseEvent.c:	at the start of a window drag (except
	* macosx/tkMacOSXInt.h:		when cmd key is down); formatting and
					whitespace fixes.

	* macosx/tkMacOSXDialog.c (Tk_GetSaveFileObjCmd): Add -filetypes option
	processing (fixes fileDialog-0.1, fileDialog-0.2 failures).

	* macosx/tkMacOSXEmbed.c (TkpMakeWindow, TkpUseWindow): Fix sending of
	Visibility event for embedded windows (fixes frame-3.9 hang).

	* macosx/tkMacOSXScrlbr.c (ScrollbarBindProc):		Fix testsuite
	* macosx/tkMacOSXSubwindows.c (TkMacOSXUpdateClipRgn):	crashes by
	adding sanity checks.

	* macosx/Wish.xcodeproj/project.pbxproj: Add 'DebugUnthreaded' &
	* macosx/Wish.xcodeproj/default.pbxuser: 'DebugLeaks' targets and env
	var settings needed to run the 'leaks' tool.

	* macosx/tkMacOSXButton.c: Fix debug msg typo.

	* tests/constraints.tcl: Ensure 'nonUnixUserInteraction' constraint is
	set for aqua.

	* tests/choosedir.test:	Add 'notAqua' constraints to X11-only tests;
	* tests/clrpick.test:	add 'nonUnixUserInteraction' to 'unix' tests
	* tests/menuDraw.test:	requiring interaction on aqua.
	* tests/unixMenu.test:
	* tests/unixWm.test:
	* tests/winMenu.test:

2007-05-07  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixRFont.c: Properly cast sentinel arguments to variadic
	function (fixes "warning: missing sentinel in function call", [Bug
	1712001])

2007-05-04  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkFont.c:     TIP #145 implementation -
	* generic/tkFont.h:     Enhanced font handling.
	* win/tkWinDefault.h:
	* win/tkWinFont.c:
	* win/tkWinInt.h:
	* win/tkWinWm.c:
	* library/demos/widget:
	* library/ttk/fonts.tcl:

2007-05-04  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* doc/ttk_treeview.n, doc/ttk_panedwindow.n, doc/ttk_dialog.n:
	* doc/ttk_checkbutton.n, doc/tk.n, doc/menu.n, doc/font.n:
	* doc/canvas.n: Spelling fixes. [Bug 1686210]

2007-05-03  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* generic/tkStubLib.c (Tk_InitStubs):
	* generic/ttk/ttkLabel.c (LabelSetup):
	* unix/tkUnixSelect.c (ConvertSelection):
	* unix/tkUnixEvent.c (TkUnixDoOneXEvent):
	* generic/tkConfig.c (Tk_RestoreSavedOptions):
	* generic/tkCanvPs.c (TkCanvPostscriptCmd):
	* generic/tkOption.c (GetDefaultOptions):
	* unix/tkUnixRFont.c (TkpGetFontAttrsForChar, InitFont)
	(TkpGetFontFamilies, TkpGetSubFonts):
	* unix/tkUnixSend.c (TkpTestsendCmd, RegOpen): Squelch warnings from
	GCC type aliasing. [Bug 1711985 and others]

2007-04-29  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure.in: Fix for default case in tk debug build detection.
	* unix/configure: autoconf-2.59

2007-04-27  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c(TagOptionSpecs): Use TK_OPTION_STRING
	instead of TK_OPTION_FONT to avoid resource leak in tag management.

2007-04-26  Joe English  <jenglish@users.sourceforge.net>

	* macosx/ttkMacOSXTheme.c: Merged OFFSET_RECT processing into
	BoxToRect(); factored out PatternOrigin; resynchronized with Tile
	codebase.

2007-04-26  Jeff Hobbs  <jeffh@ActiveState.com>

	*** 8.5a6 TAGGED FOR RELEASE ***

	* unix/Makefile.in (dist): Correct tests/ttk glob inclusion

2007-04-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (dist): Add tests/ttk dir to src dist

	* unix/tkUnixMenubu.c (TkpDisplayMenuButton): Init width/height to 0

2007-04-25  Daniel Steffen  <das@users.sourceforge.net>

	* unix/Makefile.in (dist): Add macosx/*.xcconfig files to src dist;
	copy license.terms to dist macosx dir; fix autoheader bits.

2007-04-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (dist): Add ttk bits to src dist

	* tests/font.test (font-46.[12]): Correct listification of result

2007-04-23  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkCanvas.c:	Allow -selectforeground option to be None; add
	* generic/tkCanvText.c:	fallback to fgColor when selFgColor is None
	* generic/tkEntry.c:	(new default on aqua to match native L&F).
	* generic/tkListbox.c:
	* generic/tkText.c:

	* generic/tkCanvas.c:	   Add support for bypassing all of Tk's double
	* generic/tkEntry.c:	   buffered drawing into intermediate pixmaps
	* generic/tkFrame.c:	   (via TK_NO_DOUBLE_BUFFERING #define), it is
	* generic/tkListbox.c:	   unnecessary & wasteful on aqua where all
	* generic/tkPanedWindow.c: drawing is already double-buffered by the
	* generic/tkTextDisp.c:	   window server. (Use of this on other
	* generic/ttk/ttkWidget.c: platforms would only require implementation
	* unix/tkUnixScale.c:	   of TkpClipDrawableToRect()).
	* macosx/tkMacOSXPort.h:

	* library/bgerror.tcl:	On aqua, use moveable alert resp. modal dialog
	* library/dialog.tcl:	window class and corresponding system
				background pattern; fix button padding.

	* library/tearoff.tcl:	Correct aqua menu bar height; vertically offset
	* library/tk.tcl:	aqua tearoff floating window to match menu.

	* library/demos/goldberg.tcl: Fix overwriting of widget demo global.

	* library/demos/menu.tcl:   On aqua, use custom MDEF and tearoffs;
	* library/demos/menubu.tcl: correct menubutton toplevel name.

	* library/demos/puzzle.tcl: Fix button size & padding for aqua.
	* library/demos/radio.tcl:

	* macosx/tkMacOSXCarbonEvents.c: Add window event target carbon event
	* macosx/tkMacOSXEvent.c:	 handler for all kEventClassWindow and
	* macosx/tkMacOSXEvent.h:	 kEventClassMouse events; move all
	* macosx/tkMacOSXNotify.c:	 remaining events except for
	* macosx/tkMacOSXWindowEvent.c:	 kEventClassKeyboard from dispatcher to
	application event handler; pass event handler callRef downstream; fix
	debug event tracing; process all tcl event types in carbon event timer;
	delay carbon event timer first fire; add TkMacOSXTrackingLoop() to mark
	enter/exit of event tracking loop during which all tcl events but only
	carbon update events should be processed by the timer (replaces various
	calls to Tcl_SetServiceMode()); rename TkMacOSXReceiveAndProcessEvent()
	to TkMacOSXReceiveAndDispatchEvent(), move it from tkMacOSXEvent.c to
	tkMacOSXCarbonEvents.c and modify it to dequeue only update events
	during a tracking loop; add TkMacOSXRunTclEventLoop() to standardize
	the various ways in use to run the tcl event loop; add handling of
	kEventClassAppearance events (for ScrollBarVariantChanged event).

	* macosx/tkMacOSXDialog.c:	Use new TkMacOSXTrackingLoop() around
	* macosx/tkMacOSXEvent.c:	blocking API that puts up modal dialogs
	* macosx/tkMacOSXMenu.c:	or when entering/exiting menu/control
	* macosx/tkMacOSXMouseEvent.c:	tracking, window dragging and other
	* macosx/tkMacOSXScale.c:	mouse tracking loops.
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDialog.c:	Use new TkMacOSXRunTclEventLoop()
	* macosx/tkMacOSXScale.c:	instead of Tcl_DoOneEvent(),
	* macosx/tkMacOSXScrlbr.c:	Tcl_ServiceAll(), TclServiceIdle()
	* macosx/tkMacOSXWindowEvent.c:	and Tcl_GlobalEval("update idletasks").

	* macosx/tkMacOSXColor.c: Make available as Tk system colors all
	* macosx/tkMacOSXPort.h:  appearance manager brushes, text colors and
	backgrounds with new and legacy names, as well as the fully transparent
	color "systemTransparent"; add TkMacOSXSetColorIn{Port,Context}() to
	directly set an X pixel color value in the current QD port resp. the
	given CG context without requiring passage through rgb representation
	(lossy for most system colors); modernize/remove Classic-era code;
	replace crufty strcmp() elseifs by Tcl_GetIndexFromObjStruct().

	* macosx/tkMacOSXButton.c:	Use new TkMacOSXSetColorInPort()
	* macosx/tkMacOSXDraw.c:	instead of setting rgb color directly
	* macosx/tkMacOSXMenubutton.c:	to allow for non-rgb system colors.

	* macosx/tkMacOSXCursor.c: Implement "none" cursor as on other
	platforms [Patch 1615427]; add all missing appearance manager cursors.

	* macosx/tkMacOSXDefault.h: Set SELECT_FG_COLORs to None to match aqua
	L&F; use standard system color names; use new 'menu' system font;
	correct default scrollbar width.

	* macosx/tkMacOSXDraw.c: 	Standardize initialization, use and
	* macosx/tkMacOSXInt.h: 	emptying of various static temp rgns
	* macosx/tkMacOSXRegion.c:	onto two global RgnHandles; in debug
	* macosx/tkMacOSXSubwindows.c:	builds, verify emptiness of these temp
	* macosx/tkMacOSXWindowEvent.c:	rgns before use.

	* macosx/tkMacOSXDraw.c: Add TkMacOSX{Setup,Restore}DrawingContext() to
	* macosx/tkMacOSXInt.h:  abstract common setup & teardown of drawing
	environment (for both CG and QD); save/restore QD theme drawing state;
	handle GC clip region; add TkpClipDrawableToRect() to allow clipped
	drawing into drawable regardless of GC used; use new system color
	"systemWindowHeaderBackground" to setup background in themed toplevels;
	correct implementation of TkMacOSXMakeStippleMap().

	* macosx/tkMacOSXEntry.c:  Use new TkMacOSXSetupDrawingContext() and
	* macosx/tkMacOSXFont.c:   TkMacOSXRestoreDrawingContext() instead of
	* macosx/ttkMacOSXTheme.c: various setup/teardown procs like
	TkMacOSX{SetUp,Release}CGContext(), TkMacOSXQuarz{Start,End}Draw(),
	TkMacOSXSetUpGraphicsPort() etc.

	* macosx/tkMacOSXEmbed.c: Add CG context and drawable clip rgn fields
	* macosx/tkMacOSXInt.h:   to MacDrawable struct.
	* macosx/tkMacOSXSubwindows.c:

	* macosx/tkMacOSXDialog.c: Make -parent option of tk_getOpenFile et al.
	use the sheet version of NavServices dialogs; ensure native parent win
	exists before using StandardSheet API for tk_messageBox [Bug 1677611];
	force sheets to behave like app-modal dialogs via WindowModality() API;
	use more modern ColorPicker API.

	* macosx/tkAboutDlg.r: Use themed movable modal dialog, fix (c) year.

	* macosx/tkMacOSXEntry.c:  Take xOff/yOff of MacDrawable into account
	* macosx/ttkMacOSXTheme.c: when computing locations/bounds to ensure
	correct posititioning when not drawing into intermediate pixmap.

	* macosx/tkMacOSXFont.c: Use appearance manager API to map system font
	* macosx/tkMacOSXFont.h: names to TkFonts; add "menu" system font for
	menu item text drawing from MDEF; always draw with CG; remove QD
	dependent stippling algorithm; move most header declarations into the
	source file (as they were not used anywhere else).

	* macosx/tkMacOSXMenu.c:		 Large-scale rewrite of custom
	* macosx/tkMacOSXMenu.r (removed):	 MDEF and related code that
	* macosx/Wish.xcode/project.pbxproj:	 restores many longtime-MIA
	* macosx/Wish.xcodeproj/project.pbxproj: features to working order
	* unix/Makefile.in:			 (e.g. images, custom colors &
	fonts in menus etc); implement compound menu items; use Appearance Mgr
	and ThemeText APIs to mimic native MDEF as closely as possible when
	default "menu" system font is used; remove now obsolete SICN drawing
	code and resources.

	* macosx/tkMacOSXCarbonEvents.c: Handle additional menu carbon events
	* macosx/tkMacOSXEvent.c:	 in order to support <<MenuSelect>> in
	* macosx/tkMacOSXMenu.c:	 the menubar and in menus that are not
	* macosx/tkMacOSXMenus.c:	 using the custom MDEF [Bug 1620826];
	fix early and missing clearing of current Tk active menu entry; fix
	extraneous sending of <<MenuSelect>> during active menu entry clearing.

	* macosx/tkMacOSXMouseEvent.c: Add support for async window dragging by
	the window server; set the corresponding window attribute by default.

	* macosx/tkMacOSXMouseEvent.c: Rationalized handling order of
	non-mousedown events; add TkMacOSXModifierState() to retrieve the
	current key modifiers in carbon format.

	* macosx/tkMacOSXScrlbr.c: Use appearance manager API to retrieve
	scrollbar component metrics; add awareness of multiple possibilites for
	scrollbar arrow position in aqua and handle user changes to arrow
	position pref; handle difference in metrics of small & large scrollbar
	variants; handle aqua "jump to here" scrollbar behaviour; correct
	computation of scroll view size and position; enforce min scrollbar
	height to avoid scrollbar component overlap; erase scrollbar area
	outside of standard width; remove broken auto-adjust code; account for
	window class when leaving space for grow box; remove code to manually
	draw grow box; use modern API for thumb scroll proc; replace
	HiliteControl() by modern API; replace control mgr constants with
	appearance mgr equivalents.

	* macosx/tkMacOSXSubwindows.c: Use SetWindowBounds() API instead of
	SizeWindow(); invalidate clip regions after X{Map,Unmap}Window as fix
	for [Bug 940117] made them dependent on mapping state; remove unneeded
	calls to TkMacOSXInvalClipRgns() and unnecessary setting of QD port;
	use native-endian pixmap on intel; remove obsolete pixmap pix locking.

	* macosx/tkMacOSXWindowEvent.c: Handle only the first of a batch of
	kEventAppAvailableWindowBoundsChanged events sent per transaction;
	handle kEventWindowBoundsChanged event to support live window resizing
	and centralized sending of location/size changed ConfigureNotify
	events; ensure HIGrowBox is redrawn after bounds change; constrain
	window after dragging to ensure titlebar is not inacessible
	offscreen or under dock/menubar; handle kEventWindowGetRegion and
	kEventWindowDrawContent for transparent windows to mark resp. paint
	content region as transparent; handle kEventWindowConstrain for
	fullscreen windows to ensure bounds match new screen size; enter/exit
	fullscreen UIMode upon activation/deactivation of fullscreen window.

	* macosx/tkMacOSXWm.c: Use live-resize and async-drag carbon window
	* macosx/tkMacOSXWm.h: attributes for toplevels by default; implement
	new [wm attributes] -topmost, -transparent and -fullscreen; refactor
	WmAttributesCmd() parallelling the tkUnixWm.c implementation, use thus
	factored proc to set proxy icon from [wm iconbitmap]; dynamically
	determine default values for toplevel min and max sizes (similar to
	tkWinWm.c impl): min sizes depend on window class & attributes to
	ensure visibility of all titlebar widgets and grow box, max sizes
	depend on maximal window bounds for all active displays; factor out
	code that puts into effect changes to master or override_redirect; use
	RepositionWindow() API to determine staggered initial window bounds;
	correct resize limit calculations, handle gridding and use modern
	resize API in TkMacOSXGrowToplevel(); remove sending of ConfigureNotify
	after resize or zoom (now handled by BoundsChanged handler); correct
	composite carbon window attribute handling, remove currently unusable
	attributes and add new attributes in [tk::unsupported::MacWindowStyle];
	ensure validity of window class and attributes before use; apply
	changes to window class when handling carbon window attribute changes
	(if HIWindowChangeClass() API available); add debug build warning
	message when deprecated window style is used instead of window class;
	use transparent HIGrowBox for resizable windows; avoid unnecessary
	calls to window structure width API; use tcl time API in TkpGetMS();
	add TkMacOSXEnterExitFullscreen() to enter/exit UIMode with dock and
	menubar hidden; restrict wmTracing output to debug builds; remove
	unneeded calls to TkMacOSXInvalClipRgns() and unnecessary setting of QD
	port; workaround GetWindowStructureWidths() Carbon bug (bogus results
	for never-mapped floating windows).

	* macosx/tkMacOSXXStubs.c (TkMacOSXDisplayChanged): Add maximal window
	bounds field to Screen record (in ext_data), computed as the union of
	available window positioning bounds of all graphics devices (displays).

	* macosx/tkMacOSXBitmap.c: Fix macRoman encoding leak.
	* macosx/tkMacOSXCursor.c:

	* macosx/tkMacOSXDebug.c (TkMacOSXCarbonEventToAscii): Use static
	* macosx/tkMacOSXDebug.h: buffer to simplify callers; const fixes.

	* macosx/tkMacOSXBitmap.c: Use more efficient QDSwapPort() instead of
	* macosx/tkMacOSXButton.c: GetPort()/SetPort()/GetGWorld()/SetGWorld().
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXColor.c: Use kHIToolboxVersionNumber for runtime OS
	* macosx/tkMacOSXEntry.c: version check rather than Gestalt() etc.
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXWm.c:

	* macosx/tkMacOSXDraw.c: Remove obsolete and now incorrect
	* macosx/tkMacOSXInt.h:  tkMenuCascadeRgn clipping code.
	* macosx/tkMacOSXMenu.c:

	* macosx/tkMacOSXHLEvents.c: Replace Tcl_GlobalEval() resp. Tcl_Eval()
	* macosx/tkMacOSXScrlbr.c:   by Tcl_EvalEx().
	* macosx/tkMacOSXInit.c:

	* macosx/tkMacOSXInit.c (TkpInit): Reorder initialization steps.

	* macosx/tkMacOSXKeyEvent.c: Remove pre-10.2 support.

	* macosx/tkMacOSXMenus.c: Remove now useless call to
	TkMacOSXHandleTearoffMenu(); use \x.. quoting for non-latin1 macroman
	literar chars to allow file to be edited as utf-8.

	* macosx/tkMacOSXScale.c: Replace TrackControl() by modern
	* macosx/tkMacOSXScrlbr.c: HandleControlClick() API (using new
	TkMacOSXModifierState()).

	* macosx/tkMacOSXInt.h:		Move all constant #defines needed to
	* macosx/tkMacOSXColor.c:	support building on older OS X releases
	* macosx/tkMacOSXEvent.h:	to a central location in tkMacOSXInt.h.
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/ttkMacOSXTheme.c:

	* macosx/tkMacOSXInt.h:		 Add ChkErr() macro to factor out
	* macosx/tkMacOSXButton.c:	 Carbon OSStatus return value checking
	* macosx/tkMacOSXCarbonEvents.c: and TkMacOSXDbgMsg() macro to factour
	* macosx/tkMacOSXClipboard.c:	 out debug message output; use these
	* macosx/tkMacOSXColor.c:	 macros to replace #ifdef TK_MAC_DEBUG
	* macosx/tkMacOSXCursor.c:	 blocks & direct printing to stderr,
	* macosx/tkMacOSXDebug.c:	 and to do additional OSStatus return
	* macosx/tkMacOSXDialog.c:	 checking, and to standardize OSStatus
	* macosx/tkMacOSXDraw.c:	 usage.
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXSend.c:	Remove duplicate/unused declarations.
	* macosx/tkMacOSXXStubs.c:

	* macosx/tkMacOSXDebug.c:	Const fixes.
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXTest.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:

	* macosx/Wish-Info.plist.in: Add tcl document extensions/mime types and
	LSMinimumSystemVersion, LSRequiresCarbon & NSAppleScriptEnabled keys.

	* macosx/Wish-Common.xcconfig: Add Wish's Info.plist as __info_plist
	section to tktest; enable more warnings.

	* macosx/Wish.xcodeproj/project.pbxproj: Add 'DebugMemCompile' build
	configuration that calls configure with --enable-symbols=all; disable
	configure check for __attribute__((__visibility__("hidden"))) in Debug
	configuration to restore availability of ZeroLink.

	* macosx/Wish-Common.xcconfig:	Fix whitespace.
	* macosx/Wish-Debug.xcconfig:
	* macosx/Wish-Release.xcconfig:
	* macosx/tkMacOSXAETE.r:
	* macosx/tkMacOSXConfig.c:
	* macosx/tkMacOSXCursors.r:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXSend.c:
	* macosx/ttkMacOSXTheme.c:
	* macosx/tkMacOSXXCursors.r:
	* macosx/README:

	* macosx/GNUmakefile:		Fix/add copyright and license refs.
	* macosx/Tk-Info.plist.in:
	* macosx/Wish-Info.plist.in:
	* macosx/Wish.xcode/project.pbxproj:
	* macosx/Wish.xcodeproj/project.pbxproj:
	* macosx/tkMacOSX.h:

	* unix/configure.in: Install license.terms into Tk.framework; fix tk
	debug build detection.
	* unix/configure: autoconf-2.59

	* doc/colors.n:		Document new Mac OS X system colors.
	* doc/cursors.n:	Document new Mac OS X native cursors.
	* doc/font.n:		Document new Mac OS X 'menu' system font.
	* doc/wm.n:		Document new Mac OS X [wm attributes].
	* doc/ttk_image.n:	Fix 'make html' warning.
	* doc/canvas.n:		Fix nroff typo.

2007-04-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXBitmap.c, macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXCarbonEvents.c, macosx/tkMacOSXClipboard.c:
	* macosx/tkMacOSXCursor.c, macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c, macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXFont.c, macosx/tkMacOSXInit.c, macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXKeyEvent.c, macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c, macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXScale.c, macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c: Revert of commits from 2007-04-13 which broke
	the OS X build.

2007-04-17  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkFont.c, generic/tkListbox.c, unix/tkUnixSelect.c:
	* win/ttkWinMonitor.c, win/ttkWinTheme.c, win/ttkWinXPTheme.c: Make
	the format of declarations much more standardized (removing K&R-isms
	and other things like that).

2007-04-13  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* macosx/tkMacOSXInt.h (LOG_MSG, LOG_ON_ERROR): Added macros to make
	the OSX code much less #ifdef-full.

2007-04-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/ttk/panedwindow.tcl (ttk::panedwindow::Press): handle Press
	triggering outside sash element boundaries.

2007-04-10  Joe English  <jenglish@users.sourceforge.net>

	* win/ttkWinMonitor.c, win/ttkWinXPTheme.c: Re-sync with Tile codebase
	so patches can flow back and forth.

	* win/ttkWinXPTheme.c: Skip OS version test, should work on Vista/Aero
	now as well as XP. Fixes [Bug 1687299], thanks to George Petasis for
	tracking this down.

2007-03-21  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkLayout.c(Ttk_BuildLayoutTemplate): BUGFIX: Nested
	TTK_GROUP nodes did not work unless they appeared at the end of the
	layout (and only by accident then).

2007-03-08  Joe English  <jenglish@users.sourceforge.net>

	* tests/grid.test(grid-21.7): Reset wm geometry . and pack propagate .
	at end of test. 'pack propagate . 0' was causing cascading failures in
	subsequent tests. [Bug 1676770]

2007-03-07  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkMain.c (Tk_MainEx): Replicate macosx-specific code from
	TkpInit() that ensures the console window appears when wish is started
	from the OS X Finder (i.e. with stdin == /dev/null), jeffh's 2006-11-24
	change rendered the corresponding code in TkpInit() ineffective in wish
	because Tk_MainEx() sets tcl_interactive before calling TkpInit().

	* generic/ttk/ttkGenStubs.tcl (new): Add ttk-specific genstubs.tcl from
	* unix/Makefile.in (genstubs):       tile and run it from 'genstubs'
	target, restores ability to generate all of Tk's stub sources.

	* generic/ttk/ttkTreeview.c: #ifdef out unused declaration.

	* macosx/tkMacOSXDebug.c (TkMacOSXGetNamedDebugSymbol): Add fix for
	libraries loaded with a DYLD_IMAGE_SUFFIX.

	* macosx/Wish.xcodeproj/project.pbxproj: Ensure gcc version used by
	* macosx/Wish.xcodeproj/default.pbxuser: Xcode and configure/make are
	* macosx/Wish-Common.xcconfig:		 consistent and independent of
	gcc_select default and CC env var; fixes for Xcode 3.0.

	* unix/tcl.m4 (Darwin): s/CFLAGS/CPPFLAGS/ in macosx-version-min check.
	* unix/configure: autoconf-2.59

2007-02-25  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkUtil.c: Fixed grid anchor center problem in labelframes.
	* tests/grid.test:  [Bug 1545765]

2007-02-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/ttk/notebook.tcl (ttk::notebook::enableTraversal): OS X
	needs Option instead of Alt binding

2007-02-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4: use SHLIB_SUFFIX=".so" on HP-UX ia64 arch.
	* unix/configure: autoconf-2.59

	* library/tkfbox.tcl (::tk::IconList_Goto): avoid goto issues in empty
	dirs. [Bug 1662959]

2007-02-09  Joe Mistachkin  <joe@mistachkin.com>

	* win/nmakehlp.c: Properly cleanup after nmakehlp, including the
	* win/makefile.vc: vcX0.pch file. Sync up fixed nmakehlp usage from
	Tcl.

2007-02-06  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/ttk.tcl: Add no-op [package ifneeded] script for tile
	0.8.0, so that existing applications that use "package require tile"
	won't fail when run under Tk 8.5.

2007-02-04  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: Use gcc4's __attribute__((__visibility__("hidden"))) if
	available to define MODULE_SCOPE effective on all platforms.
	* unix/configure.in: add caching to -pipe check.
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

2007-02-03  Joe Mistachkin  <joe@mistachkin.com>

	* win/rules.vc: Fix platform specific file copy macros for downlevel
	Windows.
	* win/ttkWinMonitor.c: Windows portability support. Fix "noxp" build
	* win/ttkWinXPTheme.c: option handling and use GetWindowLongPtr and
	SetWindowLongPtr only when needed.

2007-02-02  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/ttkWinXPTheme.c: Support IsAppThemed() call. This is what is
	used when theming is turned off just for an individual application.

2007-01-28  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj:   Extract build settings that
	* macosx/Wish.xcodeproj/default.pbxuser:   were common to multiple
	* macosx/Wish-Common.xcconfig (new file):  configurations into external
	* macosx/Wish-Debug.xcconfig (new file):   xcconfig files; add extra
	* macosx/Wish-Release.xcconfig (new file): configurations for building
	with SDKs; convert legacy jam-based 'Tk' target to native target with
	single script phase; correct syntax of build setting references to use
	$() throughout; remove unused tcltest sources from 'tktest' target.

	* macosx/README: Document new Wish.xcodeproj configurations; other
	minor updates/corrections.

	* generic/tk.h: Update location of version numbers in macosx files.

	* macosx/Wish.xcode/project.pbxproj: Restore 'tktest' target to working
	* macosx/Wish.xcode/default.pbxuser: order by replicating applicable
	changes to Wish.xcodeproj since 2006-07-20.

2007-01-25  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4: Integrate CPPFLAGS into CFLAGS as late as possible and
	move (rather than duplicate) -isysroot flags from CFLAGS to CPPFLAGS to
	avoid errors about multiple -isysroot flags from some older gcc builds.

	* unix/configure: autoconf-2.59

2007-01-19  Joe Mistachkin  <joe@mistachkin.com>

	* win/makefile.vc: Properly build man2tcl.c for MSVC8.

2007-01-19  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj: Remove libtommath defines.

	* unix/tcl.m4: Ensure CPPFLAGS env var is used when set. [Bug 1586861]
	(Darwin): add -isysroot and -mmacosx-version-min flags to CPPFLAGS when
	present in CFLAGS to avoid discrepancies between what headers configure
	sees during preprocessing tests and compiling tests.

	* unix/configure: autoconf-2.59

2007-01-11  Jeff Hobbs  <jeffh@activestate.com>

	* unix/tkUnixEvent.c, library/msgs/es.msg: s/CRLF/LF/g

2007-01-11  Joe English  <jenglish@users.sourceforge.net>

	* win/tcl.m4 (CFLAGS_WARNING): Remove "-Wconversion". This was removed
	from unix/tcl.m4 2004-07-16 but not from here.
	* win/configure: Regenerated.

2007-01-11  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkManager.h, generic/ttk/ttk*.c: Revert addition of
	contravariant 'const' qualifiers, to keep in sync with Tile codebase
	(which must remain compatible with Tk 8.4).

2007-01-03  Jan Nijtmans  <nijtmans@users.sf.net>

	* doc/ManageGeom.3,
	* generic/tk.decls,
	* generic/tk.h: Add const to 2nd parameter of Tk_ManageGeometry
	* generic/tkDecls.h: regenerated
	* generic/tkInt.h,
	* generic/tk*.c,
	* generic/ttk/ttk*.c: Added many "const" specifiers in implementation.

2007-01-02  Donal K. Fellows  <dkf@users.sf.net>

	* xlib/*: Made the generic fake-X11 glue layer abide by the formatting
	rules of the core.

2006-12-31  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c: Fill-in TkpGetFontAttrsForChar (TIP #300).
	* macosx/ttkMacOSXTheme.c: Define a constant to make it compile on Mac
	OS X 10.3.

2006-12-28  Mo DeJong  <mdejong@users.sourceforge.net>

	* tests/wm.test: Update wm attributes output so that tests pass after
	addition of -transparentcolor for Win32.

2006-12-26  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkLabel.c: ImageElement clientData no longer needed.

2006-12-22  Donal K. Fellows  <dkf@users.sf.net>

	* unix/tkUnixEvent.c (TkUnixDoOneXEvent): Made correct on AMD64 and
	other similar 64-bit systems where fd_mask is not 'unsigned int' in
	effect. [Bug 1522467]

	* library/msgs/es_ES.msg (removed):
	* library/msgs/es.msg: Fixed translation fault that was present in all
	Spanish-speaking locales. [Bug 1111213]

2006-12-19  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinButton.c (TkpDisplayButton): lint init. [Bug 1618604]

2006-12-19  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): --enable-64bit: verify linking with 64bit -arch
	flag succeeds before enabling 64bit build.
	* unix/configure: autoconf-2.59

2006-12-18  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTreeview.c, library/ttk/treeview.tcl, doc/treeview.n:
	Added column '-stretch' and '-minwidth' options. Improved column drag
	and resize behavior. Added horizontal scrolling [Bug 1518650]. Row
	height and child indent specifiable on Treeview style. Decreased
	default row height, no default -padding. Use correct heading height
	[Bug 1163349]. Apply tag settings to tree item as well as to data
	columns [NOTE: 'tag configure' still buggy]. Fix off-by-one condition
	when moving nodes forward [Bug 1618142]
	* generic/ttk/ttkScroll.c (TtkScrollTo): Prevent overscroll [Bug
	1173434]
	* library/ttk/altTheme.tcl, library/ttk/aquaTheme.tcl,
	* library/ttk/clamTheme.tcl, library/ttk/classicTheme.tcl,
	* library/ttk/defaults.tcl, library/ttk/winTheme.tcl,
	* library/ttk/xpTheme.tcl: Per-theme treeview settings.
	* macosx/ttkMacOSXTheme.c: Added disclosure triangle element.

2006-12-17  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/combobox.tcl, generic/ttk/ttkEntry.c,
	* doc/ttk_combobox.n: Add combobox -height option; only show scrollbar
	if the listbox needs to scroll. [Bug 1032869]

2006-12-16  Mo DeJong  <mdejong@users.sourceforge.net>

	* doc/cursors.n: Mention "none" in supported cursor list. Fix comment
	that incorrectly claims that the Win32 "no" cursor hides the cursor.
	* tests/cursor.test: Test "none" cursor.
	* unix/tkUnixCursor.c (CreateCursorFromTableOrFile)
	(TkGetCursorByName): Define a table of Tk cursors that is searched in
	addition to the X cursor table. A Tk cursor is loaded from a data
	string and works with the same options as the built in X cursors. This
	code makes it possible to use "none" as a cursor name under Unix.
	* win/rc/cursor9a.cur: Added none Win32 cursor.
	* win/rc/tk_base.rc: Define a built-in Win32 cursor named "none".
	[Patch 1615427]

2006-12-14  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkButton.c, generic/ttk/ttkElements.c,
	* generic/ttk/ttkEntry.c, generic/ttk/ttkFrame.c,
	* generic/ttk/ttkImage.c, generic/ttk/ttkInit.c,
	* generic/ttk/ttkLabel.c, generic/ttk/ttkNotebook.c,
	* generic/ttk/ttkPanedwindow.c, generic/ttk/ttkProgress.c,
	* generic/ttk/ttkScale.c, generic/ttk/ttkScrollbar.c,
	* generic/ttk/ttkSeparator.c, generic/ttk/ttkTheme.h,
	* generic/ttk/ttkTreeview.c, generic/ttk/ttkWidget.h:
	Global reduction: use per-file *_Init() routines to reduce the number
	of globally-visible initialization records.

2006-12-13  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/Makefile.in (install-doc): intentionally skip ttk_dialog.n
	installation (not for public consumption)

	* doc/scrollbar.n, doc/button.n, doc/checkbutton.n:
	* doc/entry.n, doc/frame.n, doc/label.n, doc/labelframe.n:
	* doc/menu.n, doc/menubutton.n, doc/panedwindow.n:
	* doc/radiobutton.n, doc/scrollbar.n, doc/ttk_*: revamp ttk docs to
	use consist nroff format (not 100% consistent with classic widget
	docs). Add more man page cross-linking "SEE ALSO".

	* generic/ttk/ttkInit.c:
	* generic/ttk/ttkTreeview.c: make treeview exist by default
	* generic/ttk/ttkPanedwindow.c: s/TtkPaned_Init/TtkPanedwindow_Init/

	* win/Makefile.in, unix/Makefile.in (demo): add 'demo' target

2006-12-13  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/ttk.tcl: Try to straighten out theme loading and
	selection logic.
	* generic/ttk/ttkElements.c, library/ttk/defaults.tcl,
	* generic/ttk/ttkClamTheme.c, library/ttk/clamTheme.tcl:
	Provide package in C part instead of Tcl part.

2006-12-12  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/ttk.tcl, generic/ttkTheme.c: Remove nonfunctional code.

2006-12-12  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinButton.c (InitBoxes): Call Tcl_Panic() if loading of bitmap
	resources fails. This change generates an error if Tk is unable to
	find button widget resources instead of silently failing and then
	drawing widgets incorrectly.
	* win/rc/tk_base.rc: If the user defines BASE_NO_TK_ICON then compile
	the base resources file without a "tk" icon. This change makes it
	easier to replace the default tk icon with a custom icon. [Patch
	1614362]

2006-12-11  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* unix/tkUnixWm.c (TkWmMapWindow, WmClientCmd): Added support for
	_NET_WM_PID property from the EWMH spec. This is only installed when
	the client machine is set.
	(WmProtocolCmd, UpdateWmProtocols, TkWmProtocolEventProc): Added
	support for the _NET_WM_PING protocol from the EWMH spec. Note that
	the support for this is not exposed to the script level as that would
	prevent correct handling.

2006-12-10  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTheme.h, generic/ttk/ttkThemeInt.h,
	* generic/ttk/ttk.decls, generic/ttk/ttkTheme.c,
	* generic/ttk/ttkLayout.c, generic/ttk/ttkDecls.h:
	Rename typedef Ttk_Element => Ttk_ElementImpl.

2006-12-09  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkButton.c, generic/ttk/ttkImage.c,
	* generic/ttk/ttkLabel.c, generic/ttk/ttkWidget.h,
	* generic/ttk/ttkTheme.h, generic/ttk/ttkNotebook.c,
	* generic/ttk/ttkTreeview.c, doc/ttk_image.n:
	Merged duplicate functionality between image element factory, image
	element, and -image option processing. Image element factory now takes
	an imageSpec argument instead of a separate image name and -map option
	* tests/ttk/image.test(image-1.1): Can catch this error earlier now.

2006-12-06  Kevin Kenny  <kennykb@acm.org>

	* unix/configure.in: Further changes to avoid attempting to link
	* unix/configure:    against Xft libraries in a non-Xft build
	                     [Bug 1609616] (dgp)

2006-12-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkListbox.c (ConfigureListboxItem): ListboxWorldChanged not
	needed - just call EventuallyRedrawRange. [Bug 1608046] (rezic)

2006-12-04  Donal K. Fellows  <dkf@users.sf.net>

	TIP #286 IMPLEMENTATION

	* generic/tkMenu.c (MenuWidgetObjCmd, MenuDoXPosition):
	* doc/menu.n, tests/menu.test: Added an [$menu xposition] subcommand
	which is useful in menubars and when menus use multiple columns. Many
	thanks to Schelte Bron for the implementation.

2006-12-01  Kevin Kenny  <kennykb@acm.org>

	TIP #300 IMPLEMENTATION

	* doc/font.n:			Added a [font actual $font $char]
	* generic/tkFont.c:		variant that introspects the font that
	* generic/tkFont.h:		is chosen to render a given character
	* macosx/tkMacOSXFont.c:	in a given nominal font. Added
	* tests/font.test:		documentation and test cases for the
	* unix/tkUnixFont.c:		new command syntax.
	* unix/tkUnixRFont.c:
	* win/tkWinFont.c:

2006-12-01  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/wm.n, tests/winWm.test:
	* win/tkWinWm.c: add -transparentcolor attribute for Windows.

2006-12-01  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkTheme.h, generic/ttk/ttkLayout.c: Dead code removal.

2006-11-30  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDialog.c (Tk_MessageBoxObjCmd): fix inability to use
	buttons with standard Escape key binding as -default button (reported
	on tcl-mac by Hans-Christoph Steiner).

	* macosx/tkMacOSXWm.c (WmAttributesCmd): fix getting [wm attr -alpha].
	[Bug 1581932]

2006-11-28  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/fonts.tcl: Clean up temporary variables.

2006-11-27  Kevin Kenny  <kennykb@acm.org>

	* unix/configure.in: Corrected Xft configuration so that Xft actually
	does get turned on when available.
	* unix/configure: autoconf

2006-11-26  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkWidget.c, generic/ttk/ttkPaned.c: Fix [Bug 1603506]
	* library/ttk/button.tcl, library/ttk/combobox.tcl,
	* library/ttk/utils.tcl: Rename ttk::CopyBindings to ttk::copyBindings
	* generic/ttk/ttkTreeview.c, doc/ttk_treeview.n:
	-displaycolumns {} now means "no columns" instead of "all columns".
	Use -displaycolumns #all for "all columns". [Bug 1547622]

2006-11-26  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Linux): --enable-64bit support.	[Patch 1597389]
	* unix/configure: autoconf-2.59			[Bug 1230558]

2006-11-24  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXInit.c (TkpInit): only set tcl_interactive 1 if it
	isn't already defined. Allows embedders to set it to 0 to prevent the
	console appearing on OS X. [Bug 1487701]

	* unix/tkUnixMenu.c (DrawMenuUnderline): bound Tcl_UtfAtIndex usage
	* tests/menu.test (menu-36.1): [Bug 1599877]

2006-11-24  Joe English  <jenglish@users.sourceforge.net>

	* library/ttk/altTheme.tcl, library/ttk/clamTheme.tcl,
	* library/ttk/defaults.tcl, library/ttk/winTheme.tcl,
	* library/ttk/xpTheme.tcl: explicitly specify -anchor w on TMenubutton
	* tests/ttk/entry.test: Fixed font dependency; test entry-3.2 should
	work on all platforms now.
	* library/classicTheme.tcl: Don't define or use TkClassicDefaultFont.
	* generic/ttk/ttkTreeview.c, generic/ttk/ttkPanedwindow.c: Handle
	missing layouts.

2006-11-23  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkWinHandleMenuEvent, DrawMenuUnderline): Handle
	unichar underlining correctly and safely. [Bug 1599877]

2006-11-20  Joe English  <jenglish@users.sourceforge.net>

	* win/ttkWinXPTheme.c: Add support for alternate/indeterminate
	checkbutton state. Fix various spacing parameters [Bug 1596020, patch
	from Tim Baker]. Remove unused uxtheme hooks.

2006-11-16  Donal K. Fellows  <dkf@users.sf.net>

	* doc/colors.n, doc/wm.n: Minor fixes, added See Also.

	* doc/labelframe.n: Added an example.

2006-11-15  Donal K. Fellows  <dkf@users.sf.net>

	* doc/label.n: Added an example and some See Also refs.

	* doc/ConfigWidg.3, doc/bind.n, doc/grid.n, doc/panedwindow.n:
	* doc/text.n, doc/ttk_Geometry.3, doc/ttk_button.n:
	* doc/ttk_checkbutton.n, doc/ttk_combobox.n, doc/ttk_dialog.n:
	* doc/ttk_entry.n, doc/ttk_frame.n, doc/ttk_image.n, doc/ttk_intro.n:
	* doc/ttk_label.n, doc/ttk_labelframe.n, doc/ttk_menubutton.n:
	* doc/ttk_notebook.n, doc/ttk_panedwindow.n, doc/ttk_progressbar.n:
	* doc/ttk_radiobutton.n, doc/ttk_scrollbar.n, doc/ttk_separator.n:
	* doc/ttk_sizegrip.n, doc/ttk_style.n, doc/ttk_widget.n, doc/wm.n:
	Convert \fP to \fR so that man-page scrapers have an easier time.

2006-11-14  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkDefaultTheme.c: Fix off-by-one bug in tree indicator
	size computation [Bug 1596021, patch from Tim Baker]. Increased
	default size from 7 to 9 pixels.

2006-11-12  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttkScroll.c: *correct* fix for [Bug 1588251].

2006-11-12  Joe English  <jenglish@users.sourceforge.net>

	* tests/ttk/ttk.test(ttk-6.9): Workaround for [Bug 1583038]

2006-11-12  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttkScroll.c: Reworked cleanup procedure; "self-cancelling"
	idle call is not robust, call Tcl_CancelIdleCall() in
	TtkFreeScrollHandle instead. Fixes [Bug 1588251]

2006-11-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj: remove tclParseExpr.c and
	bwidget.test.

	* unix/tcl.m4 (Darwin): suppress linker arch warnings when building
	universal for both 32 & 64 bit and no 64bit CoreFoundation is
	available; sync with tcl tcl.m4 change.
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

2006-11-08  Kevin Kenny  <kennykb@acm.org>

	* unix/configure.in: Silenced warnings about missing Xft configuration
	unless --enable-xft is requested explicitly. Also added a few basic
	checks that we can actually compile and link against Xft headers and
	libraries. [Bug 1592667]
	* unix/configure: Regen.

2006-11-07  Kevin Kenny  <kennykb@acm.org>

	* unix/configure.in: Made --enable-xft the default.
	* unix/configure: Regen.

2006-11-06  Joe English  <jenglish@users.sourceforge.net>

	* generic/ttk/ttkClassicTheme.c, generic/ttk/ttkPanedwindow.c,
	* generic/ttk/ttkTheme.c, generic/ttk/ttkTreeview.c,
	* win/ttkWinXPTheme.c, library/ttk/entry.tcl,
	* library/ttk/notebook.tcl, library/ttk/panedwindow.tcl,
	* library/ttk/utils.tcl, tests/ttk/entry.test, tests/ttk/bwidget.test:
	Miscellaneous minor changes to re-sync Ttk codebase with Tile CVS: fix
	comments damaged by overzealous search-and-destroy; removed obsolete
	[style default] synonym for [ttk::style configure]; removed other dead
	code.

2006-11-03  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/safetk.tcl (::safe::tkTopLevel): Theme it.

	* generic/ttk/ttkLayout.c:     We do not want to require tkInt in all
	* generic/ttk/ttkMananager.h:  the ttk files so added the definition
	* generic/ttk/ttkTheme.h:      of MODULE_SCOPE to ttkTheme.h. Ensures
	* generic/ttk/ttkWinMonitor.c: everyone gets to see the definition
	from someplace.

	* library/ttk/fonts.tcl: In a safe interp there is no osVersion field
	in tcl_platform so work around it.

2006-11-02  Daniel Steffen  <das@users.sourceforge.net>

	* generic/ttk/ttkBlink.c, generic/ttk/ttkButton.c:
	* generic/ttk/ttkClamTheme.c, generic/ttk/ttkClassicTheme.c:
	* generic/ttk/ttkDecls.h, generic/ttk/ttkDefaultTheme.c:
	* generic/ttk/ttkElements.c, generic/ttk/ttkEntry.c:
	* generic/ttk/ttkFrame.c, generic/ttk/ttkImage.c:
	* generic/ttk/ttkInit.c, generic/ttk/ttkLabel.c:
	* generic/ttk/ttkLayout.c, generic/ttk/ttkManager.h:
	* generic/ttk/ttkNotebook.c, generic/ttk/ttkPanedwindow.c:
	* generic/ttk/ttkProgress.c, generic/ttk/ttkScale.c:
	* generic/ttk/ttkScroll.c, generic/ttk/ttkScrollbar.c:
	* generic/ttk/ttkSeparator.c, generic/ttk/ttkSquare.c:
	* generic/ttk/ttkStubInit.c, generic/ttk/ttkStubLib.c:
	* generic/ttk/ttkTheme.c, generic/ttk/ttkTheme.h:
	* generic/ttk/ttkThemeInt.h, generic/ttk/ttkTrack.c:
	* generic/ttk/ttkTreeview.c, generic/ttk/ttkWidget.c:
	* generic/ttk/ttkWidget.h, macosx/ttkMacOSXTheme.c:
	* win/ttkWinMonitor.c, win/ttkWinTheme.c, win/ttkWinXPTheme.c: ensure
	all global Ttk symbols have Ttk or ttk prefix; declare all externally
	visible Ttk symbols not contained in stubs table as MODULE_SCOPE (or as
	static when possible); so that 'make check{exports,stubs}' once again
	complete without errors.

	* macosx/tkMacOSXColor.c (TkMacOSXCompareColors): ifdef out when unused

	* macosx/Wish.xcodeproj/project.pbxproj: check autoconf/autoheader exit
	status and stop build if they fail.

	* macosx/tkMacOSXWindowEvent.c (GenerateUpdateEvent): fix handling of
	Carbon Update events: the QuickDraw window update region was being
	ignored and all child TkWindows were sent an Expose XEvent even when
	they did not need to be redrawn. [Patch 1589226]

2006-11-01  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDebug.c: add TkMacOSX prefix to leftover
	* macosx/tkMacOSXDebug.h: macosx-private global symbols without Tk
	* macosx/tkMacOSXEmbed.c: prefix; ifdef out currently unused debug
	* macosx/tkMacOSXEvent.c: procs.
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXCarbonEvents.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWm.c:

2006-10-31  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/makefile.vc: Added ttk files to msvc build and add manifest
	* win/rules.vc:    files to binaries with MSVC8.

2006-10-31  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcodeproj/project.pbxproj: add new Ttk files.

	* macosx/ttkMacOSXTheme.c: standardize header #includes.

	* unix/Makefile (checkstubs, checkexports): check ttk.decls, allow
	export of Ttk prefixed symbols.

	* generic/ttk/tkDefaultTheme.c: fix warnings.

2006-10-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/ttk_Geometry.3, doc/ttk_Theme.3, doc/ttk_button.n:
	* doc/ttk_checkbutton.n, doc/ttk_combobox.n, doc/ttk_dialog.n:
	* doc/ttk_entry.n, doc/ttk_frame.n, doc/ttk_image.n:
	* doc/ttk_intro.n, doc/ttk_label.n, doc/ttk_labelframe.n:
	* doc/ttk_menubutton.n, doc/ttk_notebook.n, doc/ttk_panedwindow.n:
	* doc/ttk_progressbar.n, doc/ttk_radiobutton.n, doc/ttk_scrollbar.n:
	* doc/ttk_separator.n, doc/ttk_sizegrip.n, doc/ttk_style.n:
	* doc/ttk_treeview.n, doc/ttk_widget.n,:
	* generic/ttk/ttk.decls, generic/ttk/ttkBlink.c:
	* generic/ttk/ttkButton.c, generic/ttk/ttkCache.c:
	* generic/ttk/ttkClamTheme.c, generic/ttk/ttkClassicTheme.c:
	* generic/ttk/ttkDecls.h, generic/ttk/ttkDefaultTheme.c:
	* generic/ttk/ttkElements.c, generic/ttk/ttkEntry.c:
	* generic/ttk/ttkFrame.c, generic/ttk/ttkImage.c:
	* generic/ttk/ttkInit.c, generic/ttk/ttkLabel.c:
	* generic/ttk/ttkLayout.c, generic/ttk/ttkManager.c:
	* generic/ttk/ttkManager.h, generic/ttk/ttkNotebook.c:
	* generic/ttk/ttkPanedwindow.c, generic/ttk/ttkProgress.c:
	* generic/ttk/ttkScale.c, generic/ttk/ttkScroll.c:
	* generic/ttk/ttkScrollbar.c, generic/ttk/ttkSeparator.c:
	* generic/ttk/ttkSquare.c, generic/ttk/ttkState.c:
	* generic/ttk/ttkStubInit.c, generic/ttk/ttkStubLib.c:
	* generic/ttk/ttkTagSet.c, generic/ttk/ttkTheme.c:
	* generic/ttk/ttkTheme.h, generic/ttk/ttkThemeInt.h:
	* generic/ttk/ttkTrace.c, generic/ttk/ttkTrack.c:
	* generic/ttk/ttkTreeview.c, generic/ttk/ttkWidget.c:
	* generic/ttk/ttkWidget.h:
	* library/demos/ttk_demo.tcl, library/demos/ttk_iconlib.tcl:
	* library/demos/ttk_repeater.tcl:
	* library/ttk/altTheme.tcl, library/ttk/aquaTheme.tcl:
	* library/ttk/button.tcl, library/ttk/clamTheme.tcl:
	* library/ttk/classicTheme.tcl, library/ttk/combobox.tcl:
	* library/ttk/cursors.tcl, library/ttk/defaults.tcl:
	* library/ttk/dialog.tcl, library/ttk/entry.tcl:
	* library/ttk/fonts.tcl, library/ttk/icons.tcl:
	* library/ttk/keynav.tcl, library/ttk/menubutton.tcl:
	* library/ttk/notebook.tcl, library/ttk/panedwindow.tcl:
	* library/ttk/progress.tcl, library/ttk/scale.tcl:
	* library/ttk/scrollbar.tcl, library/ttk/sizegrip.tcl:
	* library/ttk/treeview.tcl, library/ttk/ttk.tcl:
	* library/ttk/utils.tcl, library/ttk/winTheme.tcl:
	* library/ttk/xpTheme.tcl:
	* macosx/ttkMacOSXTheme.c:
	* tests/ttk/all.tcl, tests/ttk/bwidget.test, tests/ttk/combobox.test:
	* tests/ttk/entry.test, tests/ttk/image.test:
	* tests/ttk/labelframe.test, tests/ttk/layout.test:
	* tests/ttk/misc.test, tests/ttk/notebook.test:
	* tests/ttk/panedwindow.test, tests/ttk/progressbar.test:
	* tests/ttk/scrollbar.test, tests/ttk/treetags.test:
	* tests/ttk/treeview.test, tests/ttk/ttk.test, tests/ttk/validate.test:
	* win/ttkWinMonitor.c, win/ttkWinTheme.c, win/ttkWinXPTheme.c:
	First import of Ttk themed Tk widgets as branched from tile 0.7.8

	* generic/tkInt.h, generic/tkWindow.c: add Ttk_Init call, copy tk
	classic widgets to ::tk namespace.
	* library/tk.tcl: add source of ttk/ttk.tcl, define $::ttk::library.
	* unix/Makefile.in, win/Makefile.in: add Ttk build bits
	* win/configure, win/configure.in: check for uxtheme.h (XP theme).

2006-10-23  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.5a6
	* generic/tk.h:
	* library/tk.tcl:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

2006-10-19  Pat Thoyts  <patthoyts@users.sourceforge.net>

	*** 8.5a5 TAGGED FOR RELEASE ***

	* generic/tkImgBmap.c: Fixed line endings.
	* win/makefile.vc:  Patched up build system to manage
	* win/rules.vc:     AMD64 with MSVC8
	* win/nmakehlp.c:   Ensure operation without Platform SDK.

2006-10-18  Don Porter  <dgp@users.sourceforge.net>

	* changes:		8.5a5 release date set.

2006-10-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* doc/text.n: fix docs to not correct -tabs usage case.

	* generic/tkTextDisp.c (SizeOfTab): fix -tabstyle wordprocessor tab
	alignment to correct tab edge case. [Bug 1578858]

2006-10-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkText.c: Applied suggested patch from [Bug 1536735]
	* tests/text.test:  Update test for above patch.
	* tests/textWind.test:  Corrected test to catch all messages
	* tests/safe.test: Silence spurious win32 failure awaiting TIP150
	* tests/winDialog.test: Updated test for file name length check.
	* test/winWm.test: Corrected test expectation for menu wrapping.

2006-10-16  Andreas Kupries  <andreask@activestate.com>

	* doc/WindowId.3: Pat's commit on 2006-10-08 broke the .SH NAME
	information across several lines, breaking the cross-linking of
	manpages during installation for this one. Put everything back on a
	single line, unbreaking it.

2006-10-16  Daniel Steffen  <das@users.sourceforge.net>

	* changes: updates for 8.5a5 release.

	* macosx/tkMacOSXDraw.c: fix numerous issues in CG and QD drawing
	procs so that they now match X11 drawing much more closely [Bug
	1558051]; use Tiger ellipse drawing API when available; fix comments &
	whitespace.

	* macosx/tkMacOSXInit.c: set default linewidth limit for CG
	antialiasing to 0 as thin horizontal/vertical lines look good now.
	* macosx/README: document CG antialiasing limit changes.

	* generic/tkCanvLine.c (ConfigureLine):     on TkAqua, pass outline
	* generic/tkCanvPoly.c (ConfigurePolygon):  linewidth in gc even for
	* generic/tkRectOval.c (ConfigureRectOval): fills (as it controls AA).

	* macosx/GNUmakefile: don't redo prebinding of non-prebound binaires.

	* library/demos/pendulum.tcl: fix incorrect setting of toplevel title.

2006-10-10  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for 8.5a5 release

2006-10-08  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* generic/tkWindow.c:  Implemented TIP #264 - Tk_Interp function.
	* doc/WindowId.3:      Documented Tk_Interp.
	* generic/tk.decls:    Added to the stubs interface and
	* generic/tkDecls.h:   regenerated.
	* generic/tkStubsInit.c:

2006-10-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixFont.c (Ucs2beToUtfProc, UtfToUcs2beProc):
	(TkpFontPkgInit, encodingAliases): Correct alignment issues in
	encoding conversion. Call ucs-2be "unicode" on big-endian systems.
	[Bug 1122671]

2006-09-27  Andreas Kupries  <andreask@activestate.com>

	* unix/Makefile.in (install-binaries): Added a second guard to the
	* win/Makefile.in: package index file to prevent older versions of Tcl
	* win/makefile.vc: from seeing version numbers which may contain a/b
	information, and then balking on them. This could otherwise happen
	when Tcl/Tk 8.4 and 8.5 are installed in the same directory, seeing
	each other. [Bug 1566418]

2006-09-22  Andreas Kupries  <andreask@activestate.com>

	* generic/tkConsole.c: TIP #268 update regarding registered package
	* generic/tkMain.c:    version, now using full patchlevel instead of
	* generic/tkWindow.c:  major.minor
	* library/tk.tcl:
	* unix/configure:
	* unix/Makefile.in:
	* unix/tcl.m4:
	* win/configure:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/rules.vc:
	* win/tcl.m4:

2006-09-20  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkpPostMenu): disable menu animation in menus with
	images to avoid clipping bug. [Bug 1329198]

2006-09-21  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkImgBmap.c (ImgBmapPostscript): Change 0 to NULL, since
	they are not interchangable on all platforms in all circumstances.
	[Tcl Bug 1562528]

2006-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkMacOSXMakeRealWindowExist): revert part of
	2006-05-16 change that had set overrideredirect windows to not become
	activated by the window manager, as this prevented interaction with
	native widgets in such windows [Bug 1472624]; apply changes to carbon
	window attributes even if native window has already been created.

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): fix app
	* macosx/tkMacOSXMenu.c (DrawMenuBarWhenIdle): menu item key shortcuts
	* macosx/tkMacOSXInt.h: when custom ".apple" menu is installed.

	* library/demos/widget: on TkAqua, don't install file menu with single
	quit menu item, as the application menu already has a quit item.

	* macosx/tkMacOSXColor.c: fix building on Mac OS X 10.2.

2006-09-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXColor.c (TkSetMacColor,TkpGetColor): use AppearanceMgr
	* macosx/tkMacOSXDefault.h: to retrieve platform std colors for text
	* macosx/tkMacOSXPort.h:    selections, add "systemHighlightSecondary"
	color name for standard color of inactive selections, use this color as
	default for text widget -inactiveselectbackground to implement platform
	standard look for inactive text selections.

	* library/text.tcl (aqua): remove focus bindings to set selection color

	* generic/tkTextBTree.c (TkTextIsElided): on TkAqua, don't show
	* generic/tkTextDisp.c (GetStyle):        inactive text selection when
						  text widget is disabled.

	* generic/tkEntry.c (DisplayEntry): change default TkAqua selection
	* macosx/tkMacOSXDefault.h:         relief to "flat" (platform std).

	* generic/tkText.c (CreateWidget): fix bug leading to default text
	selection relief string DEF_TEXT_SELECT_RELIEF being ignored.

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): allow mouse
	event delivery to background windows with kWindowNoActivatesAttribute
	(e.g. overrideredirect windows), as these never come to the foreground
	they would never receive any mouse events otherwise. [Bug 1472624]

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXGenerateFocusEvent): do not
	send focus events to any windows with kWindowNoActivatesAttribute.

	* macosx/tkMacOSXXStubs.c (XQueryColor, XQueryColors): implement basic
	XColor computation from pixel values, enough to make tkImg's window.c
	happy, fixes img::window failures reported on tcl-mac.

	* macosx/tkMacOSXMenu.c (DrawMenuEntryLabel): fix leak. [Bug 1554672]

	* macosx/GNUmakefile: workaround bug in 'cp -pRH' on Darwin 6 and
	earlier, fixes 'make embedded' failure reported on tcl-mac; fix error
	from 'make deploy' with same build tree as previous 'make embedded'.

	* macosx/Wish.xcodeproj/project.pbxproj: add new tclUnixCompat.c file.

	* macosx/tkMacOSXEntry.c (TkpDrawEntryBorderAndFocus): fix typo.

	* unix/tcl.m4: sync with tcl/unix/tcl.m4.
	* unix/configure: autoconf-2.59

2006-09-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkEntry.c:   move hard-coded ALWAYS_SHOW_SELECTION control
	* generic/tkInt.h:     of entry/text selection display based on focus
	* generic/tkText.c:    to the Tcl level, controlled by
	* generic/tkWindow.c:  ::tk::AlwaysShowSelection (boolean, private).
	* library/tk.tcl:      [Bug 1553691]
	* macosx/tkMacOSXDefault.h:
	* unix/tkUnixDefault.h:
	* unix/tkUnixPort.h:
	* win/tkWinDefault.h:

2006-08-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinKey.c: Add WM_UNICHAR window message support (used by
	* win/tkWinX.c:   virtual keyboard apps). [Bug 1518677] (petasis)

2006-08-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValues): set native scrollbar
	control bounds only once all size adjustments have been computed.
	Fixes issue with grow icon obscuring scrollbar reported on tcl-mac.

2006-08-21  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXCarbonEvents.c (CarbonTimerProc): avoid starving main
	event loop: limit the number of tcl events processed per invocation.
	Fixes bug reported on tcl-mac by Kevan Hashemi.

2006-08-18  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* tests/text.test (text-25.15): Added test suggested by Sam
	<baudinm@yahoo.com> on comp.lang.tcl

	* generic/tk.h, generic/tkInt.h: Stylistic improvements. No API change.

2006-08-18  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add support for --enable-64bit on x86_64, for
	universal builds including x86_64, for 64-bit CoreFoundation on Leopard
	and for use of -mmacosx-version-min instead of MACOSX_DEPLOYMENT_TARGET
	* unix/configure.in (Darwin): remove 64-bit arch flags from CFLAGS for
	combined 32-bit and 64-bit universal builds, as neither TkAqua nor
	TkX11 can be built for 64-bit at present.
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

	* macosx/Wish.xcodeproj/project.pbxproj: switch native release targets
	to use DWARF with dSYM, Xcode 3.0 changes.
	* macosx/README: updates for x86_64 support in Tcl.

	* macosx/tkMacOSXInit.c (TkpInit): when available, use public
	TransformProcessType() API instead of CPSEnableForegroundOperation()
	SPI to notify the window server that we are a GUI application.

	* macosx/tkMacOSXWm.c (WmAttrGetTitlePath): use HIWindow API on >=Tiger

	* macosx/tkMacOSXMouseEvent.c (GenerateToolbarButtonEvent):
	* macosx/tkMacOSXMenus.c (GenerateEditEvent):
	* macosx/tkMacOSXMenu.c (MenuSelectEvent): bzero() the XVirtualEvent
	structure before use to ensure all fields are initialized. [Bug
	1542205]

2006-08-16  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXWm.c (WmAttributesCmd): correct OS X result for [wm
	attributes $top].

2006-07-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): handle key
	shortcut for kHICommandQuit in the same way as other application menu
	item key shortcuts. [Bug 1516950]

2006-07-24  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkWmMapWindow): fix incorrect values of wmInfo
	parentWidth/Height for toplevels by recalculating them once the window
	is mapped (i.e once the window&structure sizes are known). [Bug
	1358663]
	(ParseGeometry): sync with ParseGeometry in tkUnixWm.c/tkWinWm.c.

2006-07-21  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkBind.c (TkBindInit): for REDO_KEYSYM_LOOKUP, change
	keysym-to-string mapping hash to use first name in ks_names.h instead
	of last (if there are multiple possibilities), e.g. "F11" instead of
	"L1".

	* macosx/tkMacOSXKeyboard.c (TkpGetKeySym): correct keysyms for pure
	modifier key presses [Bugs 700311, 1525905]; correct keysym for Enter
	key; add keysyms for new NumLock and Fn modifiers (added 2005-08-09).

2006-07-20  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmAttributesCmd, WmIconbitmapCmd): add support
	* unix/tkUnixSend.c (Tk_GetUserInactiveTime):             for weakly
	importing symbols not available on OSX 10.2 or 10.3, enables binaires
	built on later OSX versions to run on earlier ones.
	* macosx/Wish.xcodeproj/project.pbxproj: enable weak-linking; turn on
	                                         extra warnings.
	* macosx/README: document how to enable weak-linking; cleanup.
	* unix/configure.in: add check on Darwin-X11 for ld support of -weak-l
	* unix/tcl.m4:       flag and weak-link libXss if possible as it is not
	available before OSX 10.4; enforce requirement of OSX 10.2 for TkAqua;
	move Darwin specific checks & defines that are only relevant to the tcl
	build out of tcl.m4; restrict framework option to Darwin; clean up
	quoting and help messages.
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

	* macosx/GNUmakefile: enable xft for TkX11 build.
	* macosx/tkMacOSXFont.c (TkMacOSXQuarzStartDraw, TkMacOSXQuarzEndDraw):
	verify validity of context returned from QDBeginCGContext() before use.
	* macosx/tkMacOSXKeyEvent.c: ifdef out diagnostic messages to stderr.

	* macosx/tkMacOSXEvent.h:      standardize MAC_OS_X_VERSION_MAX_ALLOWED
	* macosx/tkMacOSXMenu.c:       checks per QA1316, ensure define can be
	* macosx/tkMacOSXMenubutton.c: overridden on command line (from default
	* macosx/tkMacOSXMenus.c:      of current OS version).
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWm.c:

	* generic/tkImgGIF.c (ReadImage):
	* macosx/tkMacOSXCursor.c (TkMacOSXCursor):
	* macosx/tkMacOSXDebug.c (TkMacOSXGetNamedDebugSymbol):
	* macosx/tkMacOSXFont.c (TkpMeasureCharsInContext):
	* macosx/tkMacOSXInit.c (Map):
	* xlib/xgc.c (XCreateGC): fix signed-with-unsigned comparison and other
	warnings from gcc4 -Wextra.

2006-07-14  Andreas Kupries  <andreask@activestate.com>

	* generic/tkWindow.c (Initialize): Modify change of 2006-05-25 (jeffh).
	Release mutex a bit earlier, to prevent lock when OS X creates its
	console windows (recursively enters Tk_Init). Patch by JeffH.

2006-07-06  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/tkfbox.tcl: catch scrollbar use of highlightthickness

2006-06-21  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/bgerror.tcl (::tk::dialog::error::bgerror): remove a couple
	of unnecessary hardcoded options

2006-06-14  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkScale.c: Revised variable writing logic to account for
	[scale]'s design that it deals with its value as a formatted string,
	and not as a double. [Bug 891141]

2006-06-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXSubwindows.c (TkMacOSXInvalidateWindow): ensure
	invalid clip regions are recreated via TkMacOSXUpdateClipRgn() before
	they are used; correct call order of TkMacOSXInvalidateWindow() and
	TkMacOSXInvalClipRgns() throughout. [Bug 1501922]

	* macosx/tkMacOSXDraw.c (TkPutImage): implement drawing of very wide
	images in slices of less than 4096 pixels to workaround CopyBits
	limitation. [Bug 950121]

2006-06-09  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkMain.c:	Added Tcl_Preserve() call on the master interp
	as crash protection against any Tcl_DeleteInterp() call that might
	happen.

2006-06-01  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Added Tcl_RegisterChannel() calls to bump the
	refcount of channels passed to Tcl_SetStdChannel(). This prevents early
	free-ing of the channels that leads to crashes. [Bug 912571]

2006-05-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinEmbed.c (TkpGetOtherWindow):   Do not panic if no window is
	* unix/tkUnixEmbed.c (TkpGetOtherWindow): found; caller handles. [Bug
	* unix/tkUnixWm.c (Tk_CoordsToWindow, UpdateGeometryInfo): 1212056]

	* tests/entry.test (entry-22.1):
	* tests/listbox.test (listbox-6.15):
	* generic/tkListbox.c (ListboxInsertSubCmd, ListboxDeleteSubCmd):
	Ignore Tcl_SetVar2Ex failure of listVarName, similar to entry widget
	handling. [Bug 1424513]

2006-05-26  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXButton.c (TkMacOSXDrawControl): correct redraw for
	direct transition from disabled to active state. [Bug 706446]

2006-05-25  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinMenu.c (TkWinMenuKeyObjCmd): get eventPtr after we know the
	window is still alive. [AS bug 45987] [Bug 1236306]

	* generic/tkMenu.c (DeleteMenuCloneEntries): Modify entry index
	changes to work around VC6 optimization bug. [Bug 1224330]

	* generic/tkMessage.c (MessageWidgetObjCmd): Correct msgPtr
	preserve/release pairing. [Bug 1485750] (afredd)

	* generic/tkWindow.c (Initialize): Correct mutex (un)lock pairing.
	[Bug 1479587] (loewis)

	* generic/tkBind.c (Tk_BindEvent, TkCopyAndGlobalEval): use Tcl_EvalEx
	instead of Tcl_GlobalEval.

2006-05-16  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWindowEvent.c (TkMacOSXGenerateFocusEvent): don't send
	focus events to windows of class help or to overrideredirect windows.
	[Bug 1472624]

	* macosx/tkMacOSXWm.c: set overrideredirect windows to not become
	activated by the window manager and to not receive OS activate events
	(should make them behave more like on other platforms); use modern
	window class API for overrideredirect and transient windows; set the
	default class of overrideredirect windows to 'simple' rather than
	'plain' (i.e. no window frame); add missing Panther and Tiger window
	attributes to [::tk::unsupported::MacWindowStyle].

2006-05-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock): Fix
	opt added 2006-03 that caused slowdown for some common cases. [Bug
	1409140]

2006-05-13  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkCanvWind.c (DisplayWinItem, WinItemRequestProc): ensure
	canvas window items are unmapped when canvas is unmapped. [Bug 940117]

	* macosx/tkMacOSXSubwindows.c (TkMacOSXUpdateClipRgn): empty clip
	region of unmapped windows to prevent any drawing into them or into
	their children from becoming visible. [Bug 940117]

	* macosx/tkMacOSXInt.h:         revert Jim's attempt of 2005-03-14 to
	* macosx/tkMacOSXSubwindows.c:  fix Bug 940117 as it disables Map/Unmap
	event propagation to children. [Bug 1480105]

	* macosx/tkMacOSXDraw.c (TkPutImage): handle tkPictureIsOpen flag,
	fixes incorrect positioning of images with complex alpha on native
	buttons; actual alpha blending is still broken in this situation. [Bug
	1155596]

	* macosx/tkMacOSXEvent.c (TkMacOSXProcessCommandEvent):
	* macosx/tkMacOSXMenus.c (TkMacOSXInitMenus): workaround carbon bug
	with key shortcut for 'Preferences' app menu item. [Bug 1481503]

	* macosx/tkMacOSXKeyEvent.c (TkMacOSXProcessKeyboardEvent): only check
	for HICommand menu item shortcuts in the application menu.

	* macosx/tkMacOSXInt.h:       initialize keyboard layout setup in
	* macosx/tkMacOSXInit.c:      TkpInit() rather than during handling of
	* macosx/tkMacOSXKeyEvent.c:  first key down event.

	* macosx/tkMacOSXDraw.c:        add optional debug code to flash clip
	* macosx/tkMacOSXSubwindows.c:  regions during update or draw.

2006-05-04  Don Porter  <dgp@users.sourceforge.net>

	* README:		Bump version number to 8.5a5
	* generic/tk.h:
	* unix/configure.in:
	* unix/tk.spec:
	* win/configure.in:

	* unix/configure:	autoconf-2.59
	* win/configure:

2006-04-28  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (TkWmMapWindow, InitialWindowBounds): fix use of
	potentially stale window position in initial configure event on first
	map of a window. [Bug 1476443]
	(TkMacOSXWindowOffset): use modern GetWindowStructureWidths API.

	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXMouseEvent.c (TkGenerateButtonEventForXPointer): new
	internal function to generate button events for current pointer
	directly, without requiring prior call to XQueryPointer().

	* macosx/tkMacOSXMouseEvent.c (XQueryPointer): implement return of
	window-local pointer position.

	* macosx/tkMacOSXInt.h:      use improvements above to avoid calls to
	* macosx/tkMacOSXKeyEvent.c: GlobalToLocal() when the current port
	* macosx/tkMacOSXMenu.c:     might not be set correctly. May fix [Bug
	* macosx/tkMacOSXMenus.c:    1243318]
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:

	* tkAboutDlg.r: update copyright.

	* macosx/tkMacOSXDebug.h: sync #includes with core-8-4-branch.
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXFont.h:

2006-04-26  Don Porter  <dgp@users.sourceforge.net>

	*** 8.5a4 TAGGED FOR RELEASE ***

	* changes:	Updates for next RC

2006-04-25  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* unix/tkUnixFont.c (TkpGetFontFamilies): Fix crash caused when the
	XServer returns invalid font names. [Bug 1475865]

2006-04-23  Vince Darley  <vincentdarley@users.sourceforge.net>

	* tests/scrollbar.test: fix to tkAqua test failures

2006-04-18  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXEmbed.c: fix to [Bug 1088814] test failures in
	embed.test

	* macosx/tkMacOSXWm.c:
	* tests/constraints.tcl:
	* tests/wm.test: fix to 'wm attributes' test for TkAqua

2006-04-11  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkWindow.c (Tk_NameToWindow): Allow NULL interp to
	Tk_NameToWindow. This fixes TkGetWindowFromObj which promises to handle
	NULL but didn't.

	* generic/tkGrid.c: Fixed handling of out of bounds row or column.
	* tests/grid.test:  [Bug 1432666]

2006-04-11  Don Porter  <dgp@users.sourceforge.net>

	* unix/Makefile.in:	Updated `make dist` target to be sure the
	message catalogs for the widget demo get packaged into the source code
	distribution. [Bug 1466509]

2006-04-11  Daniel Steffen  <das@users.sourceforge.net>

	* changes: added latest aqua bug fixes.

	* macosx/tkMacOSXDialog.c (Tk_MessageBoxObjCmd): added standard Escape
	key binding for msgbox cancel buttons [Patch 1193614], whitespace.

	* macosx/tkMacOSXCarbonEvents.c: handle kEventCommandUpdateStatus
	* macosx/tkMacOSXEvent.c:        carbon event to dynamically enable
	the 'Preferences' app menu item when proc [::tk::mac::ShowPreferences]
	is defined. [Bug 700316]

	* macosx/tkMacOSXHLEvents.c:    call ::tk::mac::* procs for all
	* macosx/tkMacOSXWindowEvent.c: registered appleevents [FR 1105284],
	implement print applevent handling, style/whitespace cleanup.

	* macosx/tkMacOSXDraw.c (TkMacOSXInitCGDrawing): prevent multiple init.

	* macosx/tkMacOSXFont.c: remove #ifdef'd text measuring codepaths now
	* macosx/tkMacOSXInit.c: known to be incorrect, cleanup obsolete text
	* macosx/README:         antialiasing control code, document ATSUI text
				 antialiasing changes.

	* macosx/tkMacOSXInt.h:         Implemented 'zoomed' window state
	* macosx/tkMacOSXWindowEvent.c: handling for TkAqua, via titlebar
	* macosx/tkMacOSXWm.c:          widget clicks as well as [wm state].
	* doc/wm.n:                     [Bug 1073456]

2006-04-10  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/tkfbox.tcl (::tk::IconList_Goto): Fix prefix searching so
	that the start location is reasonable, and the prefix matching is using
	the correct Tcl command for this. [Bug 1467938]

2006-04-10  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* macosx/tkMacOSXFont.c (MeasureStringWidth): Use implementation based
	on ATSUGetGlyphBounds (TK_MAC_USE_GETGLYPHBOUNDS), so we can use
	kATSUseFractionalOrigins. This in turn corrects [Bug 1461650].
	(InitFont): Use "." and "W" instead of "i" and "w" to determine the
	"-fixed" attribute. This prevents "Apple Chancery" from being
	classified as fixed.
	(InitFontFamilies): Only get the font families once.

2006-04-09  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmResizableCmd): propagate window attribute
	changes to Carbon window manager. [FR 1467004]
	(TkSetWMName, TkMacOSXMakeRealWindowExist): allow empty name for
	toplevels, remove bogus initial window name. [Bug 1450800]

2006-04-07  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): fix return
	values, implement window dragging & growing in background (with Command
	key down) and by fronting clicks [Bug 934524], use correct button &
	modifier state API when application is in background (also in
	TkMacOSXButtonKeyState).

	* macosx/tkMacOSXWm.c (TkMacOSXGrowToplevel): ensure QD port is set
	correctly before using API relying on it.

2006-04-06  Vince Darley  <vincentdarley@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c: Now that [wm attributes -titlepath]
	works correctly, add OS support for dragging proxy icons and using the
	titlepath menu.

2006-04-06  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXWm.c (WmAttributesCmd, WmIconbitmapCmd): fix errors in
	setting/removing window proxy icons via [wm attributes -titlepath] and
	[wm iconbitmap], use HIWindow API on Tiger or later. [Bug 1455241]

	* unix/tcl.m4: remove TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING
	define on Darwin. [Tcl Bug 1457515]
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

2006-04-05  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkWindow.c (Initialize): remove impotent use of
	DeleteWindowsExitProc as a global exit handler.

	* generic/tkMenu.c (TkSetWindowMenuBar): remove extra TkMenuInit call
	that caused finalization panic. [Bug 1456851]
	* win/tkWinMenu.c (FreeID, TkpNewMenu, MenuExitHandler)
	(MenuThreadExitHandler, TkpMenuInit, TkpMenuThreadInit): rework Windows
	menu init/finalization to better respect per-process and per-thread
	boundaries. [Bug 1456851]
	(TkWinMenuKeyObjCmd): Do not error when unknown window is passed in.
	[Bug 1236306]

	* win/tkWinX.c (TkWinXInit): init default keyboard charset correctly.
	[Bug 1374119] (pajas)

	* win/tkWinWm.c (WmProc): pass WM_QUERYENDSESSION message to Tk as
	WM_SAVE_YOURSELF wm protocol callback.

	* tests/textWind.test (textWind-10.6.1): prevent infinite update loop
	in case of test failure.

	* tests/wm.test (wm-attributes-1.2.4): correct expected result.

	* tests/grid.test: fix segfault on empty or "all" index list
	* generic/tkGrid.c (GridRowColumnConfigureCommand): [Bug 1422430]

2006-04-05  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tkText.c: fix to crash caused on some platforms by new tests
	introduced to check for [Bug 1414171], which destroy the text widget in
	the dump callback script.

2006-03-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkOption.c (TkOptionDeadWindow): handle OptionThreadExitProc
	being called before DeleteWindowsExitProc.

	* win/Makefile.in: convert _NATIVE paths to use / to avoid ".\"
	path-as-escape issue.

2006-03-29  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for next RC

	* unix/tkUnixDefault.h: Changed "Black" to "#000000" and "White" to
	"#ffffff" to work around the (broken?) X servers that do not accept
	those color names. [Bug 917433]

2006-03-28  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, win/tcl.m4: []-quote AC_DEFUN functions.

2006-03-26  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tkText.c:
	* tests/text.test: Fix for elaborations of [Bug 1414171] for '$text
	dump -command <script>' where script deletes large portions of the
	text widget, or even destroys the widget.

2006-03-28  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcode/default.pbxuser:     add '-singleproc 1' cli arg to
	* macosx/Wish.xcodeproj/default.pbxuser: tktest to ease test debugging.

	* macosx/Wish.xcode/project.pbxproj:     removed $prefix/share from
	* macosx/Wish.xcodeproj/project.pbxproj: TCL_PACKAGE_PATH as per change
	to tcl/unix/configure.in of 2006-03-13.

	* macosx/tkMacOSXDraw.c:   sync whitespace & minor changes with
	* macosx/tkMacOSXEvent.h:  core-8-4-branch.
	* macosx/tkMacOSXFont.h:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXNotify.c:

2006-03-27  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for next RC

2006-03-27  Benjamin Riefenstahl  <b.riefenstahl@turtle-trading.net>

	* generic/tkTextDisp.c (MeasureChars): Fix calculations of start and
	end of string. [Bugs 1325998, 1456157]

2006-03-27  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkImgGIF.c (FileReadGIF): Stop crashes when the first GIF
	frame does not define the overall size of the image. [Bug 1458234]

2006-03-26  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tkText.c:
	* generic/tkText.h:
	* generic/tkTextBTree.c:
	* tests/text.test: Fix for [Bug 1414171] for '$text dump -command
	<script>' where 'script' actually modifies the widget during the
	process.

2006-03-25  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c (TkMacOSXSetUpCGContext):
	* macosx/tkMacOSXFont.c (TkMacOSXQuarzStartDraw, TkMacOSXQuarzEndDraw):
	performance improvements, sync similar code, formatting & whitespace.

2006-03-24  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkTextDisp.c:   Moved #ifdef MAC_OSX_TK code added by
	* macosx/tkMacOSXColor.c: [Patch 638966] into platform specific files.
	* macosx/tkMacOSXInt.h:

	* macosx/tkMacOSX.h:             Cleaned up & rationalized order of
	* macosx/tkMacOSXBitmap.c:       #includes of tk and carbon headers.
	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXCarbonEvents.c:
	* macosx/tkMacOSXClipboard.c:
	* macosx/tkMacOSXColor.c:
	* macosx/tkMacOSXConfig.c:
	* macosx/tkMacOSXCursor.c:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEmbed.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXFont.h:
	* macosx/tkMacOSXHLEvents.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXKeyboard.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXRegion.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXScrlbr.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXWm.h:
	* macosx/tkMacOSXXStubs.c:

2006-03-23  Reinhard Max  <max@tclers.tk>

	* unix/tkUnixRFont.c (TkpMeasureCharsInContext): Copied over from
	tkUnixFont.c to fix compiling with --enable-xft .

	* unix/tk.spec: Cleaned up and completed. An RPM can now be built from
	the tk source distribution with "rpmbuild -tb <tarball>".

2006-03-23  Don Porter  <dgp@users.sourceforge.net>

	* tests/textDisp.test: Updated expected error messages to match the
	standardized formats established on 2005-11-17. [Bug 1370296]

2006-03-22  Don Porter  <dgp@users.sourceforge.net>

	* changes:	Updates for next RC

2006-03-21  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkFont.c:             implementation of ATSUI text rendering
	* generic/tkInt.h:              in TkAqua provided by Benjamin
	* generic/tkTextDisp.c:         Riefenstahl. [Patch 638966]
	* library/demos/unicodeout.tcl:
	* macosx/tkMacOSXFont.h (new file):
	* macosx/tkMacOSXFont.c:
	* tests/font.test:
	* unix/tkUnixFont.c:
	* win/tkWinFont.c:

	* generic/tkFont.c:             moved MODULE_SCOPE declarations of font
	* generic/tkFont.h:             helper procs into header files.
	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXFont.h:
	* macosx/tkMacOSXMenubutton.c:

	* macosx/Wish.xcode/project.pbxproj:     add new tkMacOSXFont.h file,
	* macosx/Wish.xcodeproj/project.pbxproj: turn off dead code stripping
	as it interferes with -sectcreate (rdar://4486223).

	* macosx/Wish.xcode/default.pbxuser:     add TCLLIBPATH=/Library/Tcl
	* macosx/Wish.xcodeproj/default.pbxuser: env var setting to tktest.

	* unix/configure.in: fix detection of symbols build when enabling
	TkAqua debug code; filter nm output of libtclstub better to avoid
	error on intel macs. [Bug 1415789]
	* unix/configure: autoconf-2.59

2006-03-20  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Added exit handler to clean up the interp where
	the console window lives. Also added code to handle multiple calls to
	Tk_CreateConsoleWindow so that the console channels connect to the last
	console window opened, in compatibility with the previous
	implementation.

2006-03-18  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tkText.c: Fix for undo/modified status of text widgets when
	empty strings are inserted and undone.

2006-03-17  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* library/clrpick.tcl:   Avoid using abbreviated sub-commands in core
	* library/palette.tcl:   scripts as this can cause problems with
	* library/scale.tcl:     mega-widget libraries like snit.
	* library/scrlbar.tcl:	 [Bug 1451587]
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:

2006-03-16  Don Porter  <dgp@users.sourceforge.net>

	* generic/tkConsole.c:	Substantial rewrite of [console] support.
	* generic/tkInt.h:	Included Obj-ification of the [console] and
	[consoleinterp] commands, and reworking of all the supporting data
	structures for cleaner sharing and lifetime management especially in
	multi-threaded configurations.

2006-03-16  Donal K. Fellows  <dkf@users.sf.net>

	* library/msgs/pt.msg: Messages for Portuguese (strictly just for
	Brazilian Portuguese, but they'll do until we get other Portuguese
	speakers localize) from Ricardo Jorge <ricardoj@users.sf.net> and Silas
	Justiano <silasj@users.sf.net>. Many thanks! [Bug 1405069]

	* generic/tkImgPhoto.c (ImgPhotoCmd, Tk_PhotoPutBlock)
	(Tk_PhotoPutZoomedBlock): Added hack to detect copying of a photo with
	a simple alpha channel and skip calling ToggleComplexAlphaIfNeeded.
	This should speed up many photo-to-photo copies, keeping the cost of
	the alpha channel down.

2006-03-15  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkImgPhoto.c (Tk_PhotoPutBlock, Tk_PhotoPutZoomedBlock): Try
	to squelch performance issue with code that writes to large images by
	single pixels. Masses of thanks to George Staplin for helping to trace
	this down to the COMPLEX_ALPHA flag handling code. [Bug 1409140]

2006-03-13  Don Porter  <dgp@users.sourceforge.net>

	* tests/scrollbar.test: Corrected several broken calls to [testmetrics]
	that were crashing the test suite.

	* tests/constraints.tcl:        Added notAqua constraint to canvPs-3.1
	* tests/canvPs.test:            to stop test suite crash on Mac OSX.
					[Bug 1088807]

	* generic/tkCmds.c:		Purged remaining references to errno,
	* macosx/tkMacOSXPort.h:	and errno.h. Standardized the logic
	* macosx/tkMacOSXWm.c:		for using header files from the compat
	* macosx/tkMacOSXWm.h:		directory. Thanks Joe English for the
	* unix/tkUnixPort.h:		patch. [Patch 1445404]

2006-03-08  Don Porter	<dgp@users.sourceforge.net>

	* unix/Makefile.in: Update `make dist` to copy the image files needed
	by the test suite into the source distro. This was overlooked in the
	2005-10-12 commit.

	* changes:	Update in prep. for 8.5a4 release.

2006-03-07  Joe English  <jenglish@users.sourceforge.net>

	* unix/tcl.m4: Set SHLIB_LD_FLAGS='${LIBS}' on NetBSD, as per the other
	*BSD variants. [Bug 1334613]
	* unix/configure: Regenerated.

2006-03-07  Donal K. Fellows  <dkf@users.sf.net>

	* doc/canvas.n: Added note that stipples are not well-supported on
	non-X11 platforms. [Bug 220787] It's not a great solution, but it does
	indicate the state of affairs that has existed for years anyway; not
	much modern software uses stipples anyway.

2006-03-02  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXDraw.c (TkPutImage): Fix endian issue on OS X x86
	displaying images. Bitmap images still have a black/white reversal
	issue, appears to be a general OS X issue (as seen in frogger demo).

2006-02-27  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkBitmap.c (Tk_GetBitmapFromData): Improve thread-safety.
	[Bug 470322]

	* generic/tkImgBmap.c (ImgBmapConfigureInstance): Force creation of new
	Pixmaps before deletion of old ones to prevent stupid caching problems.
	[Bug 480862]

2006-02-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tk.decls:             fix signature of TkMacOSXInvalClipRgns
	* generic/tkPlatDecls.h:        to use Tk_Window instead of internal
	* macosx/tkMacOSXSubwindows.c:  type TkWindow (which led to any include
	* macosx/tkMacOSXWindowEvent.c: of public header tkMacOSX.h requiring
	* macosx/tkMacOSXWm.c:          prior include of tkInt.h).

	* generic/tk.h:          move TkAqua specific REDO_KEYSYM_LOOKUP define
	* macosx/tkMacOSXPort.h: out of tk.h into platform header.

2006-01-31  Donal K. Fellows  <dkf@users.sf.net>

	* library/bgerror.tcl (::tk::dialog::error::bgerror): Finish the
	internationalization of the error dialog. [Bug 1409264]

2006-01-25  Don Porter	<dgp@users.sourceforge.net>

	* library/bgerror.tcl: Updates to use Tcl 8.4 features. [Patch 1237759]
	* library/choosedir.tcl:
	* library/comdlg.tcl:
	* library/console.tcl:
	* library/dialog.tcl:
	* library/focus.tcl:
	* library/msgbox.tcl:
	* library/palette.tcl:
	* library/tk.tcl:
	* library/tkfbox.tcl:
	* library/xmfbox.tcl:

2006-01-23  Daniel Steffen  <das@users.sourceforge.net>

	* unix/configure:    minor fix to Darwin specific code removing
	* unix/configure.in: 64bit flags from CFLAGS for Tk build.

2006-01-20  Joe English  <jenglish@users.sourceforge.net>

	* generic/tkEvent.c, unix/tkUnixEvent.c: XIM fixes [See 905830, patch
	tk84-xim-fixes.patch], and revert 2005-12-05 patch disabling XIM when
	SCIM in use, and make sure all X events get passed to XFilterEvent,
	including those without a corresponding Tk window.

2006-01-13  Anton Kovalenko  <a_kovalenko@users.sourceforge.net>

	* generic/tkUndo.c (TkUndoSetDepth): Don't free TkUndoSubAtoms for
	separator entries that are deleted: there is some unpredictable garbage
	instead of subatoms.

	Free both 'apply' and 'revert' action chains for non-separator entries.

2006-01-12  Donal K. Fellows  <dkf@users.sf.net>

	TIP #260 IMPLEMENTATION

	* generic/tkCanvText.c (TextItem, CreateText, DisplayCanvText):
	* doc/canvas.n:		Code, docs and tests to implement an -underline
	* tests/canvText.test:	option for canvases' text items.

2006-01-11  Peter Spjuth  <peter.spjuth@space.se>

	* generic/tkGrid.c: Removed a lingering error message from TIP#147
	implementation.

2006-01-10  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDebug.c: add TkMacOSXGetNamedDebugSymbol() function
	* macosx/tkMacOSXDebug.h: that finds unexported symbols in loaded
	libraries by manually walking their symbol table; only to be used for
	debugging purposes, may break unexpectedly in the future. Needed to get
	access to private_extern internal debugging functions in HIToolbox.

	* macosx/tkMacOSXCarbonEvents.c: fix debug event tracing on Tiger.
	* macosx/tkMacOSXMenu.c: add debug menu printing during reconfigure.
	* macosx/tkMacOSXInit.c: conditionalize 64bit-unsafe dyld code.
	* macosx/GNUmakefile: add 'wish8.x' symlink to SYMROOT.

	* macosx/Wish.xcode/project.pbxproj:     fix copy to tktest resource
	* macosx/Wish.xcodeproj/project.pbxproj: fork when zerolinked.

	* macosx/Wish.xcode/default.pbxuser:     add widget demo as argument to
	* macosx/Wish.xcodeproj/default.pbxuser: executables (on by default).

	* unix/configure:    add caching, use AC_CACHE_CHECK instead of
	* unix/configure.in: AC_CACHE_VAL where possible, consistent message
	* unix/tcl.m4:       quoting, sync relevant tclconfig/tcl.m4 changes
	and gratuitous formatting differences, fix SC_CONFIG_MANPAGES with
	default argument, Darwin improvements to SC_LOAD_*CONFIG.

2005-12-28  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkUndo.c (TkUndoSetDepth): Apply [Patch 1391939] from Ludwig
	Callewaert to fix [Bug 1380427].

2005-12-14  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/Wish.xcode/project.pbxproj:
	* macosx/Wish.xcodeproj/project.pbxproj: add new tclTomMath* files.

2005-12-13  Daniel Steffen  <das@users.sourceforge.net>

	* library/demos/cscroll.tcl: add MouseWheel bindings for aqua.

	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent)
	(GenerateMouseWheelEvent): add support for kEventMouseScroll events
	(smooth mouse wheel scrolling from mighty mouse or scrolling trackpad)
	by handling kEventMouseWheelMoved on application target as well as on
	dispatcher, in order to pick up synthesized MouseWheel events from
	HIObject handler (c.f. QA1453); add support for horizontal scrolling
	events by generating MouseWheel XEvent with Shift modifier.

2005-12-12  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tcl.m4, unix/configure: Fix sh quoting error reported in
	bash-3.1+ [Bug 1377619] (schafer)

2005-12-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/tkWinWm.c (WinSetIcon): Don't check result of SetClassLong() or
	SetClassLongPtr() since it was generating an incorrect error and the
	MSDN docs indicate that the result need not be checked.

2005-12-09  Mo DeJong  <mdejong@users.sourceforge.net>

	* win/configure: Regen.
	* win/tcl.m4 (SC_CONFIG_CFLAGS): Define MACHINE for gcc builds. The
	lack of a definition of this variable in the manifest file was causing
	a runtime error in wish built with gcc.

2005-12-09  Daniel Steffen  <das@users.sourceforge.net>

	* generic/tkInt.decls:  Move all platform test sources from tk lib into
	* generic/tkTest.c:     tktest directly, removes requirement to export
	* macosx/tkMacOSXTest.c:TkplatformtestInit from internal stubs table.
	* unix/Makefile.in:
	* win/Makefile.in:
	* win/makefile.vc:
	* win/tkWinTest.c:

	* generic/tkIntPlatDecls.h:
	* generic/tkStubInit.c: regen.

2005-12-08  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tcl.m4:       Add build support for Windows-x64 builds.
	* win/configure:    --enable-64bit now accepts =amd64|ia64 for
	* win/Makefile.in:  Windows 64-bit build variants (default: amd64)
	* win/makefile.vc:  [Bug 1369597]
	(TKOBJS): add tkWinTest.obj to regular Tk obj for TkplatformtestInit

	* win/configure.in: Add CE build support (some C code fixes needed)
	* win/wish.exe.manifest.in (new):     manifest must map in MACHINE and
	* win/rc/wish.exe.manifest (removed): VERSION to be correct.
	* unix/Makefile.in: fix dist target for manifest dir change

	* generic/tkTextTag.c (TkTextTagCmd): use correct arraySize for peered
	text widgets in [$text tag names]. [Bugs 1375069, 1374935]

2005-12-08  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXDraw.c:  Remove inclusion of tclInt.h and use of tcl
	* macosx/tkMacOSXFont.c:  internals wherever possible in tk/macosx, the
	* macosx/tkMacOSXInit.c:  only remaining tcl internals in TkAqua are
	* macosx/tkMacOSXNotify.c:TclServiceIdle() in tkMacOSXScrlbr.c and
	* macosx/tkMacOSXScrlbr.c:Tcl_Get/SetStartupScript() in tkMacOSXInit.c
				  [RFE 1336531]

	* macosx/tkMacOSXInt.h: sync comments with core-8-4-branch.

2005-12-07  Jeff Hobbs  <jeffh@ActiveState.com>

	* unix/tkUnixEvent.c (OpenIM): remove extraneous const

2005-12-06  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* doc/ConfigWidg.3 (TK_CONFIG_OPTION_SPECIFIED): Mentioned that the
	flag is deprecated because it is not thread-safe.

2005-12-05  Reinhard Max  <max@suse.de>

	* unix/tkUnixEvent.c (OpenIM): Added a workaround to allow at least
	ASCII and the Compose key when typing into text and entry widgets on a
	system that uses SCIM. This has to be taken out again once the SCIM
	problems have been fixed.

2005-12-01  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): fixed error when MACOSX_DEPLOYMENT_TARGET unset
	* unix/configure: regen.

2005-11-30  Jeff Hobbs  <jeffh@ActiveState.com>

	* win/tkWinWm.c (WmAttributesCmd): set (no)topmost window aspect before
	rewrapping. [Bug 1086049]

	* macosx/tkMacOSXXStubs.c (TkpOpenDisplay, TkMacOSXDisplayChanged):
	* macosx/tkMacOSXWindowEvent.c (TkMacOSXProcessApplicationEvent):
	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXEvent.h: Trap kEventAppAvailableWindowBoundsChanged
	* macosx/tkMacOSXInt.h:   event to watch for change in display size and
	adjust internal state appropriately.

	* doc/checkbutton.n: fix -selectcolor docs. [Bug 1083838]

	* generic/tkImgGIF.c: cast calls to blockOut

	* win/Makefile.in: place TCL_BIN_DIR first in PATH for targets to get
	Tcl built dll first.
	Add tkWinTest.obj to tk84.dll to handle some needed test functions
	being defined in stubs (TkplatformtestInit).

	* tests/scrollbar.test (6.22): fix rounding-error sensitive test

2005-11-29  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/console.tcl (::tk::ConsoleInit): improve work-around to avoid
	'% ' from tclMain.c. [Bug 1252259]

2005-11-27  Daniel Steffen  <das@users.sourceforge.net>

	* unix/tcl.m4 (Darwin): add 64bit support, check for Tiger copyfile(),
	add CFLAGS to SHLIB_LD to support passing -isysroot in env(CFLAGS) to
	configure (flag can't be present twice, so can't be in both CFLAGS and
	LDFLAGS during configure), don't use -prebind when deploying on 10.4,
	define TCL_IO_TRACK_OS_FOR_DRIVER_WITH_BAD_BLOCKING (rdar://3171542).
	(SC_ENABLE_LANGINFO, SC_TIME_HANDLER): add/fix caching, fix obsolete
	autoconf macros. Sync with tcl/unix/tcl.m4.

	* unix/configure.in: fix obsolete autoconf macros, sync gratuitous
	formatting/ordering differences with tcl/unix/configure.in.

	* unix/Makefile.in: add CFLAGS to wish/tktest link to make executable
	linking the same as during configure (needed to avoid loosing any
	linker relevant flags in CFLAGS, in particular flags that can't be in
	LDFLAGS). Avoid concurrent linking of wish and compiling of
	tkTestInit.o during parallel make, fix dependencies and flags for
	building tkMacOSXInit.o
	(checkstubs, checkexports): dependency and Darwin fixes
	(dist): add new macosx files.

	* macosx/tkMacOSXEvent.c (TkMacOSXProcessEvent):
	* macosx/tkMacOSXEvent.h:
	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent):
	* macosx/tkMacOSXCarbonEvents.c: install standard application event
	handler, add & call functions to start and stop carbon even timer that
	runs the tcl event loop periodically during a nested carbon event loop
	in the toolbox (e.g. during menutracking) to ensure tcl timers etc.
	continue to fire, register app event handler for menu tracking and HI
	command carbon events, move menu event handling to new handlers for
	those carbon events, no longer register for/handle appleevent carbon
	event (now dealt with by standard application event handler), event
	debugging code dynamically acquires carbon event debugging functions to
	allow use on Tiger where they are no longer exported from HIToolbox.

	* macosx/tkMacOSXFont.c (TkMacOSXUseAntialiasedText):
	* macosx/tkMacOSXKeyEvent.c (GetKeyboardLayout):
	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents):
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXInt.h: abstract common code to dynamically acquire
	address of a named symbol (from a loaded dynamic library) into new
	function TkMacOSXGetNamedSymbol() and macro TkMacOSXInitNamedSymbol.

	* macosx/tkMacOSXMenu.c (TkpNewMenu):
	* macosx/tkMacOSXMenubutton.c (MenuButtonInitControl):
	* macosx/tkMacOSXMenus.c (TkMacOSXHandleMenuSelect): switch to modern
	utf-8 aware menu manager API, remove obsolete code, add error handling.

	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenus.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c: define OSX 10.3 or later only constants
	if necessary to allow compilation on OSX 10.2

	* macosx/tkMacOSXWm.c (UpdateSizeHints): remove code that is never
	executed.

	* xlib/xgc.c (XCreateGC): sync with core-8-4-branch change.

	* generic/tk.h: add/correct location of version numbers in macosx files

	* generic/tkInt.h: clarify fat compile comment.

	* macosx/Wish.pbproj/default.pbxuser (new):
	* macosx/Wish.pbproj/jingham.pbxuser:
	* macosx/Wish.pbproj/project.pbxproj:
	* macosx/Wish.xcode/default.pbxuser:
	* macosx/Wish.xcode/project.pbxproj:
	* macosx/Wish.xcodeproj/default.pbxuser (new):
	* macosx/Wish.xcodeproj/project.pbxproj (new): new/updated projects for
	Xcode 2.2 on 10.4, Xcode 1.5 on 10.3 & ProjectBuilder on 10.2, with
	native tktest targets and support for universal (fat) compiles.

	* macosx/Tk-Info.plist (removed):
	* macosx/Wish-Info.plist (removed):
	* macosx/buildTkConfig.tcl (removed): remove obsolete build files.

	* macosx/README: clarification/cleanup, document new Xcode projects and
	universal (fat) builds via CFLAGS (i.e. ppc and i386 at the same time).

	* unix/Makefile.in:
	* unix/aclocal.m4:
	* unix/configure.in:
	* macosx/configure.ac (new): add support for inclusion of
	unix/configure.in by macosx/configure.ac, allows generation of a
	config headers enabled configure script in macosx (required by Xcode
	projects).

	* macosx/GNUmakefile: rename from Makefile to avoid overwriting by
	configure run in tk/macosx, add support for reusing configure cache,
	build target fixes.

	* generic/tk3d.h:
	* generic/tkButton.h:
	* generic/tkCanvas.c:
	* generic/tkCanvas.h:
	* generic/tkColor.h:
	* generic/tkEntry.h:
	* generic/tkFileFilter.h:
	* generic/tkFont.c:
	* generic/tkFont.h:
	* generic/tkImage.c:
	* generic/tkImgPhoto.c:
	* generic/tkInt.h:
	* generic/tkMenu.c:
	* generic/tkMenu.h:
	* generic/tkMenubutton.h:
	* generic/tkScale.h:
	* generic/tkScrollbar.h:
	* generic/tkSelect.h:
	* generic/tkStubInit.c:
	* generic/tkStubLib.c:
	* generic/tkText.h:
	* generic/tkUndo.h:
	* macosx/tkMacOSXButton.c:
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXDraw.c:
	* macosx/tkMacOSXEntry.c:
	* macosx/tkMacOSXFont.c:
	* macosx/tkMacOSXInt.h:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXSend.c:
	* macosx/tkMacOSXSubwindows.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:
	* macosx/tkMacOSXXStubs.c:
	* unix/tkUnixButton.c:
	* unix/tkUnixMenu.c:
	* xlib/xgc.c: ensure externally visible symbols not contained in stubs
	table are declared as MODULE_SCOPE (or as static if not used outside of
	own source file), #ifdef out a few Xlib and aqua functions that are
	never called. These changes allow 'make checkstubs' to complete without
	error on Darwin with gcc 4.

	* macosx/tkMacOSXTest.c:
	* macosx/tkMacOSXPort.h:
	* win/tkWinTest.c:
	* generic/tkInt.decls: add functions needed by tktest to internal stubs
	table, correct signature of TkMacOSXHandleMenuSelect, add XSync to aqua
	Xlib stubs.

	* unix/tkUnixSend.c:
	* generic/tkText.c:
	* generic/tkTest.c: #ifdef unix only declarations.
	(TestmetricsCmd): unify win and mac implementation.
	(TestsendCmd): move to tkUnixSend.c to avoid access to global var.
	(TesttextCmd): move to tkText.c to avoid having to put all the internal
	text functions it uses into the stubs table.

	* generic/tkTextDisp.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXXStubs.c: fix gcc 4 warnings.

	* macosx/tkMacOSXNotify.c:
	* macosx/tkMacOSXScrlbr.c: sync with core-8-4-branch.

	* generic/tkIntDecls.h:
	* generic/tkIntPlatDecls.h:
	* generic/tkIntXlibDecls.h:
	* generic/tkStubInit.c:
	* unix/configure:
	* unix/tkConfig.h.in: regen.

2005-11-22  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* library/tkfbox.tcl: Remove all references to data(curItem), as it is
	no longer used. [Bug 600313]
	(::tk::IconList_CurSelection): Renamed for clarity.

	* doc/GetFont.3: Revert previous fix; a NULL interp is now legal.
	* generic/tkFont.c (ParseFontNameObj, GetAttributeInfoObj): Allow these
	functions to work with a NULL interp by making them check when
	generating error messages. [Bug 1151523]

	* library/tkfbox.tcl (::tk::dialog::file::): Correct the quoting of the
	script used in variable traces so that widget names with spaces in will
	work. [Bug 1335485]

2005-11-16  Vince Darley  <vincentdarley@users.sourceforge.net>

	* doc/text.n: clarify left to right interpretation of index modifiers,
	including the fact that validation occurs after each step. [Bug
	1357575]

2005-11-15  Joe English  <jenglish@users.sourceforge.net>

	* unix/tkUnixWm.c, tests/unixWm.test, doc/wm.n: Support for [wm
	attributes] on X11. [TIP#231, Patch 1062022]

2005-11-14  Joe English  <jenglish@users.sourceforge.net>

	* library/bgerror.tcl: Truncate error messages at 45 characters
	instead of 30. [Bug 1224235]

2005-11-14  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkSelect.c (TkSelDefaultSelection): Test select-9.5
	highlighted further brokenness in this function.

2005-11-13  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* unix/tkUnixSelect.c (SelCvtToX): Arrange for the parsing code to use
	Tcl's list parsing code, another simplification that enables testing
	of the [Bug 1353414] fix.

	* unix/tkUnixSelect.c (SelCvtFromX): Generate string forms of the
	advanced selection types in a Tcl_DString. This makes fixing [Bug
	1353414] trivial, and simplifies the code at the same time.
	* tests/select.test (select-9.5): Added test for [Bug 1353414]

2005-11-10  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkBind.c (ChangeScreen):		More DString fixes from
	* generic/tkTextWind.c (EmbWinLayoutProc):	[Bug 1353022]
	* win/tkWinMenu.c (SetDefaults):

	* win/tkWinDialog.c (ConvertExternalFilename): Factored out the
	encoding conversion and de-backslash-ing code that is used in many
	places in this file.
	(GetFileNameW, GetFileNameA, ChooseDirectoryValidateProc): Make sure
	that data is freed correctly and that certain (hopefully impossible)
	failure modes won't cause crashes. [Bug 1353022]

2005-11-06  Pat Thoyts  <pat@zsplat.freeserve.co.uk>

	* unix/tcl.m4:    Fix SHLIB_LD_LIBS for building tclkit on OpenBSD.
	* unix/configure: regenerated

2005-10-31  Vince Darley  <vincentdarley@users.sourceforge.net>

	* generic/tkText.c
	* tests/textDisp.test: fix and test for [Bug 1333951] in '.text count
	-displaylines'.

2005-10-18  Don Porter	<dgp@users.sourceforge.net>

	* generic/tkMain.c: Rewrote code that sets the ::argv value to be sure
	conversion from the system encoding is complete before any processing
	sensitive to list-special characters is done. [Bug 1328926]

2005-10-17  Jeff Hobbs  <jeffh@ActiveState.com>

	* macosx/tkMacOSXScrlbr.c (UpdateControlValues): check geomMgrPtr is
	valid before checking type

2005-10-15  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/menu.tcl (::tk::MenuUnpost): remove leftover ] from string
	equal mods of 2005-07-25. (sowadsky)

2005-10-14  Pat Thoyts  <patthoyts@users.sourceforge.net>

	* win/tkWinSend.c:    Avoid using tcl internal headers and fix to
	* win/tkWinSendCom.h: correctly link on all types of build (was
	* win/tkWinSendCom.c: broken in static,msvcrt builds).

2005-10-12  Donal K. Fellows  <donal.k.fellows@man.ac.uk>

	* tests/canvPs.test, tests/canvPsBmap.tcl, tests/canvPsImg.tcl:
	* tests/imgPhoto.test, tests/menu.test: Arrange for the test suite to
	only ever refer to images in the same directory as the tests. This
	makes it possible to package the test suite itself as a starkit. Thanks
	to David Zolli for suggesting this.

2005-10-10  Jeff Hobbs  <jeffh@ActiveState.com>

	* generic/tkConfig.c (Tk_DeleteOptionTable, Tk_CreateOptionTable):
	properly alloc/delete one more option. [Bug 1319720] (melbardis)

	* macosx/tkMacOSXInt.h: Move MODULE_SCOPE defn to tkInt.h and add
	* generic/tkInt.h:      WORDS_BIGENDIAN checks that will work with OS X
	universal binary compiles. (steffen)

	* generic/tkMenu.c (TkSetWindowMenuBar): do not call TkMenuInit if the
	winPtr indicates TK_ALREADY_DEAD. This prevents reinit that creates a
	Tk exit handler after all exit handlers should be called. [Bug 749908,
	1322294]

2005-10-10  Vince Darley  <vincentdarley@users.sourceforge.net>

	TIP #256 IMPLEMENTATION

	* doc/text.n
	* generic/tkText.c
	* generic/tkText.h
	* generic/tkTextBTree.c
	* generic/tkTextDisp.c
	* generic/tkTextImage.c
	* generic/tkTextIndex.c
	* generic/tkTextMark.c
	* generic/tkTextTag.c
	* generic/tkTextWind.c
	* macosx/tkMacOSXDefault.h
	* tests/text.test
	* tests/textDisp.test
	* unix/tkUnixDefault.h
	* win/tkWinDefault.h: Implementation of TIP#256, adding a new text
	widget configuration option '-tabstyle', with new tests and
	documentation.

	Also a fix for [Bug 1281228] (documentation and full implementation of
	-strictlimits), and [Bug 1288677] (corrected elide behaviour), again
	with more tests.

2005-10-04  Jeff Hobbs  <jeffh@ActiveState.com>

	* library/dialog.tcl (::tk_dialog): add tkwait visibility before grab.
	[Bug 1216775]

	* win/tkWinDialog.c (ChooseDirectoryValidateProc): reset stored path to
	"" if it doesn't exist and -mustexist is true. [Bug 1309218] Remove
	old-style dir chooser (no longer used).

	* macosx/tkMacOSXInt.h: add MODULE_SCOPE definition check for extension
	writers that access private headers on OS X and don't define it in
	configure.

2005-09-28  Don Porter	<dgp@users.sourceforge.net>

	* unix/tkUnixPort.h:	Disabled inclusion of the private Tcl header
	* win/tkWinPort.h:	file tclInt.h. Tk ought to have a tiny and
	shrinking number of calls of private Tcl routines. Each Tk source file
	doing this should follow the convention in the macosx port and have its
	own #include "tclInt.h".

	* generic/tkEvent.c:	Disabled calls to private Tcl routine
	TclInExit(). See comment in TkCreateExitHandler() for full rationale.

2005-09-21  Donal K. Fellows  <donal.k.fellows@manchester.ac.uk>

	* generic/tkEvent.c (TkCreateThreadExitHandler, TkFinalizeThread)
	(TkDeleteThreadExitHandler): New internal API (from Joe Mistachkin) to
	allow Tk to finalize itself correctly in a multi-threaded
	environment. [Bug 749908]

2005-09-14  Donal K. Fellows  <dkf@users.sf.net>

	* generic/tkOldConfig.c (GetCachedSpecs): Split out the code to
	manipulate the cached writable specs so that it can be reused from all
	the public Tk_Configure* functions.
	(Tk_ConfigureInfo, Tk_ConfigureWidget, Tk_ConfigureValue): Use the
	factored out code everywhere, so we always manipulate the cache
	correctly. [Bug 1288128]

2005-09-13  Don Porter	<dgp@users.sourceforge.net>

	* win/winMain.c (WishPanic): Replaced TCL_VARARGS* macros with direct
	use of stdarg.h conventions.

2005-09-11  Daniel Steffen  <das@users.sourceforge.net>

	* macosx/tkMacOSXMouseEvent.c (TkMacOSXProcessMouseEvent): check if
	process is in front on MouseDown, otherwise request process activation
	from BringWindowForward() via new isFrontProcess param.

	* macosx/tkMacOSXCarbonEvents.c (TkMacOSXInitCarbonEvents): register
	our event handler on the dispatcher target for all carbon events of
	interest to TkAqua; this replaces event processing directly from the
	event queue and thus allows to capture events that are syntesized by
	Carbon and sent directly to the dispatcher and not to the event queue.

	* macosx/tkMacOSXEvent.c: remove TkMacOSXCountAndProcessMacEvents(),
	rename ReceiveAndProcessEvent() to TkMacOSXReceiveAndProcessEvent().
	(TkMacOSXReceiveAndProcessEvent): remove tk event processing before
	sending events to the dispatcher, all events of interest are now
	processed in our dispatcher target event handler.

	* macosx/tkMacOSXNotify.c (CarbonEventsCheckProc): dispatch events
	directly via TkMacOSXReceiveAndProcessEvent(), but dispatch no more
	than four carbon events at one time to avoid starving other event
	sources.

	* macosx/tkMacOSXEvent.c: formatting cleanup, move XSync() to XStubs,
	* macosx/tkMacOSXEvent.h: removed obsolete kEventClassWish handling.
	* macosx/tkMacOSXXStubs.c

	* macosx/tkMacOSXEvent.h: declare macosx internal procs as MODULE_SCOPE
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMouseEvent.c:
	* macosx/tkMacOSXWindowEvent.c:

	* macosx/tkMacOSXButton.c: conditionalize all debug message printing to
	* macosx/tkMacOSXCursor.c: stderr via TK_MAC_DEBUG define.
	* macosx/tkMacOSXDebug.c:
	* macosx/tkMacOSXDebug.h:
	* macosx/tkMacOSXDialog.c:
	* macosx/tkMacOSXEvent.c:
	* macosx/tkMacOSXInit.c:
	* macosx/tkMacOSXKeyEvent.c:
	* macosx/tkMacOSXMenu.c:
	* macosx/tkMacOSXMenubutton.c:
	* macosx/tkMacOSXScale.c:
	* macosx/tkMacOSXWindowEvent.c:
	* macosx/tkMacOSXWm.c:

	* unix/configure.in: define TK_MAC_DEBUG on aqua when symbols enabled.
	* unix/configure: autoconf-2.59
	* unix/tkConfig.h.in: autoheader-2.59

	* library/listbox.tcl: synced aqua MouseWheel bindings with
	* library/scrlbar.tcl: core-8-4-branch.
	* library/text.tcl:

	* xlib/xcolors.c: fixed warning

2005-08-25  Daniel Steffen  <das@users.sourceforge.net>

